//=============================================================================
// Nelsona:
// ExPlasmaSphere. Ripped and modified for some high rated A.I. but a bit retarded.
// These projectiles maybe are proving the AIRating showing something more true.
// Have fun, ladies !
//=============================================================================
class ExPlasmaSphere expands Projectile;

/*
#exec OBJ LOAD FILE=textures\PlasmaExplo.utx PACKAGE=Botpack.PlasmaExplo
 
#exec AUDIO IMPORT FILE="..\unrealshare\Sounds\Dispersion\DFly1.WAV" NAME="PulseFly" GROUP="PulseGun"
#exec AUDIO IMPORT FILE="Sounds\Pulsegun\PulseExp.WAV" NAME="PulseExp" GROUP="PulseGun"
*/

var bool bExploded, bExplosionEffect, bHitPawn;
var() texture ExpType;
var() Sound EffectSound1;
var() texture SpriteAnim[20];
var() int NumFrames;
var Float AnimTime;

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();
	SetTimer(0.8, true);
	if ( Level.NetMode == NM_Client )
		LifeSpan = 9.0;
	else
		Velocity = Speed * vector(Rotation);
	if ( Level.bDropDetail )
		LightType = LT_None;
}

simulated function Timer()
{
	if ( Level.bDropDetail )
		LightType = LT_None;
	if ( (Physics == PHYS_None) && (LifeSpan > 0.8) )
		LifeSpan = 0.8;
}

simulated function TakeDamage( int NDamage, Pawn instigatedBy, Vector hitlocation, 
					Vector momentum, name damageType)
{
	bExploded = True;
}

function BlowUp(vector HitLocation)
{
	PlaySound(EffectSound1,,7.0);
}

simulated function Explode(vector HitLocation, vector HitNormal)
{
	if ( !bExplosionEffect )
	{
//		if ( Role == ROLE_Authority ) //Mooo
		if ( Level.NetMode != NM_DedicatedServer )
			BlowUp(HitLocation);
		bExplosionEffect = true;
		if ( !Level.bHighDetailMode || bHitPawn || Level.bDropDetail )
		{
			if ( bExploded )
			{
				Destroy();
				GoTo JL90;
			}
			else
				DrawScale = 0.45;
		}
		else
			DrawScale = 0.65;

	    LightType = LT_Steady;
		LightRadius = 5;
		SetCollision(false,false,false);
		LifeSpan = 0.5;
		Texture = ExpType;
		DrawType = DT_SpriteAnimOnce;
		Style = STY_Translucent;
		if ( Region.Zone.bMoveProjectiles && (Region.Zone.ZoneVelocity != vect(0,0,0)) )
		{
			bBounce = true;
			Velocity = Region.Zone.ZoneVelocity;
		}
		else
			SetPhysics(PHYS_None);
	}
JL90:
}

simulated function ProcessTouch (Actor Other, vector HitLocation)
{
	if ( Other != Instigator )
	{
		if ( Other.bIsPawn )
		{
			bHitPawn = true;
			bExploded = !Level.bHighDetailMode || Level.bDropDetail;
		}
		if ( Role == ROLE_Authority )
			Other.TakeDamage( Damage, instigator, HitLocation, MomentumTransfer*Vector(Rotation), MyDamageType);	
		Explode(HitLocation, vect(0,0,1));
	}
}

auto State Flying
{
Begin:
	LifeSpan = 9.000000;
}

defaultproperties
{
     ExpType=Texture'Botpack.PlasmaExplo.pblst_a00'
     EffectSound1=Sound'Botpack.PulseGun.PulseExp'
     NumFrames=11
     speed=1450.000000
     Damage=40.000000
     MomentumTransfer=10000
     MyDamageType=Pulsed
     ExploWallOut=10.000000
     ExplosionDecal=Class'Botpack.BoltScorch'
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=9.000000
     DrawType=DT_Sprite
     Style=STY_Translucent
     Texture=Texture'Botpack.PlasmaExplo.pblst_a00'
     DrawScale=0.390000
     AmbientGlow=187
     bUnlit=True
     SoundRadius=10
     SoundVolume=218
     LightType=LT_Steady
     LightEffect=LE_NonIncidence
     LightBrightness=255
     LightHue=93
     LightRadius=5
     bFixedRotationDir=True
}
