class MHBiodrop expands Biodrop;

simulated function SetWall(vector HitNormal, Actor Wall)
{
	local vector TraceNorm, TraceLoc, Extent;
	local actor HitActor;
	local rotator RandRot;
	local BioMark bm;

	SurfaceNormal = HitNormal;
	RandRot = rotator(HitNormal);
	RandRot.Roll += 32768;
	SetRotation(RandRot);
	if ( Mover(Wall) != None )
		SetBase(Wall);
	if ( Level.NetMode != NM_DedicatedServer )
	{
		class'Biomark'.Default.DrawScale = DrawScale * 0.65;
		spawn(class'BioMark',,,Location, rotator(SurfaceNormal));
		class'Biomark'.Default.DrawScale = 0.65;
	}
}

auto state Flying
{
	simulated function HitWall( vector HitNormal, actor Wall )
	{
//		SetRotation(rotator(HitNormal));
		Super.HitWall(HitNormal, Wall);
	}

	simulated function BeginState()
	{
		Velocity = vect(0,0,0);
		LoopAnim('Flying',0.4);
	}
}

state OnSurface
{
	simulated function CheckSurface()
	{
		local float DotProduct;

		DotProduct = SurfaceNormal dot vect(0,0,-1);
		if (DotProduct > -0.5)
		{
			PlayAnim('Slide',0.2);
		}
	}

Begin:
	FinishAnim();
	CheckSurface();
}

defaultproperties
{
     speed=0.000000
     MaxSpeed=900.000000
     Damage=60.000000
     ImpactSound=None
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=140.000000
     CollisionRadius=3.000000
     CollisionHeight=3.000000
     bProjTarget=False
     LightRadius=2
     Buoyancy=0.000000
}

defaultproperties
{
}
