class MHMasterChunk expands MasterChunk;

simulated function PostBeginPlay()
{
	Velocity = Vector(Rotation) * (Speed + (FRand() * 200 - 100));
	if (Region.zone.bWaterZone)
		SetPhysics(PHYS_Falling);
}

simulated function HitWall( vector HitNormal, actor Wall )
{
	local float Rand;
	local WallCrack s;

	if ( bDeleteMe ) GoTo JL63;
	if ( (Mover(Wall) != None) && Mover(Wall).bDamageTriggered )
	{
		if ( Level.NetMode != NM_Client ) //he he
			Wall.TakeDamage( Damage, instigator, Location, MomentumTransfer * Normal(Velocity), '');
		Destroy();
		GoTo JL63;
	}
	if (!bDelayTime) 
	{
		bDelayTime=True;
		SetPhysics(PHYS_Falling);
		if ( (Level.Netmode != NM_DedicatedServer) ) 
		{
			s = Spawn(Class'WallCrack',,,Location+HitNormal*5,rotator(HitNormal));
			if (s != None)
				s.RemoteRole = ROLE_None;
		}
	}
	Velocity = 0.8*(( Velocity dot HitNormal ) * HitNormal * (-1.8 + FRand()*0.8) + Velocity);   // Reflect off Wall w/damping
	SetRotation(rotator(Velocity));
	speed = VSize(Velocity);
	if ( speed > 100 ) 
	{
		if ( ROLE == ROLE_Authority )
			MakeNoise(0.3);
		Rand = FRand();
		if (Rand < 0.33)
		{
			if( Level.Netmode != NM_DedicatedServer )
				PlaySound(sound 'Hit1', SLOT_Misc,0.6,,1000);
		}
		else if (Rand < 0.66)
		{
			if( Level.Netmode != NM_DedicatedServer )
				PlaySound(sound 'Hit3', SLOT_Misc,0.6,,1000);
		}
		else
		{
			if( Level.Netmode != NM_DedicatedServer )
				PlaySound(sound 'Hit5', SLOT_Misc,0.6,,1000);
		}
	}
	else 
	{
		bBounce = False;
		SetTimer(1.0,False);
	}
JL63:
}

simulated function ProcessTouch (Actor Other, vector HitLocation)
{
	if ( bDeleteMe ) GoTo JL85;
	if ( (Chunk(Other) == None) && (bDelayTime || (Other != Instigator)) )
	{
		speed = VSize(Velocity);
		if ( speed > 200 )
		{
			if ( Role == ROLE_Authority )
				Other.TakeDamage(damage, instigator,HitLocation,
					(MomentumTransfer * Velocity/speed), 'shredded' );
			if ( FRand() < 0.5 )
			{
				if( Level.Netmode != NM_DedicatedServer )
					PlaySound(Sound 'ChunkHit',, 2.0,,1000);
			}
		}
		Destroy();
	}
JL85:
}

defaultproperties
{
}
