class MonsterBasePlus expands Mutator
	config(MH_A_V2);

#exec AUDIO IMPORT FILE="Sounds\HitSoundEnemy.wav" NAME="HitsoundEnemy"
#exec AUDIO IMPORT FILE="Sounds\HitSoundTeam.wav" NAME="HitsoundTeam"
#exec obj load file=..\Music\null48.umx

//vars used by mutator when working
var DeathMatchPlus MyGame;
var MonsterHunt2 MH2;

var (AI) name Tz;
var Actor Muz;
var float StartWorkingTime, TimeTaken;
var class<Weapon> TranslocatorClass;
var class<Actor> XC_Class, XC_DecoClass;
var Pawn NP, OLDNP; //Used by PreventDeath for monster target hijack - is a shit timer which no one is fixing
var int Ways, LevelMonster, MySkill, Patrols, DiffScale, lolattacktime, XC_GE;
var bool bMHLog, bFoundLeader, bPatrols, bReplaceThem, bSuccessReplace, bHaveXC, bAIHandled, bPowerXC, bScaleRegen;
//config vars
//1 - Integers
var config int HUD_Number, FItems, MinMonsterHealth, MaxMonsterHealth,
HealthRegenPerKill, NumCapacity, MaxHealth, DefaultHealth,
MaxAmmoMultiplier, AmmoRespawnTime, AllowedOpen;
//2 - Floaters
var config float md, HitVolume, MonsterMultiplier;
//3 - Booleans
var config bool /*bUseEScoreBoard,*/ bNastyCorpse, bNoTest, bOtherPlayer, bDecoChange, bUTReplace, bOldWepReplace,
bRemoveBlocking, bUseCoopTranslocator, bUseCrapSpree, bReplaceMonsters, bDoSpawnSpamFix,
bNoTranslator, bNoRiskCannon, bUseAntiboost, bUseWarnTeamDamage, bUseAltScoring, bHitsounds, stopPlayerCollision,
bTweakGroup, bFixGrabCmd, bDoPawnOpen, bDoCrushMover;

simulated event PreBeginPlay()
{
	local Actor A;

	if ( bDoSpawnSpamFix )
		DoSpawnfix();
	DoTheDirt(); //This is only for my fun - Client will be normal, but my server won't host craps
	ConsoleCommand("SET MONSTERHUNT.MONSTERBASE BSTATIC 0");
	ConsoleCommand("SET MONSTERHUNT.MONSTERBASE BNODELETE 0");
	ConsoleCommand("SET DECAL BNODELETE 0");
	ConsoleCommand("SET DECAL BSTATIC 0");
	foreach AllActors(class 'Actor', A)
	{
		if ( MonsterBase(A) != None )
		{
			log("Found"@A.Name$"... Removing!");
			A.Destroy();
		}
		if ( MonsterShadow(A) != None && A.Owner == None )
		{
			log("Found"@A.Name$"... Removing!");
			A.Destroy();
		}
	}
}

simulated function DoTheDirt()
{
	local Actor A;
	local String CC;

	foreach AllActors (class 'Actor',A )
	{
		if ( Carcass(A) != None )
		{
			if ( ( Carcass(A).bStatic || Carcass(A).bNoDelete ) && Carcass(A).bCollideActors )
			{
				CC = Caps(Carcass(A).class);
				CC = "set"@CC@"bStatic 0";
	//			log ("Command is"@CC);
				ConsoleCommand(CC);
				CC="";
				CC = Caps(Carcass(A).class);
				CC = "set"@CC@"bNoDelete 0";
	//			log ("Command is"@CC);
				ConsoleCommand(CC);
	//			log ("Found "$Carcass(A)$" now with bStatic="$Carcass(A).bStatic);
	//			log ("Also "$Carcass(A)$" with bNoDelete="$Carcass(A).bNoDelete);
				CC="";
				Carcass(A).Destroy();
			}
		}
		if ( Inventory(A) != None )
		{
			if (Inventory(A).bStatic || Inventory(A).bNoDelete )
			{
				Inventory(A).bRotatingPickup=False;
			}
		}
	}
}

simulated function DoSpawnfix()
{
	local SpawnPoint So, Sn;
	local ThingFactory Tf;
	local int i;

//	ConsoleCommand("SET UNREALSHARE.SPAWNPOINT BSTATIC 0");
//	ConsoleCommand("SET UNREALSHARE.SPAWNPOINT BNODELETE 0");
//	class'SpawnPoint'.Default.bStatic = False;
//	class'SpawnPoint'.Default.bNoDelete = False;
	class'SpawnPoint'.Default.bGameRelevant = True;
	ForEach AllActors ( class 'SpawnPoint', So )
	{
		if ( So.class == class 'UnrealShare.SpawnPoint' )
		{
			Sn = Spawn(class 'MH_A_V2.SpawnPoint',,,So.Location+vect(0,0,1),So.Rotation);
			if ( Sn != None )
			{
//				Log (Sn$" spawned for "$So);
				if (So.Tag != '') Sn.SetPropertyText("Tag",So.GetPropertyText("Tag"));
				if (So.Event != '') Sn.SetPropertyText("Event",So.GetPropertyText("Event"));
				Sn.SetPropertyText("factory",So.GetPropertyText("factory"));
				So.Tag = '';
				So.SetPropertyText("Tag",("None"));
//				log (Sn$" new tag is "$Sn.Tag);
//				log ( So.Tag$" is the Tag from "$So);
			}
		}
	}
	ConsoleCommand ("SET PLAYERSTART TEAMNUMBER 0");
}

event PostBeginPlay()
{
	local Actor A;
	local Pawn P, PlayerPawn;
	local ScriptedPawn S;
	local ThingFactory Thfa;
	local CreatureFactory CF;
	local BlockMonsters Bmo;
	local PatrolPoint PPo;
	local CTFFlag Flag;
	local MonsterEnd ME;
	local AdvancedMonsterEnd ME1;
	local MonsterEnd2 ex;
	local ExMonsterEnd ex1;
	local DistanceViewTrigger Dwt;
	local MHDistanceViewTrigger Mdt;
	local Weapon Wp;
//	local float F[2], Time;
	local string bSetEnemy;
	local VisibleTeleporter Vt;

//	class'XC_CoreStatics'.static.Clock( F);
	if (MonsterHunt2(Level.Game) != None)
	{
		MH2 = MonsterHunt2(Level.Game);
		bMHLog = MH2.bMHLog;
		if ( bMHLog )
			log ("BaseMutator started Initialization at "$GetAbsoluteTime());
	}
	else
	{
		log ("*** MH2 got screwed!!! ***");
		ConsoleCommand("exit");
	}
	log ("Looking for XC_Engine... ",'MonsterBasePlus');
	XC_GE = int(ConsoleCommand("GET INI:ENGINE.ENGINE.GAMEENGINE XC_VERSION"));
	if (XC_GE >= 8)
	{
		log ("Detected running XC_Engine V"$XC_GE);
		bAIHandled=bool(ConsoleCommand("GET INI:ENGINE.ENGINE.GAMEENGINE bUseSetEnemyHook"));
		if (bAIHandled)
			log ("XC_Engine will manage Monster's SetEnemy.");
		else
			log ("XC_Engine won't manage natively Monster's SetEnemy.");
		if ( XC_GE >= 19 )
		{
			bPowerXC = True;
			bAIHandled = True;
			log ("New iterators are available...");
		}
		if ( XC_GE < 16 )
		{
			if ( Level.NetMode != NM_StandAlone )
				log ("XC_Engine is older, Old Weapons Handler will be used.");
		}
		else
		{
/*
			log (" Extended XC checking..." );
			XC_Class=class<Actor>( DynamicLoadObject( "XC_Engine.XC_PrimitiveMesh", class'Class' ) );
			bExtendedXC = ( XC_Class != None );
			if (bExtendedXC)
				log("XC Engine uses PrimitiveActor addon...");
			else
				log ("XC Engine doesn't include PrimitiveActor classes...");
*/
			if ( Level.NetMode != NM_StandAlone )
				log ("XC_Engine will manage Old Weapons, Handler won't be used.");
			bHaveXC = True;
		}
	}
	else
	{
		log("Result: XC_Engine not found.");
		if ( Level.NetMode != NM_StandAlone )
			log("Old Weapons Handler will be used.");
	}
	if (NumCapacity < 256)
	{
		NumCapacity = 260;
		if (bMHLog)
			log ("Adjusted configuration - you risk to mess up an Engine.Counter, Dick Head");
	}
	if (NumCapacity > 1000)
	{
		NumCapacity = 1000;
		if ( bMHLog )
			log ("LOL - your high value has been modified. Why are you using this mutator if you want spam?");
	}
	if (FItems < 5)
	{
		if (bMHLog)
			log ("Value for MaxItems of a Factory is too low, check your INI, adjusted to 5");
		FItems = 5;
	}
	if (FItems > 25)
	{
		if (bMHLog)
			log ("Value for MaxItems of a Factory is close to spam, check your INI, adjusted to 24");
		FItems = 25;
	}
	if ( DeathMatchPlus(Level.Game)!= None )
		MyGame = DeathMatchPlus(Level.Game);

	ConsoleCommand("set CTFFlag bNoDelete False");
	ConsoleCommand("set CTFFlag bStatic False");

	if (bMHLog)
		log ("Scanning for any PatrolPoint...");
	if ( !bPowerXC )
	{
		foreach AllActors (class 'Patrolpoint', PPo)
		{
			bPatrols = True;
			Patrols++;
		}
	}
	else
	{
		foreach NavigationActors (class 'Patrolpoint', PPo)
		{
			bPatrols = True;
			Patrols++;
		}
	}
	if (bMHLog)
	{
		if ( bPatrols )
			log ("Information: We seems to have "@Patrols@" PatrolPoint(s).");
		else
			log ("Information: This map does not use any PatrolPoint.");
	}

	if ( !bPowerXC )
	{
		foreach AllActors(class 'Pawn', P)
		{
			if ( FlockPawn(P) != None )
				P.bGameRelevant = False;
			if ( FlockMasterPawn(P) != None )
				P.bGameRelevant = False;
			if ( ScriptedPawn(P) != None )
			{
				S = ScriptedPawn(P);
//				SetPawnDifficulty(S);
//				S.SetInitialState();
				if (S.bTeamLeader)
					S.bTeamLeader = False;
				S.TeamTag = '';
				if ( Tentacle(S)!= None )
					if ( S.Mesh != None )
						S.AnimSequence = 'Hide';
				if (S.DrawScale > 2)
					S.DrawScale = 2;
				if ( S.Orders == 'Roaming' || ( S.Orders == 'Patroling' && !bPatrols ) || S.Orders == 'Hunting' )
				{
					if (bMHLog)
						log (S$" having order "$S.Orders$" has been reset because has no logic here.");
					S.Orders = '';
				}
			}
		}
	}
	else
	{
		foreach PawnActors(class 'Pawn', P)
		{
			if ( FlockPawn(P) != None )
				P.bGameRelevant = False;
			if ( FlockMasterPawn(P) != None )
				P.bGameRelevant = False;
			if ( ScriptedPawn(P) != None )
			{
				S = ScriptedPawn(P);
//				SetPawnDifficulty(S);
//				S.SetInitialState();
				if (S.bTeamLeader)
					S.bTeamLeader = False;
				S.TeamTag = '';
				if ( Tentacle(S)!= None )
					if ( S.Mesh != None )
						S.AnimSequence = 'Hide';
				if (S.DrawScale > 2)
					S.DrawScale = 2;
				if ( S.Orders == 'Roaming' || ( S.Orders == 'Patroling' && !bPatrols ) || S.Orders == 'Hunting' )
				{
					if (bMHLog)
						log (S$" having order "$S.Orders$" has been reset because has no logic here.");
					S.Orders = '';
				}
			}
		}
	}

	foreach AllActors(class'Actor',A)
	{
// Fixing stupid teleporter useless spam
		if (VisibleTeleporter(A) != None)
		{
			if ((VisibleTeleporter(A).URL == "" || VisibleTeleporter(A).URL == "None") && VisibleTeleporter(A).bCollideActors)
			{
				VisibleTeleporter(A).SetCollision(False,False,False);
				VisibleTeleporter(A).Disable('Touch');
				if (bMHLog)
					log ("On Screen Invalid Teleporter Message Spam removed for Teleporter"@Vt);
			}
		}
// Attach our normal end here
		if ( MonsterEnd(A) != None )
		{
			if ( MonsterEnd(A).class == class 'MonsterHunt.MonsterEnd')
			{
				if (bMHLog)
				log ("Using New End2 prototype.");
				ex = Spawn(class 'MonsterEnd2',,,MonsterEnd(A).location + vect(-1,-1,0));
				if (ex != None)
				{
					if ( MonsterEnd(A).Base != None )
						ex.SetBase(MonsterEnd(A).Base);
					ex.InitialState = MonsterEnd(A).InitialState;
					if (MonsterEnd(A).Tag != '') ex.tag = MonsterEnd(A).Tag;
					if (MonsterEnd(A).Event != '') ex.event = MonsterEnd(A).Event;
					if (MonsterEnd(A).AttachTag != '') ex.AttachTag = MonsterEnd(A).AttachTag;
						ex.SetCollisionSize(MonsterEnd(A).CollisionRadius, MonsterEnd(A).CollisionHeight);
					if (MonsterEnd(A).bInitiallyActive) ex.bInitiallyActive = True;
						else ex.bInitiallyActive = False;
					if (MonsterEnd(A).bMovable) ex.bMovable = True;
						else ex.bMovable = False;
					if ( !MonsterEnd(A).bStatic && !MonsterEnd(A).bNoDelete )
					{
						MonsterEnd(A).SetCollisionSize(0,0);
						MonsterEnd(A).Disable('Touch');
						MonsterEnd(A).Tag = MonsterHunt2(Level.Game).TT;
						if (bMHLog)
							log (ex$" - new trigger for ending added successfully");
						MonsterEnd(A).LifeSpan = 2.000000;
					}
				}
				else
				{
					if (bMHLog)
					{
						log("WARNING!!! Things went bad as long as New End did not spawn... Please check the Map!");
					}
				}
			}
		}
//ThingFactory love
		if ( ThingFactory(A) != None )
		{
			if ( !bPowerXC )
				ThingFactory(A).bCovert = False; //:P No bullshit check
			if (bMHLog)
				log ("MH_A_V2 checking for bullshit spam... ->> ThingFactory - "@ThingFactory(A));
			if ( !bPowerXC )
			{
				if (ThingFactory(A).prototype == class 'SkaarjBerserker')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.EXSkaarjBerserker';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'Fly')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.NsFly';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'GiantGasbag')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.ExGiantGasbag';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'Gasbag')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.ExGasbag';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'MercenaryElite')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.ExMercenaryElite';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'Mercenary')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.ExMercenary';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'NaliPriest')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.ExNaliPriest';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'Nali')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.ExNali';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'Squid')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.ExSquid';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'DevilFish')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.ExDevilFish';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'LeglessKrall')
				{
					ThingFactory(A).prototype = Class'Krall';
					if (bMHLog)
					{
						log ("Heck !!! Legless bullshit is not allowed to spawn - idiotic mapping fixed at: "@ThingFactory(A));
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
					}
				}
				else
				if (ThingFactory(A).prototype == class 'BiterFishSchool')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.BiterFishSchool2';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'Bird1')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.Bird2';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'NaliRabbit')
				{
					ThingFactory(A).prototype = Class'MH_A_V2.NaliRabbit2';
					if (bMHLog)
						log (ThingFactory(A)$" has now prototype "$ThingFactory(A).prototype);
				}
				else
				if (ThingFactory(A).prototype == class 'Queen')
				{
					ThingFactory(A).MaxItems = 1;
					if (bMHLog)
						log (ThingFactory(A)$" has prototype "$ThingFactory(A).prototype$" spawning 1 piece per row...");
				}
			}
			if (ThingFactory(A).MaxItems > FItems && ThingFactory(A).capacity < NumCapacity + 1)
			{
				ThingFactory(A).MaxItems = FItems;
				if (bMHLog)
					log ("Excessive fabricating capacity adjusted - LOL for bad mapping - spam fixed successfully at >"@ThingFactory(A));
			}
			if (ThingFactory(A).capacity > NumCapacity || ThingFactory(A).capacity < 1)
			{
				ThingFactory(A).capacity = NumCapacity;
				if (bMHLog)
					log ("Detected abnormal value in fabricating - Only a freak mapper can think that he can spam our server at >"@ThingFactory(A));
				if ( ThingFactory(A).MaxItems > FItems ) 	//There are enough places ?
				{
					ThingFactory(A).MaxItems = FItems;		//If yes, let's cut off the crap spam.
					if (bMHLog)
						log ("Excessive fabricating in Thing Factory >"@ThingFactory(A)@"- spam fixed successfully.");
				}
				if ( ThingFactory(A).interval < 0.3 )
				{
					ThingFactory(A).interval = 0.3;
				}
				if ( ThingFactory(A).itemtag == ThingFactory(A).Tag )
				{
					if (bMHLog)
						log ("Detected retarded self triggering at: "$ThingFactory(A)$" attempting a fix.");
					ThingFactory(A).itemtag = MH2.TT;
				}
				if ( !ThingFactory(A).bOnlyPlayerTouched )
				{
					ThingFactory(A).bOnlyPlayerTouched = True;
					if (bMHLog)
						log ("Wild creature touch removed at"@ThingFactory(A));
				}

			}
			if ( bOldWepReplace )
			{
				switch(ThingFactory(A).prototype)
				{
					case class 'WeaponPowerUp':
						ThingFactory(A).Prototype = class'MH_A_V2.MHDispersionPowerUp';
						break;
					case class 'Dampener':
						ThingFactory(A).Prototype = class'MH_A_V2.MHDispersionPowerUp';
						break;
					case class 'ForceField':
						ThingFactory(A).Prototype = class'MH_A_V2.MHDispersionPowerUp';
						break;
					case class 'Invisibility':
						ThingFactory(A).Prototype = class'MH_A_V2.MHDispersionPowerUp';
						break;
				}
				if (Left((Caps(ThingFactory(A).prototype)),7)=="MH_A_V2")
					continue;
			}
			if ( bUTReplace )
			{
				if (ThingFactory(A).prototype == Class'Pulsegun')
					ThingFactory(A).prototype = Class'MH_A_V2.EPulseGun';
				else if (ThingFactory(A).prototype == Class'minigun2')
					ThingFactory(A).prototype = Class'MH_A_V2.Eminigun2';
				else if (ThingFactory(A).prototype == Class'UT_Eightball')
					ThingFactory(A).prototype = Class'MH_A_V2.EUT_Eightball';
				else if (ThingFactory(A).prototype == Class'SuperShockRifle')
					ThingFactory(A).prototype = Class'MH_A_V2.MHSuperShockRifle';
				else if (ThingFactory(A).prototype == Class'WarheadLauncher')
					ThingFactory(A).prototype = Class'MH_A_V2.NSWarheadLauncher';
				else if (Left((Caps(ThingFactory(A).prototype)),7)=="MH_A_V2")
					continue;
				else if (ClassIsChildOf(ThingFactory(A).prototype,class'Inventory'))
				{
					ThingFactory(A).MaxItems = 0;
					ThingFactory(A).capacity = 0;
					ThingFactory(A).InitialState='Finished';
					ThingFactory(A).GotoState('Finished');
					ThingFactory(A).Disable('Tick');
					ThingFactory(A).Disable('Touch');
					ThingFactory(A).Disable('UnTouch');
					ThingFactory(A).Disable('Trigger');
				}
//Probably enough ? If not next goes here...
			}
		}
// Other retarded setup crashing and/or sucking cocks
		if ( CreatureFactory(A) != None )
		{
			if ( CreatureFactory(A).Orders == 'Roaming' )
			{
				CreatureFactory(A).Orders = 'Attacking'; //La, la, la...
				if (bMHLog)
					log ("Illegal orders discovered and restored to defaults at"@CreatureFactory(A));
			}
			if ( CreatureFactory(A).Orders == 'Patroling' && !bPatrols )
			{
				CreatureFactory(A).Orders = 'Attacking';
				if (bMHLog)
					log ("Order patroling is invalid without a PatrolPoint at"@CreatureFactory(A)@"and has been modified.");
			}

			// End stupid fixes for CreatureFactories, do others before this line
		}
// BlockMonsters && BOTS ? No shit me...
		if (bRemoveBlocking)
		{
			if ( BlockMonsters(A) != None )
			{
				BlockMonsters(A).SetCollisionSize( 0, 1 );
				BlockMonsters(A).SetCollision( False, False, False );
				if (bMHLog)
					log ("Found blocker: "$BlockMonsters(A)$". Unlocked, have fun!");
			}
		}
// Porting a crap into a bigger one
		if ( CTFFlag(A) != None )
		{
			if (bMHLog)
				log("MH_A_V2: checking CTFFlags... Hit! >"@CTFFlag(A).name@"--> AutoFixed!( Sheduling removal )");
			CTFFlag(A).LifeSpan = 0.1;
		}

	} //Iterator for an Actor

	if ( !bPowerXC ) //solved by XCGE19+ so we don't use it if XCGE is advanced with new A.I.
	foreach AllActors(class 'DistanceViewTrigger',Dwt)
	{
		if ( Dwt != None )
		{
			Mdt = Spawn(class 'MHDistanceViewTrigger',,,Dwt.location + vect(-1,-1,0));
			if (Dwt.Tag != '') Mdt.tag = Dwt.Tag;
			if (Dwt.Event != '') Mdt.event = Dwt.Event;
			if (Dwt.AttachTag != '') Mdt.AttachTag = Dwt.AttachTag;
			Mdt.SetCollisionSize(Dwt.CollisionRadius, Dwt.CollisionHeight);
			if (Dwt.bMovable) Mdt.bMovable = True;
			else Mdt.bMovable = False;
			if (!Dwt.bStatic && !Dwt.bNoDelete)
			{
				Dwt.SetCollisionSize(1,1);
				Dwt.Tag = MonsterHunt2(Level.Game).TT;
				if (bMHLog)
					log (Mdt$" - new DistanceViewTrigger for MonsterHunt added successfully.");	//This line is for notice if map has end or not
				Dwt.Destroy();
			}
		}
	}

	if (bMHLog)
		log ("Values checked ... Proceed to next step...");

	Level.DefaultGameType = class 'MH_A_V2.MonsterHunt2';
	Level.game.registerdamagemutator(Self);
	Level.game.registermessagemutator(Self);
	SaveConfig();

	LevelMonster = MH2.SkillMonster;

	if(bMHLog)
		log ("Difficulty is set to:"@LevelMonster);
	Tz = MH2.TT;
	if(bMHLog)
		log ("Team word for monsters used is:"@Tz);
	if ( LevelMonster == 1)
		MySkill = 0;
	if (LevelMonster == 2 || LevelMonster == 3)
		MySkill = 1;
	if (LevelMonster == 4 || LevelMonster == 5)
		MySkill = 2;
	if (LevelMonster == 6 || LevelMonster == 7)
		MySkill = 3;

	if (MaxMonsterHealth < 2000)
	{
		if (bMHLog)
			log ("Maximum health of a monster is not allowed to be lower than 2000, :P, Switching to default limit.");
		MaxMonsterHealth = 10000;
	}
	if (MaxMonsterHealth > 500000)
	{
		if (bMHLog)
			log ("Maximum health of a monster is not allowed to be higher than 500000, :P, Switching to default limit.");
		MaxMonsterHealth = 50000;
	}
	if ( MinMonsterHealth > MaxMonsterHealth/2)
	{
		MinMonsterHealth=MaxMonsterHealth/2;
	}
	if (MonsterMultiplier > 5)
	{
		MonsterMultiplier = 5;
		if (bMHLog)
			log ("Multiplier for monster has been adjusted. Not allowed more than 5...");
	}
	if (MonsterMultiplier < 0)
	{
		MonsterMultiplier = 0;
	}
	//Forcing config check, no need troubles
	if (HUD_Number < 1)
		HUD_Number = 1;
	if (HUD_Number > 3)
		HUD_Number = 3;

	if( DefaultHealth < 1 )
		DefaultHealth = 100;

	if( AmmoRespawnTime < 0.6 )
		AmmoRespawnTime = 0.6;
	fixmovers();
	if (bMHLog)
		log ("Movers were checked, will proceed to next step...");
	if (!bOldWepReplace)
	{
		MH2.DefaultWeapon = class'UnrealShare.DispersionPistol';
	}
	setdiffscale();
	SetUpCurrent();
	bReplaceThem = True;
/*
	if ( bUseEScoreBoard )
	{
		MH2.ScoreboardType = class'UTES_DMSB';
		Level.Spawn(class'UTES_Mut');
	}
*/
	DoProjTweak();

	if (Level.Game.HUDType != None)
	{
		if (HUD_Number == 1)
			Level.Game.HUDType = class'UnrealHUD';
		if (HUD_Number == 2)
			Level.Game.HUDType = class'Monster2HUD';
		else if (HUD_Number == 3)
			Level.Game.HUDType = class'NSMonsterHUD';
	}
	if (bMHLog)
		log ("BaseMutator ended Initialization at "$GetAbsoluteTime());
	ShowConfig();
//	Time = class'XC_CoreStatics'.static.UnClock( F);
//	Log("Base Mutator initialization took: "$Time$" seconds.");
}

function DoProjTweak()
{
	class 'BigBioGel'.default.RemoteRole=ROLE_SimulatedProxy;
	class 'MiniShellCase'.default.RemoteRole=ROLE_DumbProxy; //Duh !?
	class 'GuidedWarshell'.default.RemoteRole=ROLE_SimulatedProxy;
}

function ShowConfig()
{
	log ("============ MH_A_V2 report configuration ============");
	log ("<<< MonsterHunt Main Controller >>>");
	log ("-------------------------------------------------------------");
	log ("Logging control -						bMHLog ="@MH2.bMHLog);
	log ("Usage only of Red Color -					bUseTeamSkin ="@MH2.bUseTeamSkin);
	log ("Changing Green Color Messages -				bNoGreen ="@MH2.bNoGreen);
	log ("Changing SpawnPoints feature -				bDoSpawnSpamFix ="@bDoSpawnSpamFix);
	if ( bDoSpawnSpamFix )
		log ("Levels using Custom bugs or Less bugs might be affected. Keep an eye on this...");
	log ("Changing Counters -						bFixCounters ="@MH2.bFixCounters);
	if (MH2.bFixCounters)
		log ("Levels using Custom Counting systems might look changed. Try to spy if won't break something...");
	log ("Value for using Lives System -				Live ="@MH2.Live);
	log ("Monster Power-Level -					SkillMonster ="@MH2.SkillMonster);
	log ("Minimum A.I. Node check -					Ncheck ="@MH2.Ncheck);
	log ("Penalty floater value for death -				Pen ="@MH2.Pen);
	log ("Team word changing monster attitude -			TT ="@MH2.TT);
	log ("Word above should be short. It's configurable to not match in future with anything from any Level.");
	log ("Changing it is very recommended. We try to prevent unexpected problems.");
	log ("-------------------------------------------------------------");
	log ("<<< MutatorClass configuration - MonsterBasePlus >>>");
	log ("	- Various primary mutator specific values >>>");
	log ("Using one of 3 HUDs -			HUD_Number ="@HUD_Number);
	log ("Number of Items at once for Factory -	FItems ="@FItems);
	log ("Monster Multiplier Factor -			MonsterMultiplier ="@MonsterMultiplier);
	if (MonsterMultiplier <= 1.000000)
		log("So Minimum Health for monsters is not used.");
	else
		log ("And we have configured Minimum Health -	MinMonsterHealth ="@MinMonsterHealth);
	log ("Maximum of Health allowed for Monster -	MaxMonsterHealth ="@MaxMonsterHealth);
	log ("Health added for killing monster -		HealthRegenPerKill ="@HealthRegenPerKill);
	log ("Limit for default Factory spam -		NumCapacity ="@NumCapacity);
	log ("Maximum of Health allowed for Hunter -	MaxHealth ="@MaxHealth);
	log ("Hunter start with health -			DefaultHealth ="@DefaultHealth);
	log ("Regenerator rescales ammo -			MaxAmmoMultiplier ="@MaxAmmoMultiplier);
	log ("Base Value for Respawning ammo interval -	AmmoRespawnTime ="@AmmoRespawnTime);
	log ("Damaging monster low hit volume -		HitVolume ="@HitVolume);
	if (!bHitSounds)
		log ("Must have bHitSounds=True for using this feature.");
	log ("	- Booleans True/False configurable values >>>");
//	log ("Activate Enhanced ScoreBoard using -		bUseEScoreBoard ="@bUseEScoreBoard);
	log ("Activate Corpse Monsters using -		bNastyCorpse ="@bNastyCorpse);
	log ("Deactivate test Bot-Support mode -		bNoTest ="@bNoTest);
	log ("Activate changing player type -		bOtherPlayer ="@bOtherPlayer);
	log ("Activate tweak for several decorations -	bDecoChange ="@bDecoChange);
	log ("Activate changing several UT weapons -	bUTReplace ="@bUTReplace);
	log ("Activate changing Old weapons -		bOldWepReplace ="@bOldWepReplace);
	log ("Activate K.O. at BlockMonsters -		bRemoveBlocking ="@bRemoveBlocking);
	log ("Activate usage of CoopTranslocator -		bUseCoopTranslocator ="@bUseCoopTranslocator);
	log ("Activate monster spree usage -		bUseCrapSpree ="@bUseCrapSpree);
	log ("Activate few monster types replacement -	bReplaceMonsters ="@bReplaceMonsters);
	log ("Disabling Translator -			bNoTranslator ="@bNoTranslator);
	if (!bNoTranslator)
		log ("I'm not sure if allowing Translator helps in Tournament Game-Types linked from BotPack.");
	log ("Disabling Cannon to Monster damage -		bNoRiskCannon ="@bNoRiskCannon);
	log ("Activate a version of Anti-Boost -		bUseAntiboost ="@bUseAntiboost);
	log ("Activate warn damage for FriendlyFire -	bUseWarnTeamDamage ="@bUseWarnTeamDamage);
	log ("Activate another scoring method -		bUseAltScoring ="@bUseAltScoring);
	log ("Activate 0 player vs player collision -	stopPlayerCollision ="@stopPlayerCollision);
	log ("	- Mover related tweak configuration types - Booleans, Floaters, Integers >>>");
	log ("Activate a Fake Group - is created group if doesn't exist -			bTweakGroup ="@bTweakGroup);
	if (bTweakGroup)
		log ("Tweak is trying to tune Closing-Group based errors when players are leaving and Mover has been opened, using isolation.");
	log ("Activate mover's access for all Pawns -					bDoPawnOpen ="@bDoPawnOpen);
	if (bDoPawnOpen)
		log ("Movers having mission purposes like bTriggerOnceOnly are excepted from wild touching.");
	log ("Activate removal of GRAB cheating command -					bFixGrabCmd ="@bFixGrabCmd);
	if (!bFixGrabCmd)
		log ("GRAB can open earlier and even unfair several Movers. Main cause is bad mapping, as usual.");
	log ("Activate crusher Movers against evil returns -				bDoCrushMover ="@bDoCrushMover);
	log ("Mover's StayOpenTime in SEC. until is declared bTriggerOnceOnly -		AllowedOpen ="@AllowedOpen);
	if (bMHLog)
	{
		log ("This value+tweak are trying to prevent 10 Doors opened with timer fired up which might stuck the rest of doors.");
		log ("If Mover stays open more than value configured above, it will be changed. The mostly problem occurs because timers have set with stupid insane values.");
	}
	log ("Current configuration is located in file > MH_A_V2.ini");
	log (" - Regenerators are located in class TimedBoy -");
	log ("Regenerate hunter's health/second value -		HealthRegenPerSec ="@class'TimedBoy'.default.HealthRegenPerSec);
	log ("Regenerate hunter's ammo/second value -		AmmoRegenPerSec ="@class'TimedBoy'.default.AmmoRegenPerSec);
	log ("BaseMutator will screw them if doesn't match with TimedBoy's values bellow...");
	log ("Regenerate hunter's health until value -		MaxRegenHealth ="@class'TimedBoy'.default.MaxRegenHealth);
	log ("Hunter Receiving health stops at -			MaxHealth ="@class'TimedBoy'.default.MaxHealth);
	log ("Monster's health is re-checked for Maximum -		MaxMonsterHealth ="@class'TimedBoy'.default.MaxMonsterHealth);
	log ("So called must-have goes down here the mostly if Boolean values are True");
	log ("Hunters are receiving an UDamage at time -		AmpTime ="@class'TimedBoy'.default.AmpTime);
	log ("Random Hunter receives Redeemer bonus at time -	kakuTime ="@class'TimedBoy'.default.kakuTime);
	log ("Random Hunter receives 500Health bonus at time -	HealthTime ="@class'TimedBoy'.default.HealthTime);
	log ("These time intervals are supposed in Seconds based on Level's timer.");
	log ("Activate Ammo Regenerator -				bUseRegenAmmo ="@class'TimedBoy'.default.bUseRegenAmmo);
	log ("Activate Health Regenerator for Hunters -		bUseRegenHealth ="@class'TimedBoy'.default.bUseRegenHealth);
	log ("Activate Regenerators Feature -			bScaleRegen ="@class'TimedBoy'.default.bScaleRegen);
	log ("In Win Servers v451 - any - we might see funky things. We want small tweaks for Hunter's Carcass down here...");
	log ("Activate Hunter Carcass corroding -			bCorrodeFaster ="@class'TimedBoy'.default.bCorrodeFaster);
	log ("---------------------------------------------------------------------------------------------");
}

function AddMutator(Mutator M)
{
	if ( M == None )
	{
		Log (Self.Name@"> Plonk!!! Configuration attempt to load a Null"@M@"mutator!");
		GoTo JL766;
	}
	if ( M.Class != Class )
		Super.AddMutator ( M );
JL766:
}

function setdiffscale()
{
	if (LevelMonster == 1)
		DiffScale = 90;
	if (LevelMonster == 2)
		DiffScale = 100;
	if (LevelMonster == 3)
		DiffScale = 110;
	if (LevelMonster == 4)
		DiffScale = 120;
	if (LevelMonster == 5)
		DiffScale = 130;
	if (LevelMonster == 6)
		DiffScale = 140;
	if (LevelMonster == 7)
		DiffScale = 150;
}

function SetUpCurrent()
{
	class'MH_A_V2.ExCreatureCarcass'.default.bNastyCorpse=bNastyCorpse;
	class'TimedBoy'.default.MaxMonsterHealth=MaxMonsterHealth;
	class'TimedBoy'.default.MaxHealth=MaxHealth;
	class'TimedBoy'.default.bUTReplace=bUTReplace;
	class'TimedBoy'.default.bMHLog=bMHLog;
	class'TimedBoy'.default.bPowerXC=bPowerXC;
	bScaleRegen=class'TimedBoy'.default.bScaleRegen;
	Spawn(class'PawnNotify');
	Spawn(class'TimedBoy');
	if ( Level.NetMode == NM_DedicatedServer)
	{
		Spawn(class'LightNotify');
		Spawn(Class'Lightbadie');
	}
}

function SetAlign()
{
	if ( Level.NetMode != NM_Standalone )
		Spawn(class'AlignS');
}

function SetPawnDifficulty( ScriptedPawn S ) //Pretty Slow - no longer recommended usage in AlwaysKeep
{
	local Texture Sk;
	local Texture ms0;
	local Texture ms1;
	local Texture ms2;
	local Texture ms3;
	local Texture ms4;
	local Texture ms5;
	local Texture ms6;
	local Texture ms7;
	local string MSH, Prj;
//	local float Timer;
//	local float F[2];
	local Actor XCPM;
	local XC_Mgmt XCM;

//	class'XC_CoreStatics'.static.Clock( F);

	if (!Level.bStartup)
		S.bCollideWorld=True;
	if (S.Health <= 0)
		GoTo JL1314;
/*	if ( Level.NetMode != NM_DedicatedServer )
		S.Shadow = Level.Spawn(class'MH_A_V2.Monster2Shadow',S);
*/
	if ( S.MenuName == "" )
		S.MenuName = GetItemName(String(S.class));
	if ( ( Caps(Left((S.MenuName),1)) == "A"
		|| Caps(Left((S.MenuName),1)) == "E"
		|| Caps(Left((S.MenuName),1)) == "I"
		|| Caps(Left((S.MenuName),1)) == "O"
		|| Caps(Left((S.MenuName),1)) == "U" )
		&& (Caps(Left((S.NameArticle),3)) == " A "
		|| Caps(Left((S.NameArticle),2)) == "A " 
		|| Caps(Left((S.NameArticle),2)) == " A"
		|| Caps(Left((S.NameArticle),1)) == "A") )
		S.NameArticle = " an ";

	S.DamageScaling = S.DamageScaling * DiffScale / 100;
	if ( S.Mesh != None )
	{
		if ( S.Mesh != S.Class.Default.Mesh )
			S.Mesh = S.Class.Default.Mesh;
		MSH = Caps(S.Mesh);
//		log ("Mesh stored is "$MSH);
	}
	else MSH = Caps(Tz);
	if ( S.RangedProjectile != None )
	{
		Prj = Caps(S.RangedProjectile);
	}
	else
		Prj = Caps(Tz);
//	log ("Projectile for "$S$" stored is "$Prj);
	if (S.PeripheralVision < -1.6) S.PeripheralVision = -1.6;
	if (S.PeripheralVision > -0.2) S.PeripheralVision = -0.2;
	if (S.Aggressiveness < 0.8) S.Aggressiveness = 0.8;
	S.Health = (S.Health * DiffScale) / 100;
	if ( MonsterMultiplier > 1 )
	{
		if (S.IsA('ExFly'))
			goto MoveOn;
		if (S.IsA('ExRat'))
			goto MoveOn;
		S.Health = Clamp(S.Health*MonsterMultiplier,MinMonsterHealth,MaxMonsterHealth); //Use Minimum-Health at once with Multiplier
	}
MoveOn:
	S.SightRadius = (S.Default.SightRadius * DiffScale) / 100;
//	S.HearingThreshold = (S.Default.HearingThreshold * DiffScale) / 100;
	S.Aggressiveness = (S.Default.Aggressiveness * DiffScale) / 100;
	S.MeleeRange = S.Default.MeleeRange; //Yea, idiots ! Fixed craps right now :P !
//	S.ReFireRate = (S.Default.ReFireRate * DiffScale) / 100;
	S.CombatStyle = (S.Default.CombatStyle * DiffScale) / 100;
	S.ProjectileSpeed = (S.Default.ProjectileSpeed * DiffScale) / 100;
	S.GroundSpeed = (S.Default.GroundSpeed * DiffScale) / 100;
	S.AirSpeed = (S.Default.AirSpeed * DiffScale) / 100;
	S.WaterSpeed = (S.Default.WaterSpeed * DiffScale) / 100;
	S.JumpZ = (S.JumpZ * Diffscale) / 100; //... Done, small adjustments changing style.

	if (S.GroundSpeed > 500) 
		S.GroundSpeed = 500;
	if (S.HearingThreshold < 0.1)
		S.HearingThreshold = 0.1;
	if (S.HearingThreshold > 0.8)
		S.HearingThreshold = 0.8;
	if (S.SightRadius < 3500)
		S.SightRadius = 3500;
	if (S.SightRadius > 4500)
		S.SightRadius = 4500;
	if (S.AccelRate > 700)
		S.AccelRate = 700;
	if (S.AirSpeed > 500)
		S.AirSpeed = 500;
	if (S.WaterSpeed > 400)
		S.WaterSpeed = 400;
	if (S.CombatStyle > 0.9)
		S.CombatStyle = 0.9;
	if (S.CombatStyle < 0.3)
		S.CombatStyle = 0.3;
	if (S.Aggressiveness > 1.0)
		S.Aggressiveness = 1.0;
	if (S.Aggressiveness < 0.5)
		S.Aggressiveness = 0.5;
	if ( MH2.bStartedHunt )
		S.AttitudeToPlayer = ATTITUDE_Frenzy;

	if (Right((MSH),6)=="SQUID1")
//	if (S.Mesh == LodMesh 'Squid1')
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		if (S.Skin != None && S.Skin != Texture'UnrealI.Skins.JSquid1')
			Sk = S.Skin;
		else
			Sk = Texture'UnrealI.Skins.JSquid1';
		S.Mesh = LodMesh 'ExSquid1';
		S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
//		S.Fatness = S.Default.Fatness;
	}
	if (Right((MSH),7)=="NALICOW")
//	if (S.Mesh == LodMesh 'NaliCow')
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		if (S.Skin != None && S.Skin != Texture'UnrealShare.Skins.JCow1')
			Sk = S.Skin;
		else
			Sk = Texture'UnrealShare.Skins.JCow1';
		S.Mesh = LodMesh 'ExNaliCow';
		S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
		S.Fatness = S.Default.Fatness;
//		S.Style = STY_Masked;
	}
	if (Right((MSH),4)=="FLYM")
//	if (S.Mesh == LodMesh 'FlyM')
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		if (S.Skin != None && S.Skin != Texture'UnrealShare.Skins.JFly1')
			Sk = S.Skin;
		else
			Sk = Texture'UnrealShare.Skins.JFly1';
		S.Mesh = LodMesh 'ExFlyM';
		S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
		S.Fatness = S.Default.Fatness;
//		S.Style = STY_Masked;
	}
	if (Right((MSH),6)=="SLITH1")
//	if (S.Mesh == LodMesh 'Slith1')
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		if (S.Skin != None && S.Skin != Texture'UnrealShare.Skins.JSlith1')
			Sk = S.Skin;
		else
			Sk = Texture'UnrealShare.Skins.JSlith1';
		S.Mesh = LodMesh 'ExSlith1';
		S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
		S.Fatness = S.Default.Fatness;
//		S.Style = STY_Masked;
	}
	if (Right((MSH),6)=="TITAN1")
//	if (S.Mesh == LodMesh 'Titan1')
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		if (S.Skin != None && S.Skin != Texture'UnrealI.Skins.JTitan1')
			Sk = S.Skin;
		else
			Sk = Texture'UnrealI.Skins.JTitan1';
		S.Mesh = LodMesh 'ExTitan1';
		S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
		S.Fatness = S.Default.Fatness;
	}
	if (Right((MSH),7)=="SPINNER")
//	if ( S.Mesh == LodMesh 'Spinner' )
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		sk = S.Skin;
		S.Mesh = LodMesh 'ExSpinner';
		if ( S.Skin != None && S.Skin != S.Default.Skin )
			S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
		S.Fatness = S.Default.Fatness;
	}

	if ( Pupae(S) != None )
	{
		if (S.RangedProjectile == None)
			S.bHasRangedAttack = False;
	}
	if ( Manta(S) != None )
	{
		if (S.RangedProjectile == None)
			S.bHasRangedAttack = False;
	}
	if ( Mercenary(S) != None )
	{
		Mercenary(S).bHasInvulnerableShield = False;
		Mercenary(S).invulnerableCharge = 0.2;
	}
	if (MH2.bMProjTweak)
	{
	if (Right((Prj),15)=="BRUTEPROJECTILE")
	{
		S.RangedProjectile = class 'MH_A_V2.ExBruteProjectile';
		goto EndProj;
	}
//------------------
	if (Right((Prj),10)=="MERCROCKET")
	{
		S.RangedProjectile = class 'MH_A_V2.ExMercRocket';
		goto EndProj;
	}
//------------------
	if (Right((Prj),14)==".WARLORDROCKET")
	{
		S.RangedProjectile = class 'MH_A_V2.ExWarlordRocket';
		goto EndProj;
	}
//------------------
	if (Right((Prj),11)=="GASBAGBELCH")
	{
		S.RangedProjectile = class 'MH_A_V2.mhGasBagBelch';
		goto EndProj;
	}
	if (Right((Prj),9)=="KRAALBOLT")
	{
		S.RangedProjectile = class 'MH_A_V2.mhKraalBolt';
		goto EndProj;
	}
	if (Right((Prj),14)=="ELITEKRALLBOLT")
	{
		S.RangedProjectile = class 'MH_A_V2.mhEliteKrallBolt';
		goto EndProj;
	}
	if (Right((Prj),16)=="SKAARJPROJECTILE")
	{
		S.RangedProjectile = class 'MH_A_V2.mhSkaarjProjectile';
		goto EndProj;
	}
	if (Right((Prj),15)=="QUEENPROJECTILE")
	{
		S.RangedProjectile = class 'MH_A_V2.mhqueenprojectile';
		goto EndProj;
	}
	if (Right((Prj),18)=="TENTACLEPROJECTILE")
	{
		S.RangedProjectile = class 'MH_A_V2.mhTentacleProjectile';
		goto EndProj;
	}
//-- Expect Lava Bullshit modifications first, in order to be slapped down
	if (Right((Prj),19)=="LAVASLITHPROJECTILE")
	{
		S.RangedProjectile = class 'MH_A_V2.mhLavaSlithProjectile';
		goto EndProj;
	}
//----------------
	if (Right((Prj),15)=="SLITHPROJECTILE")
	{
		S.RangedProjectile = class 'MH_A_V2.mhSlithProjectile';
		goto EndProj;
	}
	if (Right((Prj),13)=="SEEKINGROCKET")
	{
		S.RangedProjectile = class 'MH_A_V2.MHSeekingRocket';
		goto EndProj;
	}
	if (Right((Prj),10)=="RAILROCKET")
	{
		S.RangedProjectile = class 'MH_A_V2.MHTazerProj';
		goto EndProj;
	}
	if (Right((Prj),7)==".ROCKET")
	{
		S.RangedProjectile = class 'MH_A_V2.MHRocket';
		goto EndProj;
	}
	if (Right((Prj),9)=="TAZERPROJ")
	{
		S.RangedProjectile = class 'MH_A_V2.MHTazerProj';
		goto EndProj;
	}
	if (Right((Prj),10)=="RAZORBLADE")
	{
		S.RangedProjectile = class 'MH_A_V2.MHRazorBlade';
		goto EndProj;
	}
	if (Right((Prj),15)=="RAZORBLADEALT")
	{
		S.RangedProjectile = class 'MH_A_V2.MHRazorBladeAlt';
		goto EndProj;
	}
	if (Right((Prj),14)=="DISPERSIONAMMO" || Right((Prj),6)=="PLASMA")
	{
		S.RangedProjectile = class 'MH_A_V2.MHOSDispersionAmmo';
		goto EndProj;
	}
	if (Right((Prj),10)=="ENERGYBOLT")
	{
		S.RangedProjectile = class 'MH_A_V2.MHEnergyBolt';
		goto EndProj;
	}
	if (Right((Prj),6)=="DAMMO2")
	{
		S.RangedProjectile = class 'MH_A_V2.MHOSDAmmo2';
		goto EndProj;
	}
	if (Right((Prj),6)=="DAMMO3")
	{
		S.RangedProjectile = class 'MH_A_V2.MHOSDAmmo3';
		goto EndProj;
	}
	if (Right((Prj),6)=="DAMMO4")
	{
		S.RangedProjectile = class 'MH_A_V2.MHOSDAmmo4';
		goto EndProj;
	}
	if (Right((Prj),6)=="DAMMO5")
	{
		S.RangedProjectile = class 'MH_A_V2.MHOSDAmmo5';
		goto EndProj;
	}
	if (Right((Prj),9)=="FLAKSHELL")
	{
		S.RangedProjectile = class 'MH_A_V2.MHFlakShell';
		goto EndProj;
	}
	if (Right((Prj),17)=="STINGERPROJECTILE")
	{
		S.RangedProjectile = class 'MH_A_V2.MHStingerProjectile';
		goto EndProj;
	}
	if (Right((Prj),8)==".BIODROP")
	{
		S.RangedProjectile = class 'MH_A_V2.MHBioGel';
		goto EndProj;
	}
	if (Right((Prj),9)=="BIGBIOGEL")
	{
		S.RangedProjectile = class 'MH_A_V2.MHBigBiogel';
		goto EndProj;
	}
	if (Right((Prj),7)==".BIOGEL")
	{
		S.RangedProjectile = class 'MH_A_V2.MHBioGel';
		goto EndProj;
	}
	if (Right((Prj),11)=="MASTERCHUNK")
	{
		S.RangedProjectile = class 'MH_A_V2.MHMasterChunk';
		goto EndProj;
	}
	if (Right((Prj),6)=="CHUNK1")
	{
		S.RangedProjectile = class 'MH_A_V2.MHChunk1';
		goto EndProj;
	}
	if (Right((Prj),6)=="CHUNK2")
	{
		S.RangedProjectile = class 'MH_A_V2.MHChunk2';
		goto EndProj;
	}
	if (Right((Prj),6)=="CHUNK3")
	{
		S.RangedProjectile = class 'MH_A_V2.MHChunk3';
		goto EndProj;
	}
	if (Right((Prj),6)=="CHUNK4")
	{
		S.RangedProjectile = class 'MH_A_V2.MHChunk4';
		goto EndProj;
	}
	if (Right((Prj),8)==".GRENADE")
	{
		S.RangedProjectile = class 'MH_A_V2.MHgrenade';
		goto EndProj;
	}
	}

EndProj:
	if (S.BaseEyeHeight < S.CollisionHeight/1.5)
		S.BaseEyeHeight = S.CollisionHeight/1.5;
	S.Intelligence = BRAINS_HUMAN;
	S.bInitialFear=False;
	S.Skill = MySkill;
	if (S.CarcassType != None)
		S.CarcassType = class'MH_A_V2.ExCreatureCarcass';
	if ( S.bCanWalk && !S.bCanFly )
		S.SetPhysics(PHYS_Falling);
	S.NetUpdateFrequency=20;
	S.NetPriority=3.000000;
/*
	if ( bExtendedXC )
	{
		if ( S.DrawScale > 2 ||
			(S.class.default.CollisionHeight > 45 && S.DrawScale > 0.5 ) ||
			(( S.class.default.CollisionHeight < S.class.default.CollisionRadius ) && S.DrawScale >= 1 ) )
		{
			XCM = Spawn(class'XC_Mgmt',S,,S.Location+vect(0,0,50));
			XCPM = Spawn(XC_Class,S,,S.Location+vect(0,0,40));
			if (XCM != None && XCPM != None)
				XCM.A = XCPM;
		}
	}
*/
//	log (S$" has skill level "$S.Skill);
	Sk = None;
	ms0 = None;
	ms1 = None;
	ms2 = None;
	ms3 = None;
	ms4 = None;
	ms5 = None;
	ms6 = None;
	ms7 = None;

//	Timer = class'XC_CoreStatics'.static.UnClock( F);
//	Log("Pawn Difficulty setup took: "$Timer$" seconds.");
JL1314:
}

function bool IsRelevant(Actor Other, out byte bSuperRelevant)
{
	local bool bResult;
	local ScriptedPawn S;

	bResult = CheckReplacement(Other,bSuperRelevant);
	if ( ScriptedPawn(Other) != none && bResult )
	{
		S = ScriptedPawn(Other);
		S.bCanBePissed = False;
		S.bIgnoreFriends = False;
		S.OddsOfAppearing = 1.000000;
//		if ( !Level.bStartUp )
		SetPawnDifficulty(S);
		bResult = True;
	}
	if ( ThingFactory(Other) != None && bResult )
		bResult = True;

	if ( Other.class == class 'MH_A_V2.SpawnPoint' )
		bResult = True;

	if ( bResult && (NextMutator != None) )
		bResult = NextMutator.IsRelevant(Other, bSuperRelevant);
	return bResult;
}

function bool AlwaysKeep(Actor Other)
{
	local bool bTemp;

	if ( ScriptedPawn(Other) != None )
	{
		if ( ScriptedPawn(Other).bHasRangedAttack && ScriptedPawn(Other).bCanWalk )
			ScriptedPawn(Other).bMovingRangedAttack = True;
	}

	if ( NextMutator != None )
		return ( NextMutator.AlwaysKeep(Other) );
	return False;
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	local Inventory Inv;
	local Weapon W;
	local ScriptedPawn S;
	local Pawn P;
	local FlockPawn FP;
	local Actor XCM;
	local ThingFactory Thfa;
//	local float Timer;
//	local float F[2];

	bSuperRelevant = 1;

//== It's a timing problem with weapons which are not replaced and it wasn't anymore before - Heck, will this ever end ?
	if ( Weapon(Other) != None && Weapon(Other).Instigator != None && Weapon(Other).Instigator.Weapon != Weapon(Other) )
	{
		P = Weapon(Other).Instigator;
		if ( P.Health > 0 && P.PlayerReplicationInfo == None )
			spawn (class'PawnControl',P,,P.Location);
	}
//== I'm doin' a short delayed check at weapon instigated by something (monster) if after 150 ms it's held somehow,
//== if still exist an instigator but instigator doesn't have weapon add to instigator's inventory
//== doesn't matter who is that fart. Something is too slow or too fast in here or autostates doesn't have
//== a good timing - Initialization of Actors - one of them is not ready when it needs to be.

/*	if ( bExtendedXC )
	if ( !Level.bStartUp && ExCreatureCarcass(Other) != None && ExCreatureChunks(Other) == None )
	{
		if ( XC_DecoClass != None )
		{
			XCM = Spawn( XC_DecoClass,Other,,Other.Location,Other.Rotation);
			XCM.Attach(Other);
		}
	}
*/
	if ( WayBeacon(Other) != None )
	{
		Other.NetUpdateFrequency = 10.000000;
		Other.RemoteRole = ROLE_DumbProxy; //My Light, I want my light
		Other.AmbientGlow = 200;
		Other.LightEffect = LE_NonIncidence;
		Other.LightBrightness = 200;
		Other.LightRadius = 10;
	}
	if ( Inventory(Other) != None && WarheadLauncher(Other) == None && NSWarheadLauncher(Other) == None ) //Attack only Map items
	{
		if ( Inventory(Other).MyMarker != None && Level.bStartUp )
			Inventory(Other).RespawnTime = AmmoRespawnTime+RandRange(1,AmmoRespawnTime+1);
		if (Inventory(other).PickupMessageClass != Class'Botpack.PickupMessagePlus')
			Inventory(other).PickupMessageClass=Class'Botpack.PickupMessagePlus';
	}
//	log ("Clocking replacement for "$Other);
//	class 'XC_CoreStatics'.static.Clock( F);
	if (Left((Caps(Other.Class)),7)=="MH_A_V2")
	{
//		log (Other@"won't be checked forward");
//		Timer = class'XC_CoreStatics'.static.UnClock( F);
//		log ("Actor Check Time took :"@Timer@"seconds.");
		return True;
		// if actor is from this package simply get over checks as long as it's allowed by default - rarely will gain speed
		// AND also getting over check seems to cost randomly more time, looks like this crap is really expensive
		// However will prevent infinite stupid recursions if OTHER is one of ours
	}
/*
	if (Left((Caps(Other.Class)),4)=="BPAK")
		return True;
*/
	if ( bReplaceThem && !bPowerXC )
	{
		if ( Other.bIsPawn && !Other.bStatic && !Other.bNoDelete )
		{
			if ( bReplaceMonsters )
			{
			if ( Other.IsA('Bird1') )
			{
//				log ("Attempt to replace actor: "@Other@" with health "@Bird1(Other).Health );
				ReplaceWithOther(Other,"MH_A_V2.Bird2");
				return False;
			}
			if ( Other.IsA('SkaarjBerserker') )
			{
//				S = ScriptedPawn(Other);
				ReplaceMonster(Other, "MH_A_V2.ExSkaarjBerserker");
				if ( !Other.bBlockActors )
					return False;
//				else SetPawnDifficulty(S); //Else replacement not worked and need to keep it to not alter game :(.
			}
			if ( Other.IsA('Fly') )
			{
//				S = ScriptedPawn(Other);
				ReplaceMonster(Other, "MH_A_V2.NsFly"); //Done ? Warning at Factories !!!
				if ( !Other.bBlockActors )
					return False;
//				else SetPawnDifficulty(S); //Else replacement not worked and need to keep it to not alter game :(.
			}
			if ( Other.IsA('GiantGasbag') )
			{
//				S = ScriptedPawn(Other);
				ReplaceMonster(Other, "MH_A_V2.ExGiantGasbag"); //Done ? Warning at Factories !!!
				if ( !Other.bBlockActors ) //If OldPawn doesn't have a collision is OK for removal.
					return False;
//				else SetPawnDifficulty(S); //Else replacement not worked and need to keep it to not alter game :(.
			}
			if ( Other.IsA('Gasbag') )
			{
//				S = ScriptedPawn(Other);
				ReplaceMonster(Other, "MH_A_V2.ExGasbag"); //Done ? Warning at Factories !!!
				if ( !Other.bBlockActors )
					return False;
//				else SetPawnDifficulty(S); //Else replacement not worked and need to keep it to not alter game :(.
			}
			if ( Other.IsA('MercenaryElite') )
			{
//				S = ScriptedPawn(Other);
				ReplaceMonster(Other, "MH_A_V2.ExMercenaryElite"); //Done ? Warning at Factories !!!
				if ( !Other.bBlockActors )
					return False;
//				else SetPawnDifficulty(S); //Else replacement not worked and need to keep it to not alter game :(.
			}
			if ( Other.IsA('Mercenary') )
			{
//				S = ScriptedPawn(Other);
				ReplaceMonster(Other, "MH_A_V2.ExMercenary"); //Done ? Warning at Factories !!!
				if ( !Other.bBlockActors )
					return False;
//				else SetPawnDifficulty(S); //Else replacement not worked and need to keep it to not alter game :(.
			}
			if ( Other.Class == Class 'NaliPriest' )
			{
//				S = ScriptedPawn(Other);
				ReplaceMonster(Other, "MH_A_V2.ExNaliPriest"); //Done ? Warning at Factories !!!
				if ( !Other.bBlockActors )
					return False;
//				else SetPawnDifficulty(S); //Else replacement not worked and need to keep it to not alter game :(.
			}
			if ( Other.Class == Class 'Nali' )
			{
//				S = ScriptedPawn(Other);
				ReplaceMonster(Other, "MH_A_V2.ExNali"); //Done ? Warning at Factories !!!
				if ( !Other.bBlockActors )
					return False;
//				else SetPawnDifficulty(S); //Else replacement not worked and need to keep it to not alter game :(.
			}
			if ( Other.IsA('Squid') )
			{
//				S = ScriptedPawn(Other);
				ReplaceMonster(Other, "MH_A_V2.ExSquid"); //Done ? Warning at Factories !!!
				if ( !Other.bBlockActors )
					return False;
//				else SetPawnDifficulty(S); //Else replacement not worked and need to keep it to not alter game :(.
			}
			if ( Other.IsA('DevilFish') )
			{
//				S = ScriptedPawn(Other);
				ReplaceMonster(Other, "MH_A_V2.ExDevilFish"); //Done ? Warning at Factories !!!
				if ( !Other.bBlockActors )
					return False;
//				else SetPawnDifficulty(S); //Else replacement not worked and need to keep it to not alter game :(.
			}

			if ( Other.Class == Class 'BiterFishSchool' )
			{
				ReplaceWithOther(Other,"MH_A_V2.BiterFishSchool2");
				return False;
			}
			if ( Other.IsA('NaliRabbit') )
			{
				ReplaceWithOther(Other,"MH_A_V2.NaliRabbit2");
				return False;
			}
			}
		}

		if ( bDecoChange && !bPowerXC )
		{
		if (!Other.bStatic && !Other.bNoDelete && ( Decoration(Other) != None && Decoration(Other).bCollideActors ))
		{
			if ( Barrel(Other) != None  )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExBarrel");
				if (!Other.bBlockActors)
					return False;
			}
			if ( Vase(Other) != None  )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExVase");
				if (!Other.bBlockActors)
					return False;
			}
			if ( WoodenBox(Other) != None  )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExWoodenBox");
				if (!Other.bBlockActors)
					return False;
			}
			if ( Chest(Other) != None  )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExChest");
				if (!Other.bBlockActors)
					return False;
			}
			if ( TarydiumBarrel(Other) != None  )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExTarydiumBarrel");
				if (!Other.bBlockActors)
					return False;
			}
			if ( Chair(Other) != None )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExChair");
				if (!Other.bBlockActors)
					return False;
			}
			if ( MonkStatue(Other) != None  )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExMonkStatue");
				if (!Other.bBlockActors)
					return False;
			}
			if ( SludgeBarrel(Other) != None )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExSludgeBarrel");
				if (!Other.bBlockActors)
					return False;
			}
			if ( Urn(Other) != None )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExUrn");
				if (!Other.bBlockActors)
					return False;
			}
			if ( Table(Other) != None )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExTable");
				if (!Other.bBlockActors)
					return False;
			}
			if ( Cannon(Other) != None )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExCannon");
				if (!Other.bBlockActors)
					return False;
			}
			if ( Lamp4(Other) != None )
			{
				ReplaceWithOther(Other,"MH_A_V2.ExLamp4");
				if (!Other.bBlockActors)
					return False;
			}
		}
		}
	}
	if ( Other.bIsPawn )
	{
		if ( FlockPawn(Other) != None )
		{
			FP = FlockPawn(Other);
			SetCreature(FP);
//			FP.Style = STY_Masked;
		}
		if ( ScriptedPawn(Other) != None )
			return true;
	}

	if ( ThingFactory(Other) != None )
		return True;
	if (!bPowerXC)
	{
		if ( HumanCarcass(Other) != None && (!HumanCarcass(Other).bStatic && !HumanCarcass(Other).bNoDelete) && Other.Region.Zone.bWaterZone )
		{
			log ("Attempt corrode "$HumanCarcass(Other));
			HumanCarcass(Other).GotoState('Corroding');
		}

		if ( UTHumanCarcass(Other) != None )
		{
			Other.Disable('Timer');
			Other.LifeSpan = 2.000000;
		}

		if ( CreatureChunks(Other) != None && !CreatureChunks(Other).bStatic && !CreatureChunks(Other).bNoDelete )
		{
			Other.Disable('Timer');
			Other.LifeSpan = 4.000000;
		}

		if ( UTCreatureChunks(Other) != None && (!UTCreatureChunks(Other).bStatic && !UTCreatureChunks(Other).bNoDelete ) )
		{
			Other.Disable('Timer');
			Other.LifeSpan = 1.000000;
		}
	}
	if (bNoTranslator)
	{
		if ( Other.class == class 'Translator') 
		{
			if ( bOldWepReplace )
			{
				ReplaceWith(Other,"MH_A_V2.MHDispersionPowerUp");
				return False;
			}
			else
			{
				ReplaceWith(Other,"UnrealShare.WeaponPowerUp");
				return False;
			}
		}
	}

	if ( Pickup(Other) != None && Weapon(Other) == None )
	{
//		log ("Clocking replacement for "$Other);
//		class 'XC_CoreStatics'.static.Clock( F);
		if ( (Other.IsA('MB') || Other.IsA('MB2')) && UT_Jumpboots(Other) == None )
		{
			ReplaceWith(Other, "BotPack.UT_Jumpboots");
			return False;
		}
		switch(Other)
		{
			case WeaponPowerUp(Other):
				if ( bOldWepReplace ) //Allow powers
				{
					ReplaceWithOther(Other,"MH_A_V2.MHDispersionPowerUp");
					return False;
				}
				break;

			case Dampener(Other):
				if ( bOldWepReplace )
				{
					ReplaceWith(Other,"MH_A_V2.MHDispersionPowerUp");
					return False;
				}
				else
				{
					ReplaceWith(Other,"UnrealShare.WeaponPowerUp");
					return False;
				}
				break;

			case ForceField(Other):
				if ( bOldWepReplace )
				{
					ReplaceWith(Other,"MH_A_V2.MHDispersionPowerUp");
					return False;
				}
				else
				{
					ReplaceWith(Other,"UnrealShare.WeaponPowerUp");
					return False;
				}
				break;

			case Invisibility(Other):
				if ( bOldWepReplace )
				{
					ReplaceWith(Other, "MH_A_V2.MHDispersionPowerUp");
					return False;
				}
				else
				{
					ReplaceWith(Other,"UnrealShare.WeaponPowerUp");
					return False;
				}
				break;

			case UT_invisibility(Other):
				if ( bUTReplace )
				{
					ReplaceWith(Other, "MH_A_V2.MHDispersionPowerUp");
					return False;
				}
				break;

			case NaliFruit(Other):
				ReplaceWith(Other, "MH_A_V2.CNaliFruit");
				return False;
				break;

			case MedBox(Other):
				if (bUTReplace)
				{
					ReplaceWithOther(Other, "MH_A_V2.CHealthBox");
					return False;
				}
				break;

			case SuperHealth(Other):
				ReplaceWithOther(Other, "MH_A_V2.CHealthPack");
				return False;
				break;

			case HealthPack(Other):
				if (bUTReplace)
				{
					ReplaceWithOther(Other, "MH_A_V2.CHealthPack");
					return False;
				}
				break;

			case Bandages(Other):
				ReplaceWithOther(Other, "MH_A_V2.CHealthVial");
				return False;
				break;

			case Health(Other):
				ReplaceWithOther(Other, "MH_A_V2.CHealthBox");
				return False;
				break;

			case HealthVial(Other):
				if (bUTReplace)
				{
					ReplaceWithOther(Other, "MH_A_V2.CHealthVial");
					return False;
				}
				break;

			case Seeds(Other):
				ReplaceWith(Other, "MH_A_V2.MHSeeds");
				return False;
				break;

			case Searchlight(Other):
				ReplaceWithOther(Other, "MH_A_V2.mhsearchlight");
				return False;
				break;

			case FlashLight(Other):
				ReplaceWithOther(Other, "MH_A_V2.mhflashlight");
				return False;
				break;

			case Flare(Other): //&& mhflare(Other) == None
				ReplaceWithOther(Other, "MH_A_V2.mhflare");
				return False;
				break;

			case jumpboots(Other):
				ReplaceWithOther(Other, "botpack.ut_jumpboots");
				return False;
				break;
/*
			case Other.IsA('MB') || Other.IsA('MB2'):
				ReplaceWith(Other, "BotPack.UT_Jumpboots");
				return False;
				break;
I'll be back to you later - fucking idiots
*/
			case ScubaGear(Other):
				if (bUTReplace)
				{
					ReplaceWithOther(Other, "MH_A_V2.mhscuba");
					return false;
				}
				break;

			case UT_ShieldBelt(Other):
				if (bUTReplace)
				{
					ReplaceWithOther(Other, "MH_A_V2.MHUT_ShieldBelt");
					return false;
				}
				break;

			case ShieldBelt(Other):
				ReplaceWithOther(Other, "MH_A_V2.MHUT_ShieldBelt");
				return false;
				break;

			case UDamage(Other):
				if (bUTReplace)
				{
					ReplaceWithOther(Other, "MH_A_V2.MHUdamage");
					return False;
				}
				break;

			case Amplifier(Other):
				if ( bOldWepReplace )
				{
					ReplaceWithOther(Other, "MH_A_V2.MHUdamage");
					return False;
				}
				break;

			case Suits(Other):
				ReplaceWithOther(Other, "MH_A_V2.MHArmor2");
				return False;
				break;

			case Armor(Other):
				ReplaceWithOther(Other, "MH_A_V2.MHArmor2");
				return false;
				break;

			case Armor2(Other):
				if (bUTReplace)
				{
					ReplaceWithOther(Other, "MH_A_V2.MHArmor2");
//					log (Other@"replacement.");
					return false;
				}
				break;

			case ThighPads(Other):
				if (bUTReplace)
				{
					ReplaceWithOther(Other, "MH_A_V2.MHThighPads");
//					log (Other@"replacement.");
					return false;
				}
				break;

			case GalticAmmo(Other):
				if (GalticAmmo(Other).AmmoAmount > 1)
					GalticAmmo(Other).AmmoAmount = 1;
				if (GalticAmmo(Other).MaxAmmo > 2)
					GalticAmmo(Other).MaxAmmo = 2;
				break;

			case WarHeadAmmo(Other):
				if (!bUTReplace)
				{
					WarheadAmmo(Other).AmmoAmount=2;
					WarheadAmmo(Other).Default.AmmoAmount=2;
				}
				break;

			case Ammo(Other):
				if ( Other.IsA('SinShotgunAmmo') )
				{
					ReplaceWith(Other, "Botpack.FlakAmmo");
					return False;
				}
				if ( bScaleRegen )
					Ammo(Other).MaxAmmo = Ammo(Other).Default.MaxAmmo * MaxAmmoMultiplier;
				break;
		}
//		Timer = class'XC_CoreStatics'.static.UnClock( F);
//		log ("Pickup Check Time took :"@Timer@"seconds.");

	} //Pickup check

	if ( Light(Other) != None && Torchflame(Other) == None )
	{
		Light(Other).NetUpdateFrequency = 1.000000;
	}

//bSuperRelevant = 1;
	if ( MyGame.bMegaSpeed && Other.bIsPawn && Pawn(Other).PlayerReplicationInfo != None )
	{
		Pawn(Other).GroundSpeed *= 1.4;
		Pawn(Other).WaterSpeed *= 1.4;
		Pawn(Other).AirSpeed *= 1.4;
		Pawn(Other).AccelRate *= 1.4;
	}

	Inv = Inventory(Other);
 	if ( Inv == None )
	{
		bSuperRelevant = 0;
		if ( TorchFlame(Other) != None )
			Other.NetUpdateFrequency = 0.5;
		return true;
	}

	if ( Weapon(Other) != None )
	{
		if (!Other.Region.Zone.bWaterZone)
			Weapon(Other).MaxDesireability=Weapon(Other).default.MaxDesireability+3.000000;
		if ( Weapon(Other).Instigator != None && Weapon(Other).Instigator.PlayerReplicationInfo == None)
		{
			Weapon(Other).SetHand(1);
			Weapon(Other).FireOffset = Weapon(Other).FireOffset * 2 * Weapon(Other).Instigator.DrawScale;
			Weapon(Other).FireOffset.X = Weapon(Other).Default.FireOffset.X * (Weapon(Other).Instigator.DrawScale/Weapon(Other).Instigator.Default.DrawScale) * 4 * Weapon(Other).Instigator.DrawScale;
			Weapon(Other).FireOffset.Y = Weapon(Other).Default.FireOffset.Y;
			Weapon(Other).FireOffset.Z = Weapon(Other).Default.FireOffset.Z * Weapon(Other).Instigator.DrawScale;
		}
/*
	Rant On
	Obviously to gain popularity we are releasing all trash just to be cool...
	Hint -> In my games your fucking retarded stuff is about to be removed, AASHOOOLEEES !
	Rant off
*/
		if ( Other.IsA('SinShotgun') ) //Using ISA to avoid compiling dependencies 
		{
			ReplaceWith(Other, "Botpack.UT_FlakCannon");
			return False;
		}
/*	Rant on
	Something without dependencies... for "rewritten" quadsh*t
	This was not even later rewritten better.
	Some replacements still contains unexistent mesh material for import...
	Your are stupid after all... Still did not see retarded green cube at first time load? - IT'S A FUCKING MESS >:|
	Rant off
*/
		if ( Other.IsA('OLquadshot') )
		{
			ReplaceWithOther( Other, "MH_A_V2.MHquadshot");
			return false;
		}
		if ( TournamentWeapon(Other) != None )
		{
			if ( bUTReplace )
			switch(Other)
			{
			case WarheadLauncher(Other):
				if ( Other.class == class'WarheadLauncher' )
				{
					ReplaceWith(Other,"MH_A_V2.NSWarheadLauncher");
					return false;
				}
				break;
			case GalticLauncher(Other):
				if (GalticLauncher(Other).PickupAmmoCount > 1)
					GalticLauncher(Other).PickupAmmoCount = 1;
				break;
			case minigun2(Other):
				if (Other.class == class'minigun2')
				{
					ReplaceWith(Other,"MH_A_V2.Eminigun2");
					return false;
				}
				break;
			case PulseGun(Other):
				if (Other.class == class'PulseGun')
				{
					ReplaceWith(Other,"MH_A_V2.EPulseGun");
					return false;
				}
				break;
			case Chainsaw(Other):
				if (Other.class == class'ChainSaw')
				{
					ReplaceWith(Other,"BotPack.Enforcer");
					return False;
				}
				break;
			case UT_Eightball(Other):
				if ( Other.class == class'UT_Eightball')
				{
					ReplaceWith(Other,"MH_A_V2.EUT_Eightball");
					return False;
				}
				break;
			case SuperShockRifle(Other):
				if (Other.class == class'SuperShockRifle')
				{
					ReplaceWith(Other,"MH_A_V2.MHSuperShockRifle");
					return False;
				}
				break;
			}
		}
		if ( Other.IsA('quadshot') ) //quad-shit would be a perfect match :|
		{
			ReplaceWith( Other, "MH_A_V2.MHquadshot"); 
			return false; 
		}
		if ( bOldWepReplace )
		switch(Other)
		{
			case Stinger(Other):
				ReplaceWithOther(Other, "MH_A_V2.MHStinger");
				return false;
				break;
			case OLStinger(Other):
				ReplaceWithOther(Other, "MH_A_V2.MHStinger");
				return false;
				break;
			case Rifle(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHRifle" );
				return false;
				break;
			case OLRifle(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHRifle" );
				return false;
				break;
			case Razorjack(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHRazorJack" );
				return false;
				break;
			case OLRazorjack(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHRazorJack" );
				return false;
				break;
			case Minigun(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHMinigun" );
				return false;
				break;
			case OLMinigun(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHMinigun" );
				return false;
				break;
			case AutoMag(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHAutomag" );
				return false;
				break;
			case OLAutoMag(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHAutomag" );
				return false;
				break;
			case Eightball(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHEightball" );
				return false;
				break;
			case OLEightball(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHEightball" );
				return false;
				break;
			case FlakCannon(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHFlakCannon" );
				return false;
				break;
			case OLFlakCannon(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHFlakCannon" );
				return false;
				break;
			case ASMD(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHASMD" );
				return false;
				break;
			case OLASMD(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHASMD" );
				return false;
				break;
			case GESBioRifle(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHGESBioRifle" );
				return false;
				break;
			case OLGESBioRifle(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHGESBioRifle" );
				return false;
				break;
			case DispersionPistol(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHDispersionPistol");
				return false;
				break;
			case OLDPistol(Other):
				ReplaceWithOther( Other, "MH_A_V2.MHDispersionPistol");
				return false;
				break;
		}
	}

	if ( NextMutator != None )
		return NextMutator.CheckReplacement(Other,bSuperRelevant) ;
	return True;
}

function SetCreature (Pawn FP)
{
	local Texture Sk;
	local Texture ms0;
	local Texture ms1;
	local Texture ms2;
	local Texture ms3;
	local Texture ms4;
	local Texture ms5;
	local Texture ms6;
	local Texture ms7;

	if (FP.Mesh == LodMesh 'Bird')
	{
		ms0 = FP.MultiSkins[0];
		ms1 = FP.MultiSkins[1];
		ms2 = FP.MultiSkins[2];
		ms3 = FP.MultiSkins[3];
		ms4 = FP.MultiSkins[4];
		ms5 = FP.MultiSkins[5];
		ms6 = FP.MultiSkins[6];
		ms7 = FP.MultiSkins[7];
		if (FP.Skin != None && FP.Skin != Texture'UnrealShare.Skins.JBird11')
			Sk = FP.Skin;
		else
			Sk = Texture'UnrealShare.Skins.JBird11';
		FP.Mesh = LodMesh 'ExBird';
		FP.Skin = Sk;
		FP.MultiSkins[0] = ms0;
		FP.MultiSkins[1] = ms1;
		FP.MultiSkins[2] = ms2;
		FP.MultiSkins[3] = ms3;
		FP.MultiSkins[4] = ms4;
		FP.MultiSkins[5] = ms5;
		FP.MultiSkins[6] = ms6;
		FP.MultiSkins[7] = ms7;
	}
	if (FP.Mesh == LodMesh 'Rabbit')
	{
		ms0 = FP.MultiSkins[0];
		ms1 = FP.MultiSkins[1];
		ms2 = FP.MultiSkins[2];
		ms3 = FP.MultiSkins[3];
		ms4 = FP.MultiSkins[4];
		ms5 = FP.MultiSkins[5];
		ms6 = FP.MultiSkins[6];
		ms7 = FP.MultiSkins[7];
		if (FP.Skin != None && FP.Skin != Texture'UnrealShare.Skins.JRabbit1')
			Sk = FP.Skin;
		else
			Sk = Texture'UnrealShare.Skins.JRabbit1';
		FP.Mesh = LodMesh 'ExRabbit';
		FP.Skin = Sk;
		FP.MultiSkins[0] = ms0;
		FP.MultiSkins[1] = ms1;
		FP.MultiSkins[2] = ms2;
		FP.MultiSkins[3] = ms3;
		FP.MultiSkins[4] = ms4;
		FP.MultiSkins[5] = ms5;
		FP.MultiSkins[6] = ms6;
		FP.MultiSkins[7] = ms7;
	}
	if (FP.Mesh == LodMesh 'FireFly')
	{
		ms0 = FP.MultiSkins[0];
		ms1 = FP.MultiSkins[1];
		ms2 = FP.MultiSkins[2];
		ms3 = FP.MultiSkins[3];
		ms4 = FP.MultiSkins[4];
		ms5 = FP.MultiSkins[5];
		ms6 = FP.MultiSkins[6];
		ms7 = FP.MultiSkins[7];
		if (FP.Skin != None && FP.Skin != Texture'UnrealShare.Skins.JFirefly1')
			Sk = FP.Skin;
		else
			Sk = Texture'UnrealShare.Skins.JFirefly1';
		FP.Mesh = LodMesh 'ExFirefly';
		FP.Skin = Sk;
		FP.MultiSkins[0] = ms0;
		FP.MultiSkins[1] = ms1;
		FP.MultiSkins[2] = ms2;
		FP.MultiSkins[3] = ms3;
		FP.MultiSkins[4] = ms4;
		FP.MultiSkins[5] = ms5;
		FP.MultiSkins[6] = ms6;
		FP.MultiSkins[7] = ms7;
	}
	if (FP.Mesh == LodMesh 'AmbientFish')
	{
		ms0 = FP.MultiSkins[0];
		ms1 = FP.MultiSkins[1];
		ms2 = FP.MultiSkins[2];
		ms3 = FP.MultiSkins[3];
		ms4 = FP.MultiSkins[4];
		ms5 = FP.MultiSkins[5];
		ms6 = FP.MultiSkins[6];
		ms7 = FP.MultiSkins[7];
		if ( FP.Skin != None )
			Sk = FP.Skin;
		else
			Sk = Texture'UnrealShare.Skins.JFish21';
		FP.Mesh = LodMesh 'ExAmbientFish';
		FP.Skin = Sk;
		FP.MultiSkins[0] = ms0;
		FP.MultiSkins[1] = ms1;
		FP.MultiSkins[2] = ms2;
		FP.MultiSkins[3] = ms3;
		FP.MultiSkins[4] = ms4;
		FP.MultiSkins[5] = ms5;
		FP.MultiSkins[6] = ms6;
		FP.MultiSkins[7] = ms7;
	}
	Sk = None;
	ms0 = None;
	ms1 = None;
	ms2 = None;
	ms3 = None;
	ms4 = None;
	ms5 = None;
	ms6 = None;
	ms7 = None;
}

function ScoreKill(pawn Killer, pawn Other)   
{
	if (Killer == None) GoTo JL2270; //return; sui - or fall in lava ? Who give a shit anyway ? Return removed from each class !!!
//	if (!Killer.bIsHuman) GoTo JL2270; // bot iran
//	if ( Killer.PlayerReplicationInfo.bIsABot ) GoTo JL2270; // bot irane- Nelsona > Because???? Just check for fucking replication...
	if (!Killer.bIsPlayer || Killer.PlayerReplicationInfo == None) GoTo JL2270; //LOLZ
	if ( Other == None ) GoTo JL2270; // ?
	if ( !Other.IsA ('ScriptedPawn')) GoTo JL2270;
	if ( Killer.bIsPlayer && Other.bIsPlayer ) GoTo JL2270; // tk
		if (Killer.IsA('StationaryPawn')) GoTo JL2270;
	if ( Other.Spree > 1 && Other.bIsPlayer && Other.PlayerReplicationInfo != None )
		EndSpree(Killer, Other);
	if ( Other.bIsPlayer ) Other.Spree = 0;
	if ( Killer != None && Killer.PlayerReplicationInfo != None && Killer != Other && ScriptedPawn(Other) != None )
	{
		// if(Killer.Health <= MaxHealth)Killer.Health += Rand(HealthRegenPerKill)+HealthRegenPerKillMin;
		if(Killer.Health <= MaxHealth)
		{
			Killer.Health += HealthRegenPerKill;
		}
		if(Killer.Health > MaxHealth)          //New check for max health
		{
			Killer.Health = MaxHealth;
		}

		if (bUseCrapSpree)
		{
			if ( Killer.PlayerReplicationInfo != None )
			{
				Killer.Spree+=1;
				if ( Killer.Spree > 14 )
					NotifySpree(Killer, Killer.Spree);
			}
			if ( TournamentPlayer(Killer) != None )
			{
				if ( (TournamentPlayer(Killer).Level.TimeSeconds - TournamentPlayer(Killer).LastKillTime < 3))
				{
					TournamentPlayer(Killer).MultiLevel++;
					if(TournamentPlayer(Killer).MultiLevel >= 41)TournamentPlayer(Killer).MultiLevel = 40;
					TournamentPlayer(Killer).ReceiveLocalizedMessage( class'NSMH_AGMultiKillMessage', TournamentPlayer(Killer).MultiLevel );
						CheckBroadCast(Killer,TournamentPlayer(Killer).MultiLevel);
				}
				else
					TournamentPlayer(Killer).MultiLevel = 0;
				TournamentPlayer(Killer).LastKillTime = TournamentPlayer(Killer).Level.TimeSeconds;
			}
		}
	}
JL2270:
	Super.ScoreKill(Killer,Other);
}

function CheckBroadCast(Pawn Killer,int num)
{
	if ( Killer.PlayerReplicationInfo != None )
		BroadCastMessage(Killer.PlayerReplicationInfo.PlayerName@GetText(num));
}

function string GetText(int Switch)
{
	switch (Switch)
	{
		case 1:
			return " has Double Kill!";
			break;
		case 2:
			return " has Triple Kill!";
			break;
		case 3:
			return " has Multi Kill!";
			break;
		case 4:
			return " has Mega Kill!";
			break;
		case 5:
			return " has ULTRA KILL!";
			break;
		case 6:
			return " has M O N S T E R  K I L L !!!";
			break;
		case 7:
			return " has L U D I C R O U S   K I L L !!!";
			break;
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
		case 16:
		case 17:
		case 18:
		case 19:
		case 20:
		case 21:
		case 22:
		case 23:
		case 24:
		case 25:
		case 26:
		case 27:
		case 28:
		case 29:
		case 30:
		case 31:
		case 32:
		case 33:
		case 34:
		case 35:
		case 36:
		case 37:
		case 38:
		case 39:
			return " has H O L Y  S H I T !!!";
			break;
		case 40:
		case 41:
			return " is  J U S T  H U N T I N G !!!";
			break;
	}
	return "";
}

function NotifySpree(Pawn Other, int num)
{
	local TournamentPlayer P;

	if ( num == 15 )
		num = 0;
	else if ( num == 35 )
		num = 1;
	else if ( num == 60 )
		num = 2;
	else if ( num == 90 )
		num = 3;
	else if ( num == 125 )
		num = 4;
	else if ( num == 250 )
		num = 5;
	else
		GoTo JL2368;

	if ( !bPowerXC )
	{
		foreach AllActors (class 'TournamentPlayer',P,'aMH')
			P.ReceiveLocalizedMessage( class'NSMH_AGKillingSpreeMessage', Num, Other.PlayerReplicationInfo );
	}
	else
	{
		foreach PawnActors (class 'TournamentPlayer',P,,,True)
			P.ReceiveLocalizedMessage( class'NSMH_AGKillingSpreeMessage', Num, Other.PlayerReplicationInfo );
	}

JL2368:
}

function EndSpree(Pawn Killer, Pawn Other)
{
	local TournamentPlayer P;
//	BroadcastMessage("Endspree Killer"@Killer@" Other"@Other);
	if ( !Other.bIsPlayer || Killer.PlayerReplicationInfo.bIsABot)
		GoTo JL2380;
	if ( !bPowerXC )
	{
		foreach AllActors (class 'TournamentPlayer',P,'aMH')
			P.ReceiveLocalizedMessage( class'NSMH_AGKillingSpreeMessage', Other.Spree, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo );
	}
	else
	{
		foreach PawnActors (class 'TournamentPlayer',P,,,True)
			P.ReceiveLocalizedMessage( class'NSMH_AGKillingSpreeMessage', Other.Spree, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo );
	}
JL2380:
}

function MutatorTakeDamage( out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation,
out Vector Momentum, name DamageType)
{
	local TournamentPlayer P;
	local NSBloodPuff bp;
	local NSGreenBloodPuff gb;
	local ExBloodSpurt b;

	if ( InstigatedBy == None ) // damagezone etc...
		GoTo JL2549;

	if(DamageType == 'Impact') // hammer x5 ii !
	{
	   ActualDamage *= 5;
	}

	if(bUseAltScoring) //Scoring by damage
	{
		if (Victim != None && InstigatedBy != None)
		{
			if ( actualDamage < 0 )
				GoTo JL2549;

	// Stop scoring above monsters health value
			if (ActualDamage > Victim.Health)
				ActualDamage = Victim.Health;

	//Add the monster health taken to the players score
	//Revision 2014 - Not Interested in dumb millions
			if ( Victim != InstigatedBy )
			{
				if (( Victim.PlayerReplicationInfo == None
					&& StationaryPawn(Victim) == None )
						&& InstigatedBy.PlayerReplicationInfo != None )
				{
//					InstigatedBy.PlayerReplicationInfo.Score += ActualDamage; //End of bullshits
					InstigatedBy.PlayerReplicationInfo.Score += Clamp(ActualDamage,1,ActualDamage/10);
				}
			}
		}
	}	
	if(bUseAntiBoost)
	{
		if( Victim != None && InstigatedBy != None)
		{
			if (( PlayerPawn(InstigatedBy) != None && PlayerPawn(Victim) != None && Victim != InstigatedBy ) || ( Bot(InstigatedBy) != None && PlayerPawn(Victim) != None ))
			{
				Momentum.z *= 0.1;
				Momentum.x *= 0.1;
				Momentum.y *= 0.1;
				if (string(DamageType)=="RedeemerDeath")
				{
//					Velocity = Vect(0,0,0);
					Victim.Velocity = Victim.Velocity * 0.05;
				}
			}
		}
	}

	// monster damage
	if (bNoRiskCannon)
	{
		if( TeamCannon(InstigatedBy) != None && Victim.PlayerReplicationInfo == None)
		{
			ActualDamage = 0;
			GoTo JL2549; // None damage = 0
		}
	}

	if(bHitsounds) // hitsounds code
	{
		if ( ( PlayerPawn(InstigatedBy) != None || Bot(InstigatedBy) != None ) && (Victim != InstigatedBy) )
		{
			if( PlayerPawn(Victim) != None || Bot(Victim) != None )  // When player shoot other player
			{
				InstigatedBy.PlaySound(Sound'MH_A_V2.HitsoundTeam',SLOT_Interact,4 * HitVolume, False);
//				PlayerPawn(InstigatedBy).PlaySound(Sound'MH_A_V2.HitsoundTeam', SLOT_Interface, HitVolume, False);
//				PlayerPawn(InstigatedBy).PlaySound(Sound'MH_A_V2.HitsoundTeam', SLOT_Interact, HitVolume, False);
			}
			if( ScriptedPawn(Victim) != None )  // When player shoots a monster
			{// Cows and rabbits are friends - Nah, Rabbits are stupid trash with Hate attitude in case you messed something.
				if (Cow(Victim) != None || Nali(Victim) != None)
				{
					InstigatedBy.PlaySound(Sound'MH_A_V2.HitsoundTeam',SLOT_Interact,4 * HitVolume, False);
	//				PlayerPawn(InstigatedBy).PlaySound(Sound'MH_A_V2.HitsoundTeam', SLOT_Interface, HitVolume, False);
	//				PlayerPawn(InstigatedBy).PlaySound(Sound'MH_A_V2.HitsoundTeam', SLOT_Interact, HitVolume, False);
				}
				else // ScriptedPawn is an enemy
				{
					InstigatedBy.PlaySound(Sound'MH_A_V2.HitsoundEnemy',SLOT_Interact,4 * HitVolume, False);
	//				PlayerPawn(InstigatedBy).PlaySound(Sound'MH_A_V2.HitsoundEnemy', SLOT_Interface, HitVolume, False);
	//				PlayerPawn(InstigatedBy).PlaySound(Sound'MH_A_V2.HitsoundEnemy', SLOT_Interact, HitVolume, False);
				}
			}
		}
	}

	if ( ActualDamage > 0 && Victim != None && InstigatedBy != None )
	{
		lolattacktime = 0;
		if ( ScriptedPawn(Victim) != None && ( Nali(Victim) == None || Cow(Victim) == None ) && ScriptedPawn(InstigatedBy) == None && Victim.Health > 0 )
		{
/*
			if ( FRand() > 0.6 ) //40% chances to respond at any attack from other pawn than monster
			{
				ScriptedPawn(Victim).AttitudeTo(InstigatedBy) == ScriptedPawn(Victim).AttitudeToPlayer;
				ScriptedPawn(Victim).Hated = InstigatedBy;
				ScriptedPawn(Victim).Enemy = InstigatedBy;
			}
*/
			Momentum.z *= 0.3;
			Momentum.x *= 0.3;
			Momentum.y *= 0.3;
			if (string(DamageType)=="RedeemerDeath")
			{
//				Velocity = Vect(0,0,0);
				Victim.Velocity = Victim.Velocity * 0.3;
			}
		}
		if (ScriptedPawn(Victim) != None )
		{
			if ( Victim.Region.Zone.bWaterZone )
			{
				if (!ScriptedPawn(Victim).bGreenBlood)
					bp = Spawn(class'NSBloodPuff',,,HitLocation/*,rotator(Momentum)*/);
				else
					gb = Spawn(class'NSGreenBloodPuff',,,HitLocation/*,rotator(Momentum)*/);
			}
			else
			{
				b = Spawn(class'ExBloodSpurt',,,HitLocation,rotator(Momentum));
				if (ScriptedPawn(Victim).bGreenBlood && b != None)
					b.GreenBlood();
			}
		}
		if ( FlockPawn(Victim) != None && ActualDamage >= Victim.Health ) //Show stupid kill messages and do normal call to KILLED...
		{
			if ( MH2 != None )
				MH2.Killed(InstigatedBy,Victim,damageType);
		}
		if((ScriptedPawn(Victim) != None && Nali(Victim) == None && Cow(Victim) == None) && ( ScriptedPawn(InstigatedBy) != None
		&& ( ScriptedPawn(InstigatedBy).TeamTag == ScriptedPawn(Victim).TeamTag ) && (Victim != InstigatedBy)))
			ActualDamage = 0;

		//Log("Dam:"@ActualDamage@"victim "@Victim.name@"instigatedby"@InstigatedBy.name@" dam type:"@DamageType);
		if(( PlayerPawn(Victim) != None || Bot(Victim) != None ) && PlayerPawn(InstigatedBy) != None && Victim != InstigatedBy
			&& bUseWarnTeamDamage && InstigatedBy.PlayerReplicationInfo.Team == Victim.PlayerReplicationInfo.Team)
		{// InstigatedBy > killer  Victim > killed
		  //danger
			if ( TournamentPlayer(InstigatedBy) != None )
				InstigatedBy.ReceiveLocalizedMessage( class'NSMH_AGKMessage',Victim.Health - ActualDamage, Victim.PlayerReplicationInfo );

			//BroadCastMessage("Dam: victim"@ActualDamage@Victim.PlayerReplicationInfo.PlayerName@"instigatedby"@InstigatedBy.PlayerReplicationInfo.PlayerName@DamageType);
			if(Victim.Health - ActualDamage<= 0 && Victim != InstigatedBy)
			{
			   Log("TK? :(dam:"@ActualDamage@")killed"@Victim.PlayerReplicationInfo.PlayerName@"killer"@InstigatedBy.PlayerReplicationInfo.PlayerName@"type:"@DamageType);
				if ( TournamentPlayer(Victim) != None || Bot(Victim) != None )
				{
					foreach AllActors (class 'TournamentPlayer',P,'aMH')
						P.ReceiveLocalizedMessage( class'NSMH_AGKMessage',9999, InstigatedBy.PlayerReplicationInfo );
				}
				if ( TournamentPlayer(InstigatedBy) != None )
					InstigatedBy.ReceiveLocalizedMessage( class'NSMH_AGKMessage',Victim.Health - ActualDamage, Victim.PlayerReplicationInfo );
			}
		}
	}
JL2549:
	Super.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);
}

function ModifyPlayer(Pawn Other)
{
	local Weapon W;
	local Triggerator T;
	local AlignSPP Ali;
	local bool bHasHandler,bHasAligner;

// First player joined - if start to trigger something won't mess replacing pawns any more - Factories are attacked already
	if (bReplaceThem)
		bReplaceThem = False;
// So it was done - I have no timer for this deal - Moved into outside
	if ( Other.PlayerReplicationInfo != None )
	{
		if ( NP != None )
			OLDNP = NP;
		NP = Other;
		Other.Health = DefaultHealth; //Here we try other trick but I advice you to not use freaks, will crash replication
		if ( stopPlayerCollision )
			Other.SetCollision(True,True,False);
		else
			Other.SetCollision(True,True,True);
		if ( Other.PlayerReplicationInfo.Team == 0 )
		{
			Other.Tag = 'aMH';
//			log ( Other.GetHumanName()$" has Tag "$Other.Tag );
		}
	}

	if (bUseCoopTranslocator)
	{
		if ( TournamentPlayer(Other) != None )
		{
			W = Spawn(TranslocatorClass,Other.Owner,Other.Tag,Other.Location,Other.Rotation);	//We need a Coop Game... 
//			TournamentPlayer(Other).ClientSetMusic( Music'null48.null48', 0, 255, MTRAN_Fade);
		}
		if ( W != None )
		{
			W.RespawnTime = 0;
			W.Touch(Other);
		}
	}
	Super.ModifyPlayer(Other);
	if (!bHaveXC)
	{
		if ( PlayerPawn(Other) != None && !Other.bHidden )
		{
			foreach Other.ChildActors(class 'Triggerator', T)
			{ bHasHandler=True; }
			if ( Level.NetMode != NM_StandAlone )
			{
				if ( !bHasHandler )
					T = Spawn(class'Triggerator',Other);
			}
		}
	}
}

function GiveWeapon(Pawn PlayerPawn, class<TournamentWeapon> WeaponClass )
{
	local Weapon NewWeapon;	//hm, I'm not sure if is used, I have a bit different formula for "men"

	if( PlayerPawn.FindInventoryType(WeaponClass) != None )
		GoTo JL2626;
	newWeapon = Spawn(WeaponClass);
	if( newWeapon != None )
	{
		newWeapon.RespawnTime = 0.0;
		newWeapon.Touch(PlayerPawn);
		if ( !newWeapon.IsA('ImpactHammer') && !newWeapon.IsA('Translocator') ) {
			newWeapon.GiveAmmo(PlayerPawn);
		newWeapon.AmmoType.AmmoAmount = newWeapon.AmmoType.MaxAmmo*2;
		}
	}
JL2626:
}

/*
function UTES_CInfo FindPlayerRI(Pawn P)
{
	local UTES_CInfo Link;
	if ( P == none )
		return none;
	foreach AllActors (class'UTES_CInfo',Link,'cFL')
//	For ( Link=Linked ; Link!=none ; Link=Link.LinkNext )
		if ( Link.PlayerOwner == P )
		{
			return Link;
			break;
		}
}
*/

function bool PreventDeath (Pawn Killed, Pawn Killer, name DamageType, Vector HitLocation)
{
	local Actor T;
	local int i;
	local Pawn P;
	local ScriptedPawn S;
	local Projectile Pj;
//	local UTES_CInfo RI_k, RI_v;

	if ( Killed != None )
	{
/*
		if (bUseEScoreBoard)
			RI_v = FindPlayerRI( Killed);
		if ( Killer != None && bUseEScoreBoard )
		{
			RI_k = FindPlayerRI( Killer);
			if (damageType == 'Gibbed' && damageType != 'RedeemerDeath')
				if ( RI_k != None )
					RI_k.Telefrags += 1;
			if ( (Killer != none ) && ( Killer == Killed ) ) //Logic -> killer=victim > we have victim info
				if ( RI_v != None )
					RI_v.Suicides += 1;
			if ( damageType == 'Decapitated' && Killer != Killed )
				if ( RI_k != None )
					RI_k.Headshots += 1;
		}
*/
		if ( !Killed.bIsPlayer ) //Eh...
		foreach AllActors ( class 'Projectile',Pj )
		{
			if ( Pj.Instigator != None && Pj.Instigator == Killed )
			{
				Pj.bReplicateInstigator = False;
				Pj.Destroy();
			}
		}
		if ( Killed != Killer && Killer != None
			&& !Killed.Region.Zone.bPainZone && !Killed.Region.Zone.bKillZone )
			DiscardInventory(Killed); //Simple bullshit without bHeldItem stupidity for everybody
		foreach AllActors (class'Pawn',P)
		{
			if ( ScriptedPawn(P) != None && P != Killed && Killed.PlayerReplicationInfo != None && ScriptedPawn(P).Enemy == Killed )
			{
				if ( ( NP == None || ( NP != None && NP == Killed) ) && OLDNP != None )
					NP = OLDNP;
				if ( NP != None )
				{
					ScriptedPawn(P).Enemy = NP;
					ScriptedPawn(P).Hated = NP;
					ScriptedPawn(P).Target = NP;
				}
			}
		}
		if ( Killed.PlayerReplicationInfo == None )
		{
			foreach Killed.RadiusActors (class'Actor', T, 700)
			{
				if (T != None)
				{
					for (i=0;i<4;i++)
					{
					if (T.Touching[i] == Killed && !T.IsA('Mover'))
						T.UnTouch( Killed );
					}
					if (T.IsA('Mover') && Mover(T).Instigator != None && Mover(T).Instigator == Killed && !Mover(T).bTriggerOnceOnly && Mover(T).Tag != Killed.Event )
					{
						Mover(T).UnTrigger(Killed,Instigator);
						if ( Mover(T).bOpening )
								Mover(T).DoClose();
					}
				}
			}
			Killed.GoToState('Dying');
			return False; //Do not prevent anything... Just fucking die, right now!
		}
	}
	return Super.PreventDeath(Killed,Killer,DamageType,HitLocation);
}

function DiscardInventory (Pawn Other)
{
	local Actor dropped;
	local Inventory Inv;
	local class<Weapon> Initial1;
	local class<Weapon> Initial2;

	if (Other != none)
	{
// This is already called in GameInfo > imported to our controller for replacement reasons
/*		if ( Other.DropWhenKilled != None )
		{
			dropped=Spawn(Other.DropWhenKilled,,,Other.Location);
			Inv=Inventory(dropped);
			if ( Inv != None )
			{
				Inv.RespawnTime=0.00;
				Inv.BecomePickup();
			}
			if ( dropped != None )
			{
				dropped.NetPriority = 1.400000;
				dropped.NetUpdateFrequency = 10.000000;
				dropped.RemoteRole = ROLE_DumbProxy;
				dropped.SetPhysics(PHYS_Falling);
				dropped.bCollideWorld=True;
				dropped.Velocity=Other.Velocity + VRand() * 280;
			}
			if ( Inv != None )
				Inv.GotoState('Pickup','dropped');
		}
*/
	Inv=Other.Inventory;
	Loop1:
		if ( Inv != None )
		{
			if ( Inv.IsA('Weapon') )
			{
				if ( (Inv.Class != Level.Game.BaseMutator.MutatedDefaultWeapon()) && ((Weapon(Inv).AmmoType == None) || (Weapon(Inv).AmmoType.AmmoAmount > 0)) && Weapon(Inv).bCanThrow)
				{
					if (Inv.class != class'MHDispersionPistol' /*&& Inv.Class != class'DoubleEnforcer'*/) //Doh...
					DropWeapon(Other,Inv);
				}
			}
			Inv.Destroy();
			Inv=Inv.Inventory;
			goto Loop1;
		}
	}
}

function DropWeapon (Pawn Other, Inventory Inv)
{
	local Inventory DropInv;
	local int DropPitch;
	local int DropYaw;
	local Rotator DropRot;

	DropInv=Spawn(Inv.Class,,,Other.Location);
	if ( DropInv == None )
		GoTo JL2796;
	DropRot=Other.ViewRotation;
	DropPitch=Rand(32768);
	DropYaw=Rand(65536);
	DropRot.Pitch=DropPitch;
	DropRot.Yaw=DropYaw;
	Weapon(DropInv).bWeaponStay = false;
	DropInv.Velocity=vector(DropRot) * (Rand(250) + 250);
	DropInv.RespawnTime=0.00;
	DropInv.BecomePickup();
	DropInv.NetPriority = 1.400000;
	DropInv.NetUpdateFrequency = 10.000000;
	DropInv.RemoteRole = ROLE_DumbProxy;
	DropInv.SetPhysics(PHYS_Falling);
	DropInv.bCollideWorld=True;
	DropInv.GotoState('Pickup','dropped');
	DropInv.LifeSpan=180.000000; //We don't want a million thrown, right ? If have an owner I'll put back default
JL2796:
}

function Pawn GetRandomPlayer()
{
	local Pawn N, Dest, Candidate[32];
	local int num, Chosen;
	num = 0;
	Chosen = 0;

	if ( !bPowerXC )
	{
		foreach AllActors(class'Pawn',N)
		{
			if ( N != None )
			{
				if (  N.PlayerReplicationInfo != None && N.Health > 0 && N.Weapon != None && N.PlayerReplicationInfo.Team == 0 ) //Any kinda Spectator I'm guessing does not has weapons in end...
				{
					Dest = N; //Assign a Pawn
					if ( num < 32 ) //Must be in list with players.
						Candidate[num] = Dest; //Add to array.
					Dest = None; //Array loaded, release slot...
//					else if (Rand(num) < 32) Candidate[Rand(32)] = Dest; //What the heck is this ? Useless Mumbo Jumbo !
					num++; //Increase array count for next possible player
				}
			}
		}
	}
	else
	{
		foreach AllActors(class'Pawn',N)
		{
			if ( N != None )
			{
				if (  N.PlayerReplicationInfo != None && N.Health > 0 && N.Weapon != None && N.PlayerReplicationInfo.Team == 0 ) //Any kinda Spectator I'm guessing does not has weapons in end...
				{
					Dest = N; //Assign a Pawn
					if ( num < 32 ) //Must be in list with players.
						Candidate[num] = Dest; //Add to array.
					Dest = None; //Array loaded, release slot...
//					else if (Rand(num) < 32) Candidate[Rand(32)] = Dest; //What the heck is this ? Useless Mumbo Jumbo !
					num++; //Increase array count for next possible player
				}
			}
		}
	}
	if(num == 0) return None; //None if 0 people are playing
	Chosen = Rand(num); //Get a random 
	//return Candidate[Rand(Min(32,num))]; //I don't really like these
	return Candidate[Chosen]; //And Simply return that Random
}

function GiveAmp (Pawn P)
{
	local MHUDamage dam;
	if( (P.FindInventoryType(class'MHUDamage') != None) || ( P.Health < 1 ) )
		GoTo JL2839;
	dam = spawn(class'MHUDamage',P,,P.Location);
	if( dam != None )
	{
		dam.RespawnTime = 0.0;
		dam.Touch(P); //I think will Initialize Native, right ? Tell me when damage was not automatically activated.
	}
JL2839:
}

function GiveRedeemer (Pawn P)
{
	local NSWarheadLauncher rede;
	local Inventory Inv;

	if (P.Health > 0)
	{
		rede = Spawn(Class'NSWarheadLauncher',P,,P.Location);
		if ( rede != None )
		{
			rede.RespawnTime = 0;
			rede.Touch(P);
		}
	}
}

function GiveHealth(Pawn PlayerPawn)
{
	if ( PlayerPawn.Health > 0 )
		PlayerPawn.Health += 500;
	else PlayerPawn.Health += 0;
}

function bool HandlePickupQuery(Pawn Other, Inventory item, out byte bAllowPickup)
{
	local bool result;

//Prevent anti-retarded Epic type pickup
	if ( Level.Game.bGameEnded ) //In this case we don't give a shit on pickups, fucking fagitrons...
		return True;
	if ( MH2 != None && !MH2.bStartedHunt ) return True; //And not even before to start game
//Updated June-18-2016
	if ( Item != None )
		if ( Item.MyMarker == None && Item.LifeSpan != Item.Default.LifeSpan)
		{
			Item.LifeSpan = Item.Default.LifeSpan;
		}

	if ( NextMutator != None )
		result = NextMutator.HandlePickupQuery(Other, item, bAllowPickup);
	return result;
}

function Mutate(string MutateString, PlayerPawn Sender)
{
	local NsWayPoint NW;
	local MonsterEnd2 En;
	local bool ordered, bSetDest, bAbusing;
	local Actor Path;
	local color clMsg;
	local NsWay W;
	local Actor XCM;

	Super.Mutate(MutateString, Sender);

	if ( MutateString ~= "help" )
	{
		Sender.ClientMessage("There are available certain commands at TAB or console ~ for any player:");
		Sender.ClientMessage("<mutate version> will show game-type used.");
		Sender.ClientMessage("<mutate ai> will show or hide WayPoints (used by Bots) and even us ;).");
		Sender.ClientMessage("You can use <ShowPath> command after <mutate ai> in well pathed maps.");
		Sender.ClientMessage("<mutate perf> will show Level.AIprofile variable(s).");
		Sender.ClientMessage("<mutate help> is showing current help about mutate commands.");
	}

	if ( MutateString ~= "version" )
		Sender.ClientMessage("MH_A_V2 - Monster Hunt !", 'CriticalEvent', True);
/*
	if ( MutateString ~= "dmesh")
	{
		Sender.ClientMessage("Request detected for XC dynamic mesh dump !", 'CriticalEvent', True);
		foreach AllActors (XC_Class,XCM)
		{
			log (XCM$" has owner "$Owner.GetHumanName()$" at location "$XCM.Location$" with Owner at "@Owner.Location);
		}
	}
*/
	if ( MutateString ~= "ai")
	{
		if ( NsTournamentPlayer(Sender) == None )
		{
			Sender.ClientMessage("Test-Player is disabled, set bOtherPlayer=True", 'CriticalEvent', True);
			GoTo JL3091;
		}
		if ( bNoTest )
		{
			Sender.ClientMessage("Testing is disabled, set bNoTest=False", 'CriticalEvent', True);
			GoTo JL3091;
		}
		ordered = False;
		foreach AllActors (class 'NsWayPoint', NW)
			{
			if (NW != None)
				Ways++;
			}

		if (Ways == 0)
		{
			Sender.ClientMessage("In this map not exists any Waypoint...", 'CriticalEvent', True);
			BroadcastMessage(Sender.GetHumanName()@"noticed 0 WayPoints.");
		}
		else if (Ways > 0)
		{
		foreach AllActors (class 'NsWayPoint', NW)
		{
			if (NW != None)
			{
				if (NW.bHidden)
				{
					NW.bHidden = False;
					if (!ordered)
					{
						Sender.ClientMessage("WayPoints are visible now.", 'CriticalEvent', True);
						BroadcastMessage(Sender.GetHumanName()@"requested visible WayPoints.");
						ordered = True;
					}
				}
/*				else if (!NW.bHidden)
				{
					NW.bHidden = True;
					if (!ordered)
					{
						Sender.ClientMessage("WayPoints are invisible now.", 'CriticalEvent', True);
						BroadcastMessage(Sender.GetHumanName()@"requested invisible WayPoints.");
						ordered = True;
					}
				}
*/
			}
		}
		}
//==== Small bot feature copied to humans updated at player request
//==== Player can type ShowPath in console if doesn't have RememberSpot defined - noobs don't know this anyway
//	log (Sender.GetHumanName()$"'s destination was "$P.Destination);
	if ( Ways > 0 )
	{
		foreach AllActors (class 'NsWayPoint',NW)
		{
			if ( !NW.bVisited && NW.Position == MH2.LastPt + 1 )
			{
				Sender.Destination = NW.Location;
				if (bMHLog)
					log ( "Assigned a Destination for player "$Sender.GetHumanName()$" which means "$NW$" with Position "$NW.Position );
				Sender.ClientMessage ("You have requested a Destination at "$NW$" Position "$NW.Position$" placed at "$NW.Location );
				bSetDest = True;
			}
		}
	}
	if (!bSetDest)
	{
		foreach AllActors (class 'MonsterEnd2',En)
		{
			if ( En != None && !bSetDest)
			{
				Sender.Destination = En.Location;
				if (bMHLog)
					log ( "Assigned a Destination for player "$Sender.GetHumanName()$" at "@En );
				Sender.ClientMessage ( "You have requested a Destination at "@En@" placed at "$En.Location );
				bSetDest = True;
			}
		}
	}
	if (!bSetDest) //Still lost ? Sorry...
	{
		if (bMHLog)
			log ( "Cannot assign a Destination for player "$Sender.GetHumanName() );
	}
	foreach Sender.ChildActors (class'NsWay',W)
	{
		if ( W != None )
		{
			bAbusing = True;
			break;
		}
	}
	if (bAbusing)
	{
		Sender.ClearProgressMessages();
		Sender.SetProgressMessage("Mr. Bot, Your beacon has already spawned... If you don't see it wander around and retry later...",1);
		clMsg.R=255;
		clMsg.G=255;
		clMsg.B=120;
		Sender.SetProgressColor(clMsg,1);
		Sender.SetProgressTime(3);
	}
	else
	{
		Path = NsTournamentPlayer(Sender).FindPathTo(NsTournamentPlayer(Sender).Destination);
		if ( Path != None )
		{
			if ( Teleporter(Path) != None && Sender.RouteCache[2] != None )
			{
				if (!Sender.LineOfSightTo(Sender.RouteCache[2]))
				{
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Next isn't visible...",1);
					clMsg.R=200;
					clMsg.G=200;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(3);
					Path = Sender.RouteCache[2];
				}
			}
			W = Spawn(class'NsWay',Sender,,Path.Location);
			if ( W != None )
			{
				W.Path = Path;
				if ( Path.Base != None )
					W.SetBase(Path.Base);
				else
					W.SetBase(None);
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Your Hunting-Way is shown. See the lamp and move there...",1);
				clMsg.R=0;
				clMsg.G=255;
				clMsg.B=64;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(3);
			}
			else
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Cannot deal this time...",1);
				clMsg.R=240;
				clMsg.G=0;
				clMsg.B=0;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(3);
			}
		}
		else
		{
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("Unable to find your Hunting-Way. Wander at walls then...",1);
			clMsg.R=250;
			clMsg.G=0;
			clMsg.B=0;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(3);
		}
	}
	ordered = False;
	bSetDest = False;
	Ways = 0;
	}

	if ( MutateString ~= "perf" )
	{
		Sender.ClientMessage ( "You have requested a Level.AIProfile variables" );
		Sender.ClientMessage ( "Level.AIProfile[0] ="@Level.AIProfile[0]@"Level.AIProfile[1] ="@Level.AIProfile[1] );
		Sender.ClientMessage ( "Level.AIProfile[2] ="@Level.AIProfile[2]@"Level.AIProfile[3] ="@Level.AIProfile[3] );
		Sender.ClientMessage ( "Level.AIProfile[4] ="@Level.AIProfile[4]@"Level.AIProfile[5] ="@Level.AIProfile[5] );
		Sender.ClientMessage ( "Level.AIProfile[6] ="@Level.AIProfile[6]@"Level.AIProfile[7] ="@Level.AIProfile[7] );
	}
JL3091:
}

function fixmovers()
{
	local Mover M;
	local name Grp;
	local Trigger T;
	local Counter Cr;
	local Dispatcher Ds;
	local ScriptedPawn S;
	local int i;

	foreach AllActors(class 'Mover', M)
	{
		if (M != None)
		{
			if ( M.StayOpenTime > AllowedOpen )
			{
				M.bTriggerOnceOnly = True;
				M.StayOpenTime=AllowedOpen/10; //Duh
				if (bMHLog)
					log ("Mover"@M@"looks meant to Stay Opened"@M.StayOpenTime@"- bTriggerOnceOnly modification value > "@M.bTriggerOnceOnly);
			}
			if (bTweakGroup)
			if (M.InitialState == 'TriggerOpenTimed' && M.Group == M.default.Group)
			{
				M.Group = M.Name;
				if (bMHLog)
					log ("Mover"@M@"has been set for group"@M.Group);
			}
			M.NetUpdateFrequency = 10.000000;
//			log ("Mover "@M@" updated to frequency "@M.NetUpdateFrequency);
//			log ("Mover "@M@"has been updated to bDynamicLightMover ="@M.bDynamicLightMover);
			if (M.MoverEncroachType == ME_CrushWhenEncroach && !M.bTriggerOnceOnly && M.BumpType != BT_PawnBump )
			{
				if (bMHLog)
					log ("Mover"@M@" is crusher. Demanding Pawn kill.");
				M.BumpType = BT_PawnBump;	//If I was killed why Bot need to not be killed, even is blocked, fag ?
				if (M.EncroachDamage <= 0)
					M.EncroachDamage = 5000000;
			}
			if (bDoPawnOpen)
			{
				foreach AllActors (class 'Trigger', T)
				{
					if ( T != None && T.Event == M.Tag )
					{
						if ( T.TriggerType == TT_ClassProximity && bReplaceMonsters )
						{
//						if (!ClassIsChildOf(SpawnClass, class'NsTournamentPlayer'))
							if ( ClassIsChildOf(T.ClassProximityType,class'ScriptedPawn') )
							{
								if (bMHLog)
									log (T@" is set for trigerring by"@T.ClassProximityType@"will be modified due to replacements required.");
								T.ClassProximityType = class'UnrealShare.ScriptedPawn';
							}
						}
						if(!M.bTriggerOnceOnly && T.InitialState == 'NormalTrigger' && !T.bTriggerOnceOnly)
							if (T.TriggerType == TT_PlayerProximity)
							{
								if (bMHLog)
									log ("Mover"@M@"looks meant for Player. Demanding Proximity changed.");
								T.TriggerType = TT_PawnProximity;
							}
					}
				}
			}
			foreach AllActors (class 'Counter', Cr)
			{
				if ( Cr != None && M.InitialState == 'TriggerControl' && Cr.Event == M.Tag )
				{
					if (bMHLog)
					{
						log ("Mover "$M$" is just shit with "$M.InitialState$". Will attack InitialState and Encroaching method to avoid other error.");
						log ("Being triggered by "$Cr$" with Event "$Cr.Event$", will be properly set.");
					}
					M.InitialState = 'TriggerOpenTimed'; M.MoverEncroachType = ME_IgnoreWhenEncroach; M.bTriggerOnceOnly = True;
				}
			}
			foreach AllActors (class 'ScriptedPawn', S)
			{
				if ( S != None && M.InitialState == 'TriggerControl' && S.Event == M.Tag )
				{
					if (bMHLog)
					{
						log ("Mover "$M$" is just shit with "$M.InitialState$". Will attack InitialState and Encroaching method to avoid other error.");
						log ("Being triggered by "$S$" without to mind console, will be properly set.");
					}
					M.InitialState = 'TriggerOpenTimed'; M.MoverEncroachType = ME_IgnoreWhenEncroach; M.bTriggerOnceOnly = True;
				}
			}
			foreach AllActors (class 'Dispatcher', Ds)
			{
				if ( Ds != None )
				{
					for (i=0;i<8;i++)
					{
						if ( Ds.OutEvents[i] == M.Tag && M.InitialState == 'TriggerControl' )
						{
							if (bMHLog)
							{
								log ("Mover "$M$" is just shit with "$M.InitialState$". Will attack InitialState and Encroaching method to avoid other error.");
								log ("Being triggered by "$Ds$" having event OutEvents["$i$"]: "$Ds.OutEvents[i]$", without to mind console, will be properly set.");
							}
							M.InitialState = 'TriggerOpenTimed'; M.MoverEncroachType = ME_IgnoreWhenEncroach; M.bTriggerOnceOnly = True;
						}
					}
				}
			}
			
			if ( M.bTriggerOnceOnly )
			{
				if (M.MoverEncroachType == ME_ReturnWhenEncroach)
				{
					M.MoverEncroachType = ME_IgnoreWhenEncroach;
					if (bMHLog)
						log ("Detected & Resolved a Mover Triggered Once With ReturnWhenEncroach >> "@M.name);
				}
				if ( M.InitialState == 'TriggerControl' )
				{
					if (bMHLog)
					{
						log ("Ass ? A mover with TriggerControl shouldn't be set bTriggerOnceOnly >> "@M.Name);
						log ("Attempt to fix mover state >> "@M.Name@" to TriggerOpenTimed.");
					}
					M.InitialState = 'TriggerOpenTimed';
					if (bMHLog)
					{
						if ( M.InitialState == 'TriggerOpenTimed' )
							log ("Successfully fixed.");
						else
							log ("Fixing failed !!!");
					}
				}
			}
			if (bFixGrabCmd)
			if ( M.bUseTriggered == True )
			{
				M.bUseTriggered = False;
				if (bMHLog)
					log ("Detected & Resolved a Mover to not be cheated by GRAB command >> " @M.name);
			}
			if (bMHLog)
				if (M.bDamageTriggered)
					log(M@" >> is damage triggered");
			if (bDoCrushMover)
			if (!M.bTriggerOnceOnly && M.MoverEncroachType == ME_ReturnWhenEncroach)
			{
				M.MoverEncroachType = ME_CrushWhenEncroach; //Camping under lifts bad idea for lamers :P
				M.EncroachDamage = 5000000;
				if (bMHLog)
					log ("Detected & Resolved a Mover to not be turned back without to suffer a big damage >> "@M.name);
			}
			if (!M.bTriggerOnceOnly && M.DelayTime == 0 && M.InitialState != 'TriggerControl')
			{
				if (bMHLog)
					log ("Mover"@M@" will have delay...");
				M.DelayTime = md; //Expect some ping reaction for NetworkPlay
			}
			if (bDoPawnOpen)
			if (!M.bTriggerOnceOnly && M.BumpType == BT_PlayerBump && ( M.InitialState == 'StandOpenTimed' || M.InitialState == 'BumpOpenTimed' || M.InitialState == 'BumpButon'))
			{
				if (bMHLog)
					log ("Mover"@M@"will be activated by any Pawn.");
				M.BumpType = BT_PawnBump; //Enhanced mover, LOL, monsters will use it to hunt you back :P
			}
		}
	}
}

function bool ReplaceWith(actor Other, string aClassName) //reworking this stupid one for different reasons
{
	local Actor A;
	local class<Actor> aClass;
	local Pawn P;
	local Weapon W;
	local Rotator DropRot;
	local bool bMarked;
	local float ORadius, OHeight;

//	log ("Attempt replacing "$Other$" at "$GetAbsoluteTime());
	if ( Other.IsA('Inventory') && (Other.Location == vect(0,0,0)) )
		return false;
//Add-ons - Save primary collision and reduce manure to not mess the newer
	ORadius = Other.CollisionRadius;
	OHeight = Other.CollisionHeight;
	Other.SetCollisionSize(1,1);
//End Adds
	aClass = class<Actor>(DynamicLoadObject(aClassName, class'Class'));
	if ( aClass != None ) //Yes, checking if class can be used into "sand-box". Probably someone has sand-box often at lunch :P
	{
		aClass.Default.bCollideWhenPlacing = False;
		A = Spawn(aClass,Other.Owner,Other.tag,Other.Location+vect(0,0,1),Other.Rotation); //Not sure if this really works properly for monsters
	}
	if ( Other.IsA('Inventory') && A != None ) //Presume inventory and do not touch it if new thing is missing - POSSIBLE !!!
	{
		if ( Inventory(Other).MyMarker != None ) //Check for it if is marked as part of a path placed in map 
		{
			Inventory(Other).MyMarker.markedItem = Inventory(A); //Try to mark New thing
			if ( Inventory(A) != None ) //Is inventory ?
			{
				Inventory(A).SetCollisionSize(1,1); //SMALL!
				Inventory(A).MyMarker = Inventory(Other).MyMarker; //copy data from old thing
				A.SetLocation(Other.Location+vect(0,0,1)); //Meh...
				bMarked = True;
/*
				A.SetLocation(A.Location 
					+ (A.CollisionHeight - Other.CollisionHeight) * vect(0,0,1)); //move it a lil
*/
				Inventory(A).bRotatingPickup=Inventory(Other).bRotatingPickup;
				Inventory(A).RespawnTime=Inventory(Other).RespawnTime;
			}
			Inventory(Other).MyMarker = None; //remove marker from old - it will be destroyed soon
		}
// To work here - Time to examine if this crap is not spawned by monster or a stupid WoodenBox - thanks for Accesed Nones
		else if ( A.IsA('Inventory') && Inventory(Other).Instigator != None
			&& Inventory(Other).Instigator.bIsPawn && Vsize(A.Location-Other.Instigator.Location) <= A.CollisionRadius ) //Modification in here - Checking if has a Pawn Instigator
		{
			Inventory(A).Respawntime = 0.0;	//Agree ONLY if belongs to a PAWN, morons !
			Inventory(A).bHeldItem = True;	//Yes is held, else I promise it will be held very soon...
			if (Inventory(A).IsA('Weapon'))
			{
				W = Weapon(Inventory(A)); //We speak about weapon - Not Very TournamentWeapon ?
				W.PickupMessageClass = Class'Botpack.PickupMessagePlus'; //Made sure of good things :D
				if ( Other.Instigator.Health > 0 )
				{
					P = Other.Instigator; //describe instigator if exist anyone alive
					W.Instigator = P; //Let me see this, assign instigator copying it from old thing
					if ( P.FindInventoryType(aClass) == None ) //This guy owns new thing or... timing went wrong so is unarmed ?
					{
//						log ("Found Instigator Pawn "$P$" for "$Inventory(A)$" as replacement for "$Other$"."); //LOLz, it just failed weapon
						if (!P.bIsPlayer) //Fix it to gain stuff if is not a good one
							P.bIsPlayer=True;
						W.Touch(P); //Then call properly original pawn code used before to screw with replacement - probably will end bIsPlayer carrer - else awaiting timer to manage shite
					}
				}
			}
		}
// Will check if still bug me. No, it looks fine.
		else // YAY - now probably 0 pawn spawned this thing, or is just dropped, or is some Decoration Content - time to end bullshit
		{
			if ( !bMarked && Other.Owner == None && MH2.bStartedHunt)
			{
				Inventory(A).RemoteRole = ROLE_DumbProxy; //is indeed something felt - no marker, remember ? No waste resources.
				Inventory(A).bCollideWorld = True; //Do not fall into void
				DropRot = Other.Rotation;
				DropRot.Pitch = Rand(32768);
				DropRot.Yaw = Rand(65536);
				Inventory(A).Velocity = vector(DropRot) * RandRange(250,301);
				Inventory(A).Velocity.Z = RandRange(250,451);
				Inventory(A).SetPhysics(PHYS_Falling); //because you will fall
				Inventory(A).GotoState('Pickup', 'Dropped'); //And you're a pathetic pickup in end
//				log (Other$" spawned at "$Other.Location$" having RespawnTime "$Inventory(Other).RespawnTime);
				if ( MH2.bHaveASpawn )
				{
					Inventory(A).RespawnTime = 0.00; //do not respawn shit dropped by pawns - could be a bunch messing up around
				}
				else
					Inventory(A).RespawnTime = Inventory(Other).RespawnTime;
			}
			else
			{
				if ( Other.Owner != None && Other.Owner.bIsPawn )
				{
					log ("Detected a spawn "$Other$" with Owner "$Other.Owner$". Inventory will be set.");
					P = Pawn(Other.Owner);
					if ( Inventory(A).IsA('Weapon'))
					{
						W = Weapon(Inventory(A));
						W.ReSpawnTime = 0.0;
						W.BecomeItem(); //Do not mess anims
						W.Instigator = P;
						P.AddInventory(W);
						W.GiveAmmo(P);
						W.WeaponSet(P);
					}
				}
			}
		}
	}
	else
	{
		if (bMHLog)
			log (Other$" looks like shit placed at "$Other.Location$". Bye !!!");
		Other.SetCollisionSize(ORadius,OHeight); //put back the shit if new couldn't spawn here here
	}
	if ( A != None )
	{
		if ( Inventory(A) != None && Inventory(A).MyMarker != None )
			A.SetCollisionSize(ORadius,OHeight);
		A.event = Other.event;
		A.tag = Other.tag;
		A.RotationRate = Other.RotationRate;
		A.bFixedRotationDir = Other.bFixedRotationDir;
		if ( Other.Base != None )
			A.SetBase(Other.Base);
//		log ( Other$" is now "$A );
		return true;
	}
	return false;
}

function bool ReplaceWithOther(actor Other, string aClassName)
{
	local Actor A;
	local class<Actor> aClass;
	local inventory O, Alt;
	local Decoration Ot, Al;
	local Pawn P;
	local Weapon W;
	local Rotator DropRot;
	local bool bMarked;
	local float ORadius, OHeight;

//	log("A replacement sequence started at "$Level.Hour$":"$Level.Minute$":"$Level.Second$":"$Level.Millisecond);
	if ( Other.IsA('Inventory') && (Other.Location == vect(0,0,0)) )
		return false;
//	Probably I need a Placement restore in future, in hoping to not throw shit into void attempting to regain a better position 
	ORadius = Other.CollisionRadius;
	OHeight = Other.CollisionHeight;
	Other.SetCollisionSize(1,1);
	aClass = class<Actor>(DynamicLoadObject(aClassName, class'Class'));
	if ( aClass != None )
	{
		if ( Other.bBlockActors );
			Other.SetCollision(False,False,False);
//		aClass.Default.bCollideWhenPlacing = False;
//		aClass.Default.bCollideWorld = False; //Never alter this, will fall into the void
		A = Spawn(aClass,Other.Owner,Other.tag,Other.Location+vect(0,0,1),Other.Rotation);
//		log ("Attempt to replace "@Other);
		if ( A != None && Other.bIsPawn && !Other.bHidden )
		{
			if (Bird2(A) != None && Bird1(Other)!= None)
			{
				Bird2(A).bCircle = Bird1(Other).bCircle;
				Bird2(A).GoalTag = Bird1(Other).GoalTag;
				goto EndFlock;
			}
			if (BiterFishSchool2(A)!=None && BiterFishSchool(Other)!=None)
			{
				BiterFishSchool2(A).bNonAggressive = BiterFishSchool(Other).bNonAggressive;
				BiterFishSchool2(A).fishcolor = BiterFishSchool(Other).fishcolor;
				BiterFishSchool2(A).schoolradius = BiterFishSchool(Other).schoolradius;
				BiterFishSchool2(A).schoolsize = BiterFishSchool(Other).schoolsize;
				BiterFishSchool2(A).StartLocation = BiterFishSchool(Other).StartLocation;
				goto EndFlock;
			}
			if ( NaliRabbit2(A)!= None && NaliRabbit(Other) != None )
			{
				NaliRabbit2(A).bStayClose = NaliRabbit(Other).bStayClose;
				NaliRabbit2(A).WanderRadius = NaliRabbit(Other).WanderRadius;
			}
//Inserting other FlockPawns here if need some
//Copy data, new pawn by default must be without collision or else won't always spawn - walls, other pawns, ect...
EndFlock:
			A.DrawScale = Other.DrawScale;
			A.SetCollisionSize(ORadius*Other.DrawScale/Other.default.DrawScale,OHeight*Other.DrawScale/Other.default.DrawScale);
/*
			if (!A.IsA('FlockMasterPawn'))
				A.SetCollision( True,True,True ); //Asses normal collision
//	Not here ... later. Let all of them to spawn first.
*/
		}
	}
	if ( Inventory(Other)!= None && A != None )
	{
	//Adding a few things - attempt to clone defaults - section 1)
		if (/*Inventory(Other).bIsAnArmor &&*/ Inventory(A).bIsAnArmor)
		{
			O = Inventory(Other);
			Alt = Inventory(A);
			Alt.Mesh = O.Mesh;
			Alt.default.Icon = O.Icon;
			Alt.PickupMessage = O.PickupMessage;
			Alt.default.PickupMessage = O.PickupMessage; //Doesn't help :(
//			log ("Pickup message old is"@O.PickupMessage);
//			log ("Pickup message New is"@Alt.PickupMessage);
			Alt.default.Charge = O.Charge;
			if (O.ArmorAbsorption > 0)
				Alt.default.ArmorAbsorption = O.ArmorAbsorption;
			if (O.ProtectionType1 != '')
				Alt.default.ProtectionType1 = O.ProtectionType1;
//			log ("Check"@O@"has"@O.ProtectionType1);
//			log ("Check"@Alt@"has"@Alt.ProtectionType1);
			if (O.ProtectionType2 != '')
				Alt.default.ProtectionType2 = O.ProtectionType2;
			if (O.AbsorptionPriority > 0)
				Alt.default.AbsorptionPriority = O.AbsorptionPriority;
			Alt.Multiskins[0] = O.Multiskins[0];
			Alt.Multiskins[1] = O.Multiskins[1];
			Alt.Multiskins[2] = O.Multiskins[2];
			Alt.Multiskins[3] = O.Multiskins[3];
			Alt.Multiskins[4] = O.Multiskins[4];
			Alt.Multiskins[5] = O.Multiskins[5];
			Alt.Multiskins[6] = O.Multiskins[6];
			Alt.Multiskins[7] = O.Multiskins[7];
			Alt.Skin = O.Skin;
			Alt.Style = O.Style;
			Alt.bMeshEnviroMap = O.bMeshEnviroMap;
			Alt.bAmbientGlow = O.bAmbientGlow;
			Alt.ScaleGlow = O.ScaleGlow;
			Alt.AmbientGlow = O.AmbientGlow;
			Alt.PickupSound = O.PickupSound;
			Alt.PickupViewMesh = O.PickupViewMesh;
			Alt.PickupViewScale = O.PickupViewScale;
			Alt.MaxDesireability = O.MaxDesireability;
			Alt.ActivateSound = O.ActivateSound;
			Alt.DeActivateSound = O.DeActivateSound;
			Alt.DrawScale = O.DrawScale;
			Alt.SetCollisionSize(ORadius,OHeight); //Put initial cylinder - will see how goes later with DrawScale if is not done yet
		}
		if (/*!Inventory(Other).bIsAnArmor &&*/ !Inventory(A).bIsAnArmor)
		{
			O = Inventory(Other);
			Alt = Inventory(A);
			Alt.Charge = O.Charge;
			if ( MHquadshot(Alt) == None)
			{
				Alt.Mesh = O.Mesh;
				Alt.PickupViewMesh = O.PickupViewMesh;
				Alt.PickupViewScale = O.PickupViewScale;
			}
			Alt.Style = O.Style;
			Alt.PickupMessage = O.PickupMessage;
			Alt.PickupSound = O.PickupSound;
			Alt.Multiskins[0] = O.Multiskins[0];
			Alt.Multiskins[1] = O.Multiskins[1];
			Alt.Multiskins[2] = O.Multiskins[2];
			Alt.Multiskins[3] = O.Multiskins[3];
			Alt.Multiskins[4] = O.Multiskins[4];
			Alt.Multiskins[5] = O.Multiskins[5];
			Alt.Multiskins[6] = O.Multiskins[6];
			Alt.Multiskins[7] = O.Multiskins[7];
			Alt.Skin = O.Skin;
			Alt.Style = O.Style;
			Alt.bMeshEnviroMap = O.bMeshEnviroMap;
			Alt.bAmbientGlow = O.bAmbientGlow;
			Alt.ScaleGlow = O.ScaleGlow;
			Alt.AmbientGlow = O.AmbientGlow;
			Alt.Icon = O.Icon;
			Alt.Texture = O.Texture;
			Alt.MaxDesireability = O.MaxDesireability;
			Alt.ActivateSound = O.ActivateSound;
			Alt.DeActivateSound = O.DeActivateSound;
			Alt.DrawScale = O.DrawScale;
			Alt.SetCollisionSize(ORadius,OHeight);
			if ( MHAsmd(Alt)!=None && ( OLASMD(O)!= None || ASMD(O)!=None ) ) //hack for customized damage
			{
				if (ASMD(O)!=None)
				{
					MHAsmd(Alt).hitDamage = ASMD(O).hitDamage;
					goto ASMDEND;
				}
				if (OLASMD(O)!=None);
					MHAsmd(Alt).hitDamage = ASMD(O).hitDamage;
ASMDEND:
			}
			if ( O.IsA('OLquadshot') && MHquadshot(Alt) != None )
				Alt.SetPropertyText("AmmoName",O.GetPropertyText("AmmoName"));
		}
		//hacked
		//End of added section 1)
		if ( Inventory(Other).MyMarker != None )
		{
//			log (Other$" has marker"@Inventory(Other).MyMarker);
			Inventory(Other).MyMarker.markedItem = Inventory(A);
			if ( Inventory(A) != None )
			{
				Inventory(A).SetCollisionSize(1,1); //SMALL!
				Inventory(A).MyMarker = Inventory(Other).MyMarker;
				A.SetLocation(Other.Location+vect(0,0,1));
				bMarked = True;
/*
				A.SetLocation(A.Location 
					+ (A.CollisionHeight - Other.CollisionHeight) * vect(0,0,1));
*/
				Inventory(A).bRotatingPickup=Inventory(Other).bRotatingPickup;
			}
			Inventory(Other).MyMarker = None;
		}
		else if ( Inventory(A)!=None && Inventory(Other).Instigator != None
			&& Inventory(Other).Instigator.bIsPawn && Vsize(A.Location-Other.Instigator.Location) <= A.CollisionRadius ) // Moment, please... No marker but... anybody spawned this to be holded ?
		{
			Inventory(A).bHeldItem = True;	//Of course, if exist a pawn holder
			Inventory(A).Respawntime = 0.0;	//Else this shit will alter Decorations >:(
			if (Inventory(A).IsA('Weapon'))
			{
				W = Weapon(Inventory(A)); //We speak about weapon - Not Very TournamentWeapon ?
				W.PickupMessageClass = Class'Botpack.PickupMessagePlus'; //Made sure of good things :D
				if ( Other.Instigator.Health > 0 )
				{
					P = Other.Instigator; //describe instigator if exist anyone alive
					W.Instigator = P; //Let me see this, assign instigator copying it from old thing
					if ( P.FindInventoryType(aClass) == None ) //This guy owns new thing or... timing went wrong so is unarmed ?
					{
//						log ("Found Instigator Pawn "$P$" for "$Inventory(A)$" as replacement for "$Other$"."); //LOLz, it just failed weapon
						if (!P.bIsPlayer) //Fix it to gain stuff if is not a good one
							P.bIsPlayer=True;
						W.Touch(P); //Then call properly original pawn code used before to screw with replacement - probably will end bIsPlayer carrer - else awaiting timer to manage shite
						if ( P.PlayerReplicationInfo == None )
						{
							W.SetHand(1);
//							W.AimError += 50;
							W.FireOffset = W.FireOffset * 2 * P.DrawScale;
							W.FireOffset.X = W.Default.FireOffset.X * (P.DrawScale/P.Default.DrawScale) * 4 * P.DrawScale;
							W.FireOffset.Y = W.Default.FireOffset.Y;
							W.FireOffset.Z = W.Default.FireOffset.Z * P.DrawScale;
						}
					}
				}
			}
		}
		else
		{
			if ( !bMarked && Other.Owner == None && MH2.bStartedHunt)
			{
				Inventory(A).RemoteRole = ROLE_DumbProxy;
				Inventory(A).bCollideWorld = True;
				DropRot = Other.Rotation;
				DropRot.Pitch = Rand(32768);
				DropRot.Yaw = Rand(65536);
				Inventory(A).Velocity = vector(DropRot) * RandRange(250,301);
				Inventory(A).Velocity.Z = RandRange(250,451);
				Inventory(A).SetPhysics(PHYS_Falling);
				Inventory(A).GotoState('Pickup', 'Dropped');
				if (bMHLog)
					log ( Other$" spawned at "$Other.Location$" with RespawnTime "$Inventory(Other).RespawnTime );
				if ( MH2.bHaveASpawn )
				{
					Inventory(A).RespawnTime = 0.00; //do not respawn shit dropped by pawns - can be a bunch messing up around
					if (bMHLog)
						log ("New stuff won't Respawn.");
				}
				else
				{
					Inventory(A).RespawnTime = Inventory(Other).RespawnTime;
					if (bMHLog)
						log ("Keep RespawnTime.");
				}
			}
			else
			{
				if ( Other.Owner != None && Other.Owner.bIsPawn )
				{
					if (bMHLog)
						log ("Detected a spawn "$Other$" with Owner "$Other.Owner$". Inventory will be set.");
					P = Pawn(Other.Owner);
					if ( Inventory(A).IsA('Weapon'))
					{
						W = Weapon(Inventory(A));
						W.ReSpawnTime = 0.0;
						W.BecomeItem(); //Do not mess anims
						W.Instigator = P;
						P.AddInventory(W);
						W.GiveAmmo(P);
						W.WeaponSet(P);
					}
				}
			}
		}
	}
	if ( A != None )
	{
		if (Decoration(Other)!=None && Decoration(A)!=None)
		{
			Ot = Decoration(Other);
			Al = Decoration(A);
			Al.Mesh = Ot.Mesh;
			Al.Skin = Ot.Skin;
			Al.Multiskins[0] = Ot.Multiskins[0];
			Al.Multiskins[1] = Ot.Multiskins[1];
			Al.Multiskins[2] = Ot.Multiskins[2];
			Al.Multiskins[3] = Ot.Multiskins[3];
			Al.Multiskins[4] = Ot.Multiskins[4];
			Al.Multiskins[5] = Ot.Multiskins[5];
			Al.Multiskins[6] = Ot.Multiskins[6];
			Al.Multiskins[7] = Ot.Multiskins[7];
			if (Ot.AmbientGlow < 245)
				Al.AmbientGlow = Ot.AmbientGlow + 10;
			Al.AnimFrame = Ot.AnimFrame;
			Al.AnimRate = Ot.AnimRate;
			Al.AnimSequence = Ot.AnimSequence;
			Al.DrawType = Ot.DrawType; //I wanna see if anyone is retard, to post this in forums
			Al.Style = Ot.Style;
			Al.Mass = Ot.Mass;
			Al.Buoyancy = Ot.Buoyancy;
			Al.bPushable = Ot.bPushable;
			if (Barrel(Ot)!=None)
			{
				Barrel(A).Health = Barrel(Other).Health;
			}
			if (WoodenBox(Ot)!= None)
			{
				WoodenBox(A).Health = WoodenBox(Other).Health;
				WoodenBox(A).FragChunks = WoodenBox(Other).FragChunks;
				WoodenBox(A).Fragsize = WoodenBox(Other).Fragsize;
			}
			if (Chair(Ot)!=None)
			{
				Chair(A).Health = Chair(Other).Health;
				Chair(A).FragChunks = Chair(Other).FragChunks;
				Chair(A).Fragsize = Chair(Other).Fragsize;
			}
			if (Table(Ot)!=None)
			{
				Table(A).Health = Table(Other).Health;
				Table(A).FragChunks = Table(Other).FragChunks;
				Table(A).Fragsize = Table(Other).Fragsize;
			}
			if (SteelBarrel(Ot)!=None)
			{
				SteelBarrel(A).Health = SteelBarrel(Other).Health;
			}
			if (SludgeBarrel(Ot)!=None)
			{
				SludgeBarrel(A).Health = SludgeBarrel(Other).Health;
			}
			if (MonkStatue(Ot)!=None)
				Ot.bAlwaysRelevant = True;
			if (Cannon(Ot)!=None)
			{
				Cannon(A).Health = Cannon(Other).Health;
				Cannon(A).DeactivateDistance = Cannon(Other).DeactivateDistance;
				Cannon(A).SampleTime = Cannon(Other).SampleTime;
				Cannon(A).TrackingRate = Cannon(Other).TrackingRate;
				Cannon(A).Drop = Cannon(Other).Drop;
				Cannon(A).FireSound = Cannon(Other).FireSound;
				Cannon(A).ActivateSound = Cannon(Other).ActivateSound;
				Cannon(A).ExplodeSound = Cannon(Other).ExplodeSound;
			}
			Al.PushSound = Ot.PushSound;
			Al.EndPushSound = Ot.EndPushSound;
			Al.contents = Ot.contents;
			Al.content2 = Ot.content2;
			Al.content3 = Ot.content3;
			Al.DrawScale = Ot.DrawScale;
			Al.SetCollisionSize(ORadius,OHeight);
			Al.bBounce = Ot.bBounce;
			Al.bAlwaysRelevant = Ot.bAlwaysRelevant;
			Al.bMovable = Ot.bMovable;
			Al.bStasis = Ot.bStasis;
		}
	}
	else
	{
		log ("FAILED to spawn replacement for "$Other$" placed nasty at "$Other.Location);
		Other.SetCollisionSize(ORadius,OHeight);
		Other.SetCollision(True,True,True); //I don't care anyway
		goto TheEnd;
	}
	if ( A != None )
	{
		if ( Inventory(A) != None && Inventory(A).MyMarker != None ) //Not sure
			A.SetCollisionSize(ORadius,OHeight);
		A.event = Other.event;
		A.tag = Other.tag;
		A.RotationRate = Other.RotationRate;
		A.bFixedRotationDir = Other.bFixedRotationDir;
		if ( Other.Base != None )
			A.SetBase(Other.Base);
		return true;
	}
TheEnd:
	return false;
}

function bool ReplaceMonster(Actor Other, string aClassName)
{
	local Actor A;
	local ScriptedPawn S;
	local ThingFactory TF;
	local class<Actor> aClass;
	local float ORadius, OHeight;

	if  (Other.Location == vect(0,0,0))
		return false;
	ORadius = Other.CollisionRadius;
	OHeight = Other.CollisionHeight;
	Other.SetCollisionSize(1,1);
	aClass = class<Actor>(DynamicLoadObject(aClassName, class'Class'));
	if ( aClass != None )
	{
		if ( Level.bStartUp )
			Other.SetCollision(False,False,False);
		aClass.default.bCollideWhenPlacing = False;
		if ( Level.bStartUp )
			aClass.Default.bCollideWorld = False; //This is really harmful - Fell out of World the mostly :( so it is temporary
		else
			aClass.Default.bCollideWorld = True;
		A = Spawn(aClass,,,Other.Location+vect(0,0,1),Other.Rotation); //Moved some
		if ( Level.bStartUp )
			aClass.Default.bCollideWorld = False; //Back after spawn - even if spawned or not
		else
			aClass.Default.bCollideWorld = True;
	}
	if ( A != None && !Other.bHidden)
	{
		A.bCollideWorld=True;
		A.event = Other.event;
		if ( Other.Tag != Other.Class.Name )
		{
			A.tag = Other.tag;
		}
		else
			A.Tag = A.Class.Name;
//		A.RotationRate = Other.RotationRate;
		if (Other.IsA('ScriptedPawn') && A.IsA('ScriptedPawn'))
		{
			A.GotoState('GameEnded');
			A.SetCollisionSize(1,1);
			A.SetLocation(Other.Location+vect(0,0,1));
			S = ScriptedPawn(A);
			CloneData(ScriptedPawn(Other),S);
			A.SetCollisionSize(ORadius*Other.DrawScale/Other.default.DrawScale,OHeight*Other.DrawScale/Other.default.Drawscale);
//			A.SetCollision(True,True,True); NOT here, let others to spawn if are too close - will assign collision in 500 ms as needed
			SetPawnDifficulty(S);
		}
		return True;
	}
	else
	{
		if (bMHLog)
			log ("Replacing "$Other$" at "@Other.Location@" failed ! Attempt to keep original Pawn.");
		Other.SetCollisionSize(ORadius,OHeight);
		Other.SetCollision(True,True,True);
	}
	return False;
}

function CloneData(ScriptedPawn OldM, out ScriptedPawn NewM) //Transfer data properly - or almost...
{
	NewM.Health = OldM.Health;
	NewM.Mesh = OldM.Mesh;
	NewM.Skin = OldM.Skin;
	NewM.Texture = OldM.Texture;
	NewM.MultiSkins[0] = OldM.MultiSkins[0];
	NewM.MultiSkins[1] = OldM.MultiSkins[1];
	NewM.MultiSkins[2] = OldM.MultiSkins[2];
	NewM.MultiSkins[3] = OldM.MultiSkins[3];
	NewM.MultiSkins[4] = OldM.MultiSkins[4];
	NewM.MultiSkins[5] = OldM.MultiSkins[5];
	NewM.MultiSkins[6] = OldM.MultiSkins[6];
	NewM.MultiSkins[7] = OldM.MultiSkins[7];
	NewM.Fatness = OldM.Fatness;
	NewM.DrawScale = OldM.DrawScale;
	NewM.AnimSequence = OldM.AnimSequence;
	NewM.AnimFrame = OldM.AnimFrame;
	NewM.AnimRate = OldM.AnimRate;
	NewM.bMeshEnviroMap = OldM.bMeshEnviroMap;
	NewM.bUnlit = OldM.bUnlit;
	NewM.TeamTag = OldM.TeamTag;
	NewM.bTeamLeader = OldM.bTeamLeader;
	NewM.TeamLeader = OldM.TeamLeader;
	NewM.AlarmTag = OldM.AlarmTag;
	NewM.SharedAlarmTag = OldM.SharedAlarmTag;
	NewM.Orders = OldM.Orders;
	NewM.OrderTag = OldM.OrderTag;
	NewM.OrderObject = OldM.OrderObject;
	NewM.Aggressiveness = OldM.Aggressiveness;
	NewM.FirstHatePlayerEvent = OldM.FirstHatePlayerEvent;
	NewM.bIgnoreFriends = OldM.bIgnoreFriends;
	NewM.bDelayedPatrol = OldM.bDelayedPatrol;
	NewM.bLeadTarget = OldM.bLeadTarget;
	NewM.bWarnTarget = OldM.bWarnTarget;
	NewM.bIsBoss = OldM.bIsBoss;
	NewM.bIsWuss = OldM.bIsWuss;
	NewM.bNoWait = OldM.bNoWait;
	NewM.bHateWhenTriggered = OldM.bHateWhenTriggered;
	NewM.bInitialFear = False; //Done
	NewM.bSpecialGoal = OldM.bSpecialGoal;
	NewM.Home = OldM.Home;
	NewM.bFixedStart = OldM.bFixedStart;
	NewM.Enemy = OldM.Enemy;
	NewM.AttitudeToPlayer = ATTITUDE_Frenzy; //No craps, please
	NewM.InitialState = OldM.InitialState;
	NewM.SpecialGoal = OldM.SpecialGoal;
	NewM.SpecialPause = OldM.SpecialPause;
	NewM.RangedProjectile = OldM.RangedProjectile;
	NewM.DropWhenKilled = OldM.DropWhenKilled;
//	NewM.RangedProjectile = class 'MH_A_V2.nsgrenade'; === just a check for replacement === WORKS ===
	NewM.Aggressiveness = OldM.Aggressiveness;
	NewM.RefireRate = OldM.RefireRate;
	NewM.Skill = OldM.Skill;
	if ( Skaarj(NewM)!=None && Skaarj(OldM)!=None )
	{
		Skaarj(NewM).bButtonPusher = Skaarj(OldM).bButtonPusher;
		Skaarj(NewM).bFakeDeath = Skaarj(OldM).bFakeDeath;
		Skaarj(NewM).ClawDamage = Skaarj(OldM).ClawDamage;
		Skaarj(NewM).LungeDamage = Skaarj(OldM).LungeDamage;
		Skaarj(NewM).SpinDamage = Skaarj(OldM).SpinDamage;
//		log ("Skaarj Replacement");
		goto AnimalDone; //skip next checks if subject has been found
	}
	if ( Gasbag(NewM)!=None && Gasbag(OldM)!=None )
	{
		Gasbag(NewM).PoundDamage = Gasbag(OldM).PoundDamage;
		Gasbag(NewM).PunchDamage = Gasbag(OldM).PunchDamage;
//		log ("Gasbag Replacement");
		goto AnimalDone;
	}
	if ( Mercenary(NewM)!=None && Mercenary(OldM)!=None )
	{
		Mercenary(NewM).bButtonPusher = Mercenary(OldM).bButtonPusher;
		Mercenary(NewM).bHasInvulnerableShield = False; //Solved
		Mercenary(NewM).bSquatter = Mercenary(OldM).bSquatter;
		Mercenary(NewM).bTalker = Mercenary(OldM).bTalker;
		Mercenary(NewM).OrdersGiven = Mercenary(OldM).OrdersGiven;
		Mercenary(NewM).PunchDamage = Mercenary(OldM).PunchDamage;
//		log ("Mercenary Replacement");
		goto AnimalDone;
	}
	if ( Nali(NewM)!=None && Nali(OldM)!=None )
	{
		Nali(NewM).bNeverBow = Nali(OldM).bNeverBow; //won't copy tool, is invalid
//		log ("Nali Replacement");
		goto AnimalDone;
	}

AnimalDone:
	if (OldM.MenuName != OldM.Default.MenuName)
		NewM.MenuName = OldM.MenuName;
	if (OldM.NameArticle != OldM.Default.NameArticle)
		NewM.NameArticle = OldM.NameArticle;
	NewM.bHasRangedAttack = OldM.bHasRangedAttack;
}

function string GetAbsoluteTime()
{
	local string AbsoluteTime;
	local string GMTRef;

	AbsoluteTime = string(Level.Year);

	if (Level.Month < 10)
		AbsoluteTime = AbsoluteTime$"/0"$Level.Month;
	else
		AbsoluteTime = AbsoluteTime$"/"$Level.Month;

	if (Level.Day < 10)
		AbsoluteTime = AbsoluteTime$"/0"$Level.Day;
	else
		AbsoluteTime = AbsoluteTime$"/"$Level.Day;

	if (Level.Hour < 10)
		AbsoluteTime = AbsoluteTime$" Time > 0"$Level.Hour;
	else
		AbsoluteTime = AbsoluteTime$" Time > "$Level.Hour;

	if (Level.Minute < 10)
		AbsoluteTime = AbsoluteTime$":0"$Level.Minute;
	else
		AbsoluteTime = AbsoluteTime$":"$Level.Minute;

	if (Level.Second < 10)
		AbsoluteTime = AbsoluteTime$":0"$Level.Second;
	else
		AbsoluteTime = AbsoluteTime$":"$Level.Second;

	if (Level.Millisecond < 10)
		AbsoluteTime = AbsoluteTime$".0"$Level.Millisecond;
	else
		AbsoluteTime = AbsoluteTime$"."$Level.Millisecond;
	return AbsoluteTime;
}

function ModifyLogin(out class<playerpawn> SpawnClass, out string Portal, out string Options)
{
	local class<playerpawn> origSC;
	local class<Spectator>  specCls;

	if ( bOtherPlayer )
		if ( SpawnClass == None )
			SpawnClass = class'TMale1';

	if ( NextMutator != None )
		NextMutator.ModifyLogin(SpawnClass, Portal, Options);

/*
	Mainly prevent crappy classes to mock in console
	Else here can go all kind of good tweaks - in New Player more exactly
	if (Left((Caps(Other.Class)),7)=="MH_A_V2")
*/
	if ( bOtherPlayer )
	{
		if ( ClassIsChildOf(SpawnClass, class'Spectator') )
		{
			log ("Spectator has entered with class"@SpawnClass);
			SpawnClass = class 'MCHSpectator';
			GoTo JL4033;
		}
		if (!ClassIsChildOf(SpawnClass, class'NsTournamentPlayer'))
		{
			log ("Player has entered with class"@SpawnClass);
			if ( Right(Caps(SpawnClass),5) == "TBOSS" )
			{
				SpawnClass = class'NsTBoss';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),6) == "TMALE1" )
			{
				SpawnClass = class'NsTMale1';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),6) == "TMALE2" )
			{
				SpawnClass = class'NsTMale2';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),8) == "TFEMALE1" )
			{
				SpawnClass = class'NsTFemale1';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),8) == "TFEMALE2" )
			{
				SpawnClass = class'NsTFemale2';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),4) == "TCOW" )
			{
				SpawnClass = class'NsTCow';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),9) == "TCOWFIXED" )
			{
				SpawnClass = class'NsTCow';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),5) == "TNALI" )
			{
				SpawnClass = class'NsTNali';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),6) == "TNALI2" )
			{
				SpawnClass = class'NsTNali';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),6) == "SKAARJ" )
			{
				SpawnClass = class'NsTSkaarj';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),6) == "XANMK2" )
			{
				SpawnClass = class'NsXanMk2';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),12) == "XANMK2FIX313" )
			{
				SpawnClass = class'NsXanMk2';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),13) == "XANMK2MFIX313" )
			{
				SpawnClass = class'NsXanMk2';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),7) == "WARBOSS" )
			{
				SpawnClass = class'NsWarBoss';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),13) == "WARBOSSFIX313" )
			{
				SpawnClass = class'NsWarBoss';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else if ( Right (Caps(SpawnClass),14) == "WARBOSSMFIX313" )
			{
				SpawnClass = class'NsWarBoss';
				Log ("Assigned"@SpawnClass);
				GoTo JL4033;
			}
			else
			{
				SpawnClass = class'NsTMale2';
				Log ("Assigned"@SpawnClass);
			}
/*
			else if ( SpawnClass == class'Arumi' )
				SpawnClass = class'MHArumi';
			else if ( SpawnClass == class'drfreak' )
				SpawnClass = class'MHDrFreak';
			else if ( SpawnClass == class'Sabb' )
				SpawnClass = class'MHSabb';
			else if ( SpawnClass == class'Squirrel' )
				SpawnClass = class'MHSquirrel';

			else if ( SpawnClass == class'WarBoss' )
				SpawnClass = class'MHWarBoss';
			else if ( SpawnClass == class'ExWarBoss' )
				SpawnClass = class'ExMHWarBoss';
*/
		}
	}
	//And happily got rid of stupid farts spamming meshes missing in certain states
JL4033:
}
//=========== Iterators and native functions specific for XC_GE 19+

native(1718) final function bool AddToPackageMap( optional string PkgName);

native(1719) final function bool IsInPackageMap( optional string PkgName, optional bool bServerPackagesOnly); //Second parameter doesn't exist in U 227!

//Iterators

native(3540) final iterator function PawnActors( class<Pawn> PawnClass, out pawn P, optional float Distance,
optional vector VOrigin, optional bool bHasPRI, optional Pawn StartAt);

native(3541) final iterator function NavigationActors( class<NavigationPoint> NavClass, out NavigationPoint P,
optional float Distance, optional vector VOrigin, optional bool bVisible);

native(3542) final iterator function InventoryActors( class<Inventory> InvClass, out Inventory Inv,
optional bool bSubclasses, optional Actor StartFrom);

native(3552) final iterator function CollidingActors( class<actor> BaseClass, out actor Actor,
float Radius, optional vector Loc);

native(3553) final iterator function DynamicActors( class<actor> BaseClass, out actor Actor,
optional name MatchTag );

//===========

defaultproperties
{
   TranslocatorClass=Class'MH_A_V2.CoopTranslocator'
   HUD_Number=3
   FItems=16
   md=0.250000
   MinMonsterHealth=200
   MaxMonsterHealth=20000
   HealthRegenPerKill=3
   AllowedOpen=7200
   MonsterMultiplier=2.000000
   bDoSpawnSpamFix=True
// bUseEScoreBoard=True
   bNastyCorpse=True
   bOtherPlayer=True
   bDecoChange=True
   bUTReplace=True
   bOldWepReplace=True
   bUseCoopTranslocator=True
   bUseCrapSpree=True
   bNoTranslator=True
   bNoRiskCannon=True
   bUseWarnTeamDamage=True
   bUseAltScoring=True
   bReplaceMonsters=False
   bHitsounds=True
   bNoTest=True
   HitVolume=2.000000
   NumCapacity=260
   bRemoveBlocking=True
   stopPlayerCollision=True
   bTweakGroup=True
   bFixGrabCmd=True
   bDoCrushMover=True
   bDoPawnOpen=True
   MaxHealth=5000
   DefaultHealth=200
   MaxAmmoMultiplier=10
   AmmoRespawnTime=3
   Tz=X
}
