class NSMonsterEnd expands Trigger;

#exec Texture Import Name=MHEnd File=textures\MHEnd.pcx Group="Pics" Mips=Off Flags=2

simulated event PreBeginPlay()
{
}
/*
simulated function PostBeginPlay()
{
	bGameRelevant = False;
	Super.PostBeginPlay();
}
*/
function Touch( actor Other )
{
	local actor A;
	local pawn P, Best;

	if( IsRelevant( Other ) )
	{
		if ( ReTriggerDelay > 0 )
		{
		if ( Level.TimeSeconds - TriggerTime < ReTriggerDelay )
			GoTo JL53;
		TriggerTime = Level.TimeSeconds;
		}
		if( Event != '' )
			foreach AllActors( class 'Actor', A, Event )
				A.Trigger( Other, Other.Instigator );

		if ( Pawn(Other) != None && (Pawn(Other).SpecialGoal == self) )
			Pawn(Other).SpecialGoal = None;

		if( Message != "" )
			Other.Instigator.ClientMessage( Message );

		TriggerObjective(Pawn(Other));

	// for ( P=Level.PawnList; P!=None; P=P.nextPawn )
		foreach AllActors (class'Pawn',P)
		{
			if ( P.PlayerReplicationInfo != None && (( Best == None ) || ( Best.PlayerReplicationInfo != None
				&& P.PlayerReplicationInfo.Score > Best.PlayerReplicationInfo.Score)) ) 
			Best = P;

		if( bTriggerOnceOnly )
			SetCollision(False);
		else if ( RepeatTriggerTime > 0 )
			SetTimer(RepeatTriggerTime, false);
		}
	}
JL53:
}

function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation,	Vector momentum, name damageType)
{
	local actor A;

	if ( bInitiallyActive && (TriggerType == TT_Shoot) && (Damage >= DamageThreshold) && (instigatedBy != None) )
	{
		if ( ReTriggerDelay > 0 )
		{
		if ( Level.TimeSeconds - TriggerTime < ReTriggerDelay )
			GoTo JL80;
		TriggerTime = Level.TimeSeconds;
	}
	if( Event != '' )
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( instigatedBy, instigatedBy );

	if( Message != "" )
		InstigatedBy.Instigator.ClientMessage( Message );

	if( bTriggerOnceOnly )
		SetCollision(False);

	TriggerObjective(InstigatedBy);
	}
JL80:
}

function Trigger (Actor Other, Pawn EventInstigator)
{
	local actor A;

	if( Event != '' )
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( Other, Other.Instigator );
		TriggerObjective(EventInstigator);
		Disable('Trigger'); //After 1st triggerer do not do it again
}

function TriggerObjective(pawn Instigator)
{
	local MonsterHunt2 MH2;

	MH2 = MonsterHunt2( Level.Game );
	if ( MH2 != None )
	{
		if ( !MH2.bGameEnded ) //ONLY if isn't ended
			MH2.EndGame("Hunt Successfull!");
	}
		else
			log(Self@"> TriggerObjective - MH2 == None. GAME HAS BEEN SCREWED!");
}
/*
function TriggerObjective(pawn Instigator)
{
	if ( Level.Game.IsA('MonsterHunt') )
		Level.Game.EndGame("Hunt Successfull!");
	else
		log("MonsterEnd - TriggerObjective - MH == None. This map needs to be fixed for normal MH.");
}
*/
defaultproperties
{
   bHidden=False
   InitialState=OtherTriggerTurnsOn
   Texture=Texture'MH_A_V2.Pics.MHEnd'
}
