// Separate class out of mutator

class TimedBoy expands Actor config (MH_A_V2);

replication
{
	reliable if ( Role == ROLE_Authority )
		NewSong;
}

	var float Time, F[2];
	var (AI) name Tz;
	var MonsterHunt2 MH2;
	var bool bUTReplace, bMHLog, bFoundLeader, BotCheck, DecoCheck, bWeaponCrap, bChAttack, bPowerXC;
	var float LastMonsterAttackTime, LastMadTime, LastMonsterCountTime, tmr;
//Attempt Performace Optimisation
	var float OldTime, NowTime, FrAttack;
	var int FRate, Tk, Step, Cmstep, SpTime;
//End of Performace optimisation chapter;
	var int AmpCount, kakuCount, HealthCount, NumWeps,
		blockattacktime, healthtimer, RegenAmmo, RegenHealth,
		HealthKillRegen, groundasstime, permitlamastime, lolattacktime,
		ActorTime, ActorCheckTime, listpawn, listpawntime, NumAttackers, NeedAttackers;
	var config int MaxMonsterHealth, AmpTime, kakuTime, HealthTime, HealthRegenPerSec,
		AmmoRegenPerSec, MaxHealth, MaxRegenHealth; 
	var config bool bUseRegenAmmo, bUseRegenHealth, bScaleRegen, bCorrodeFaster;

//	Music related craps
	var music NewSong;

event PreBeginPlay() //No trash
{
}

simulated event PostBeginPlay()
{
	if ( MonsterHunt2(Level.Game) != None )
	{
		MH2 = MonsterHunt2(Level.Game);
		bMHLog = MH2.bMHLog;
		Tz = MH2.TT;
//		int(ConsoleCommand("GET IPDRV.TCPNETDRIVER NETSERVERMAXTICKRATE"))
	}
	FrAttack=0.5;
	lolattacktime = 0;
	groundasstime = 0;
	ActorTime = 0;
	listpawn = 0;
	blockattacktime = 5;
	permitlamastime = 2;
	ActorCheckTime = 2;
	listpawntime = 1;
	RegenHealth = HealthRegenPerSec;
	RegenAmmo = AmmoRegenPerSec;
//	tmr=Level.Game.GameSpeed;
//	log ("Timer is "$tmr);
	bGameRelevant=False; //Now is time to work dynamically
	tmr=Level.TimeDilation;
	if (bMHLog)
		log ("Timed Boy Timer is "$tmr);
//	Super.PostBeginPlay();
	if (bMHLog)
		log ("Timer add-on has been engaged.");
	SaveConfig();
	if ( Level.NetMode != NM_Client )
//		SetTimer(tmr,True);
	GetMusicControl();
}

simulated function GetMusicControl()
{
	if ( Level.Song != None )
		NewSong = Level.Song;
	else NewSong = Music'null48.null48';
	if (bMHLog)
		log ("Song used by TimedBoy is "$NewSong);
}
/*
event Timer()
{
	DoTicking();
//	Super.Timer();
}
*/
function DoTicking()
{
	local Pawn P;
	local ScriptedPawn S, S1;
	local Bot B;
	local Inventory Inv;
	local Queen Q;
	local SkaarjTrooper ST;
	local Weapon Wp, Wp1;
	local TournamentWeapon W;
	local Fragment F;
	local CreatureCarcass C;
	local UTHumanCarcass UH;
	local Mover M;
	local Actor A;
	local nsgrenade ne;
	local Decoration D;
	local TeamCannon T;
	local MHTeamCannon MHT;
	local MHMinigunCannon MHM;
	local Music Mu;

//Work around to see what's wrong
//	log ("TimedBoy timer is ticking...");
//	Checking a few things...
//	log("TimedBoy reporting > Level.bBegunPlay > "@Level.bBegunPlay);
//	log("TimedBoy reporting > Level.bStartup > "@Level.bStartup);
/*	log("TimedBoy reporting > Level.AvgAITime > "@Level.AvgAITime);
	log ("AIProfile0 is "$Level.AIProfile[0]);
	log ("AIProfile1 is "$Level.AIProfile[1]);
	log ("AIProfile2 is "$Level.AIProfile[2]);
	log ("AIProfile3 is "$Level.AIProfile[3]);
	log ("AIProfile4 is "$Level.AIProfile[4]);
	log ("AIProfile5 is "$Level.AIProfile[5]);
	log ("AIProfile6 is "$Level.AIProfile[6]);
	log ("AIProfile7 is "$Level.AIProfile[7]);
*/
/*	log("Timer Sequence started at "$Level.Hour$":"$Level.Minute$":"$Level.Second$":"$Level.Millisecond);
	log("Dilation is: "$Level.TimeDilation);
	log ("GameSpeed set to: "$Level.Game.GameSpeed);
*/
// Partially or totally solved ? Yay !
// I just modified function SetGameSpeed to some value.
// Now timer crawl nearby the same millisecond only with small deviations.
// It looks like sustains more accurate the timer.
// Gotta check more details

//Checks
	if ( MH2.bGameEnded ) GoTo NoWork;
	NumAttackers = 0;
	ActorTime++;
	if (ActorTime >= ActorCheckTime)
	{
//		log("Actors time");
		ActorTime = 0;

		if (!BotCheck)
		{
			foreach Level.AllActors (class 'Bot',B)
			{
				if ( B.Weapon == None && !B.bHidden )
				{
//					log ("Found possible player at "$B.Location$" being a "$B$" without weapon, attempt arming pawn...");
					B.bIsPlayer = True;
					Wp = spawn (class 'MH_A_V2.MHRifle',,,B.Location);
					Wp.RespawnTime=0;
					Wp.GiveTo(B);
					Wp.bHeldItem = True;
					Wp.SetSwitchPriority(B);
					Wp.WeaponSet(B);
					B.PendingWeapon = None;
					Wp.GiveAmmo(B);
					if (Wp.AmmoType != None)
						Wp.AmmoType.AmmoAmount = Wp.AmmoType.MaxAmmo;
				}
			}
			BotCheck = True;
			foreach AllActors(class 'TeamCannon', T )
			{
				if ( T != None && !T.bStatic && !T.bNoDelete )
				{
					if ( T.class == class 'TeamCannon' )
					{
						T.SetCollision(False,False,False);
						MHT = spawn(class'MHTeamCannon',,,T.Location,T.Rotation);
						if ( MHT != None )
						{
							log (T$" needs to be morphed to "$MHT);
							if ( T.MyTeam > -1 && T.MyTeam < 2 )
								MHT.MyTeam=T.MyTeam;
							else
								MHT.MyTeam=1;
							MHT.DrawScale=T.DrawScale;
							MHT.ProjectileType=T.ProjectileType;
							MHT.ActivateSound=T.ActivateSound;
							MHT.DeactivateSound=T.DeactivateSound;
							MHT.FireSound=T.Firesound;
							MHT.PostKillMessage=T.PostKillMessage;
							T.Destroy();
						}
					}
					if ( T.class == class 'MinigunCannon' )
					{
						T.SetCollision(False,False,False);
						MHM = spawn(class'MHMinigunCannon',,,T.Location,T.Rotation);
						if ( MHM != None )
						{
							log (T$" needs to be morphed to "$MHM);
							if ( T.MyTeam > -1 && T.MyTeam < 2 )
								MHM.MyTeam=T.MyTeam;
							else
								MHM.MyTeam=1;
							MHM.DrawScale=T.DrawScale;
							MHM.ProjectileType=T.ProjectileType;
							MHM.ActivateSound=T.ActivateSound;
							MHM.DeactivateSound=T.DeactivateSound;
							MHM.FireSound=T.Firesound;
							MHM.PostKillMessage=T.PostKillMessage;
							T.Destroy();
						}
					}
				}
			}
		}

//Assign collision for decorations replaced. Need this !
		if (!DecoCheck)
		{
			foreach AllActors (class 'Decoration', D)
			{
				if (D != None && !D.bBlockActors)
				{
				if ( D.IsA('ExBarrel') || D.IsA('ExVase') || D.IsA('ExWoodenBox') || D.IsA('ExChest') ||
					 D.IsA('ExTarydiumBarrel') || D.IsA('ExChair') || D.IsA('ExMonkStatue') || D.IsA('ExSludgeBarrel')
					 || D.IsA('ExLamp4') || D.IsA('ExUrn') || D.IsA('ExTable')|| D.IsA('ExCannon'))
					D.SetCollision(True,True,True);
				}
			}
			DecoCheck = True;
//			ConsoleCommand("obj garbage");
		}
		if ( !bPowerXC )
		{
			foreach AllActors (class 'Actor', A)
			{
				if ( Fragment(A) != None) A.Destroy();

				if ( TournamentWeapon(A) != None ) W = TournamentWeapon(A);
				if ( bCorrodeFaster )
				{
					if (A.IsA('UTHumanCarcass')) UH = UTHumanCarcass(A);
					if (A.IsA('CreatureCarcass')) C = CreatureCarcass(A);
					if ( UH != None && (!UH.bStatic && !UH.bNoDelete))
					{
						UH.GotoState('Corroding'); //Cya, Last chance passed away
//						Gotta check how works by spawning a controller or such. Will see another time...
					}
					if ( C != None && (!C.bStatic && !C.bNoDelete) && !C.IsA('ExCreatureCarcass')) C.bCorroding = True;
				}
				if ( W != None && W.bTossedOut )
					W.Destroy();
			}
		}
	}
	listpawn++;
	if (listpawn >= listPawnTime)
	{
//		log ("PawnList timer");

		listpawn = 0;
		if ( MH2 == None || !MH2.bStartedHunt ) GoTo NoWork; //Done. If game isn't started return timer here.
		lolattacktime++;
		if (lolattacktime > blockattacktime*2)
			lolattacktime = 0;
		if ( !bPowerXC )
		{
		foreach AllActors(class 'Pawn',P)
		{
			ST = SkaarjTrooper(P);
			S = ScriptedPawn(P);
			B = Bot(P);
			Q = Queen(P);
			if ( P.PlayerReplicationInfo != None && P.PlayerReplicationInfo.Team == 0 )
				CheckAttack(P);
			if (S != None && S.Health > 0)
			{
				if (S.numHuntPaths > 5)
					S.NumHuntPaths = 5;
				if (S.Mesh == None)
					S.Mesh = S.default.mesh;
				if (!S.bIsBoss && S.health >= 4000)
					S.bIsBoss = True;
				if (S.ReducedDamagePct > 0)
				{
					S.ReducedDamageType = '';
					S.ReducedDamagePct = 0;
				}
				if (lolattacktime >= blockattacktime)
				{
//					BroadcastMessage("Target check...");
					if ( S.Enemy != None && !FastTrace(S.Location,S.Enemy.Location) && S.IsInState('RangedAttack'))
					{
						S.Target = S;
						S.bHunting = False;
						S.GotoState('Wandering');
					}
					if (S.Enemy != None && S.Target != S.Enemy && S.CanSee(S.Enemy) && S.IsInState('RangedAttack'))
					{
						S.Target = S.Enemy;
						S.NeedToTurn(S.Enemy.Location);
					}
					if ( S != None && S.bTeamLeader && S.bHidden && !S.IsInState('GameEnded'))
					{
						S.Enemy = None;
						S.Hated = None;
						S.Target = None;
						S.bHunting = False;
						S.GotoState('GameEnded'); //If case of bringing back to life
					}
					lolattacktime = 0;
				}
			}
			if (Q != None)
			{
				if (Q.IsInState('Teleporting'))
					Q.GoToState('Roaming','');
				}
			if (ST != None && ST.Inventory == None)
			{
				if ( ST.Weapon == None && ST.WeaponType == None )
				Wp = spawn (class 'MH_A_V2.MHAsmd',ST,,ST.Location);
				if ( Wp != None )
				{
					Wp.RespawnTime=0.00;
					if (!ST.bIsPlayer)
						ST.bIsPlayer = True;
					Wp.Touch(ST);
				}
				ST.bIsPlayer = False;
			}
			if ( S != None && S.Inventory != None && S.Health > 0 ) //if another kinda crappy creature is armed and forgot in bIsPlayer mode
				S.bIsPlayer = False;

			if (bScaleRegen)
			{
				if ( P.PlayerReplicationInfo != None && P.PlayerReplicationInfo.Team == 0 ) //Probably a hunter here
				if ( P.Health > 0 )
				{
					if ( Bot(P) != None && Bot(P).Health > 1 && Bot(P).Region.Zone.bWaterZone )
					{
						if ( Bot(P).Physics != PHYS_Swimming )
							Bot(P).SetPhysics(PHYS_Swimming);
					}
					if (P.IsA('PlayerPawn'))
					{
						if ( NewSong != Level.Song && PlayerPawn(P).Song != NewSong && PlayerPawn(P).PlayerReplicationInfo.StartTime > 3.000000)
						{
							PlayerPawn(P).Song = NewSong;
							PlayerPawn(P).SongSection = 0;
							PlayerPawn(P).CdTrack = 255;
							PlayerPawn(P).ClientSetMusic( NewSong,0,255,MTRAN_Instant);
						}
					}
//					log ("Scale Regen");
					if (TournamentPlayer(P) != None && TournamentPlayer(P).bIsCrouching)
					{
						groundasstime++;
						if(groundasstime >= permitlamastime)
						{
							P.ClientMessage("Inflammable ass detected...");
							ne = Spawn(class 'nsgrenade',P.Owner,P.Tag,P.Location+vect(0,16,-10),P.Rotation);
							ne.Instigator = P;
							groundasstime = 0;
						}
					}
				// ammo
				if(bUseRegenAmmo)
				for( Inv=P.Inventory; Inv!=None; Inv=Inv.Inventory )
					if ( (Ammo(Inv)!=None) && (P.bFire==0) && (P.bAltFire==0) && Ammo(Inv).MaxAmmo > 5)
						if (Ammo(Inv).AmmoAmount < Ammo(Inv).MaxAmmo-0.5*AmmoRegenPerSec)
						{
							Ammo(Inv).AmmoAmount += RegenAmmo;
							if (Ammo(inv).AmmoAmount > Ammo(Inv).MaxAmmo)
								Ammo(inv).AmmoAmount = Ammo(Inv).MaxAmmo;
						}
			// health
				if(bUseRegenHealth)
					if ( P.Health < MaxRegenHealth && !P.Region.Zone.bWaterZone)
					{
						P.Health += RegenHealth;
						if (P.health > MaxRegenHealth)
							P.Health = MaxRegenHealth;
					}
				}
			}
		}
		}
		else
		{
		foreach PawnActors(class 'Pawn',P)
		{
			ST = SkaarjTrooper(P);
			S = ScriptedPawn(P);
			B = Bot(P);
			Q = Queen(P);
			if ( P.PlayerReplicationInfo != None && P.PlayerReplicationInfo.Team == 0 )
				CheckAttack(P);
			if (S != None && S.Health > 0)
			{
				if (S.numHuntPaths > 5)
					S.NumHuntPaths = 5;
				if (S.Mesh == None)
					S.Mesh = S.default.mesh;
				if (!S.bIsBoss && S.health >= 4000)
					S.bIsBoss = True;
				if (S.ReducedDamagePct > 0)
				{
					S.ReducedDamageType = '';
					S.ReducedDamagePct = 0;
				}
				if (lolattacktime >= blockattacktime)
				{
//					BroadcastMessage("Target check...");
					if ( S.Enemy != None && !FastTrace(S.Location,S.Enemy.Location) && S.IsInState('RangedAttack'))
					{
						S.Target = S;
						S.bHunting = False;
						S.GotoState('Wandering');
					}
					if (S.Enemy != None && S.Target != S.Enemy && S.CanSee(S.Enemy) && S.IsInState('RangedAttack'))
					{
						S.Target = S.Enemy;
						S.NeedToTurn(S.Enemy.Location);
					}
					if ( S != None && S.bTeamLeader && S.bHidden && !S.IsInState('GameEnded'))
					{
						S.Enemy = None;
						S.Hated = None;
						S.Target = None;
						S.bHunting = False;
						S.GotoState('GameEnded'); //If case of bringing back to life
					}
					lolattacktime = 0;
				}
			}
			if (Q != None)
			{
				if (Q.IsInState('Teleporting'))
					Q.GoToState('Roaming','');
				}
			if (ST != None && ST.Inventory == None)
			{
				if ( ST.Weapon == None && ST.WeaponType == None )
				Wp = spawn (class 'MH_A_V2.MHAsmd',ST,,ST.Location);
				if ( Wp != None )
				{
					Wp.RespawnTime=0.00;
					if (!ST.bIsPlayer)
						ST.bIsPlayer = True;
					Wp.Touch(ST);
				}
				ST.bIsPlayer = False;
			}
			if ( S != None && S.Inventory != None && S.Health > 0 ) //if another kinda crappy creature is armed and forgot in bIsPlayer mode
				S.bIsPlayer = False;

			if (bScaleRegen)
			{
				if ( P.PlayerReplicationInfo != None && P.PlayerReplicationInfo.Team == 0 ) //Probably a hunter here
				if ( P.Health > 0 )
				{
					if ( Bot(P) != None && Bot(P).Health > 1 && Bot(P).Region.Zone.bWaterZone )
					{
						if ( Bot(P).Physics != PHYS_Swimming )
							Bot(P).SetPhysics(PHYS_Swimming);
					}
					if (P.IsA('PlayerPawn'))
					{
						if ( NewSong != Level.Song && PlayerPawn(P).Song != NewSong && PlayerPawn(P).PlayerReplicationInfo.StartTime > 3.000000)
						{
							PlayerPawn(P).Song = NewSong;
							PlayerPawn(P).SongSection = 0;
							PlayerPawn(P).CdTrack = 255;
							PlayerPawn(P).ClientSetMusic( NewSong,0,255,MTRAN_Instant);
						}
					}
//					log ("Scale Regen");
					if (P.IsA('TournamentPlayer') && TournamentPlayer(P).bIsCrouching)
					{
						groundasstime++;
						if(groundasstime >= permitlamastime)
						{
							P.ClientMessage("Inflammable ass detected...");
							ne = Spawn(class 'nsgrenade',P.Owner,P.Tag,P.Location+vect(0,16,-10),P.Rotation);
							ne.Instigator = P;
							groundasstime = 0;
						}
					}
				// ammo
				if(bUseRegenAmmo)
				for( Inv=P.Inventory; Inv!=None; Inv=Inv.Inventory )
				{
					if ( (Ammo(Inv)!=None) && (P.bFire==0) && (P.bAltFire==0) && Ammo(Inv).MaxAmmo > 5 )
						if (Ammo(Inv).AmmoAmount < Ammo(Inv).MaxAmmo-0.5*AmmoRegenPerSec)
						{
							Ammo(Inv).AmmoAmount += RegenAmmo;
							if (Ammo(inv).AmmoAmount > Ammo(Inv).MaxAmmo)
								Ammo(inv).AmmoAmount = Ammo(Inv).MaxAmmo;
						}
				}
				// health
				if(bUseRegenHealth)
					if ( P.Health < MaxRegenHealth && !P.Region.Zone.bWaterZone)
					{
						P.Health += RegenHealth;
						if (P.health > MaxRegenHealth)
							P.Health = MaxRegenHealth;
					}
				}
			}
		}
		}
	}
	// Section Amplifier
	// Give all current players damage amps
	if (AmpCount < AmpTime) AmpCount++;
	else if (AmpCount == AmpTime)
	{
		BroadcastLocalizedMessage( class'NSMH_AGAmpMessage',,, None, None );
		// give all current players damage amps
		if ( !bPowerXC )
		{
			foreach AllActors (class'Pawn',P,'aMH')
				if ( P.PlayerReplicationInfo != None && P.Weapon != None && P.PlayerReplicationInfo.Team == 0 )
						GiveAmp(P);
					if (bMHLog)
						log ("Bonus Amplifier received...");
					AmpCount = 0;
		}
		else
		{
			foreach PawnActors (class'Pawn',P,,,True)
				if ( P.PlayerReplicationInfo != None && P.Weapon != None && P.PlayerReplicationInfo.Team == 0 )
						GiveAmp(P);
					if (bMHLog)
						log ("Bonus Amplifier received...");
					AmpCount = 0;
		}
	}

	if (kakuCount < kakuTime)kakuCount++;
		if(kakuTime-kakuCount < 5 && kakuTime-kakuCount > 0) //if redeemer time almost arrived
		{
			P = GetRandomPlayer();
			if ( P != None )
				BroadcastLocalizedMessage(class'NSMH_AGRandomRedeemerMsg',kakuTime-kakuCount,P.PlayerReplicationInfo);
		}
		if ( HealthCount < HealthTime ) HealthCount++;
		if ( HealthTime-HealthCount < 5 && HealthTime-HealthCount > 0 ) //if health bonus almost arrived
		{
			P = GetRandomPlayer();
			if ( P != None )
				BroadcastLocalizedMessage(class'NSMH_AGRandomHealthMsg',HealthTime-HealthCount,P.PlayerReplicationInfo);
		}
		if ( kakuCount >= kakuTime )
		{
			kakuCount = 0;
			P = GetRandomPlayer();
			if ( P != None )
			{
				BroadcastLocalizedMessage(class'NSMH_AGRandomRedeemerMsg',kakuCount,P.PlayerReplicationInfo  );
				GiveRedeemer(P);
				if (bMHLog)
					log (P.GetHumanName()$" was sorted to get Bonus Redeemer...");
			}
		}
		if (HealthCount >= HealthTime)
		{
			HealthCount = 0;
			P = GetRandomPlayer();
			if ( P != None )
			{
				BroadcastLocalizedMessage(class'NSMH_AGRandomHealthMsg',HealthCount,P.PlayerReplicationInfo  );
				GiveHealth(P);
				if (bMHLog)
					log (P.GetHumanName()$" was sorted to get Bonus Health...");
				if(P.Health > MaxHealth)
					P.Health = MaxHealth;
			}
		}
//	}
NoWork:
}

function AssesLeader()
{
	local NavigationPoint N;
	local ExSkaarjBerserker EB;
	local MonsterEnd ME1;
	local Trigger ME;
	local ExMonsterEnd ex1;
	local bool bTemp;
	local name bName;
	local string bString;
	local int bDelayTime;
	local ScriptedPawn S;
	local Pawn P;
	local Weapon W;

	FRate=int(ConsoleCommand("GET IPDRV.TCPNETDRIVER NETSERVERMAXTICKRATE"));
	if ( FRate <= 0 )
		FRate=int(ConsoleCommand("GET XC_IPDRV.XC_TCPNETDRIVER NETSERVERMAXTICKRATE"));
	if ( FRate > 0.000000 )
	{
		Tk = FRate;
		log ("Detected TickRate at "$Tk);
		FRate = int((1000*Level.TimeDilation)/FRate);
		log ("Tick interval is around "$FRate$" ms.");
		bChAttack = True;
		if ( Level.NetMode == NM_DedicatedServer )
			MonsterReplicationInfo2(MH2.GameReplicationInfo).Ticks = Tk;
	}
	foreach AllActors(class'MonsterEnd',ME1 )
	{
		if ( ME1 != None && ME1.IsA('AdvancedMonsterEnd'))
		{
			ex1 = Spawn(class 'ExMonsterEnd',,,ME1.location + vect(-1,-1,0));
			if ( ex1 != None)
			{
				if (ME1.Base != None)
					ex1.SetBase(ME1.Base);
				if (ME1.Tag != '') ex1.SetPropertyText("Tag",ME1.GetPropertyText("Tag"));
				if (ME1.Event != '') ex1.SetPropertyText("Event",ME1.GetPropertyText("Event"));
				if (ME1.AttachTag != '') ex1.SetPropertyText("AttachTag",ME1.GetPropertyText("AttachTag"));
				ex1.SetCollisionSize(ME1.CollisionRadius,ME1.CollisionHeight);
				ex1.SetPropertyText("bInitiallyActive",ME1.GetPropertyText("bInitiallyActive"));
				ex1.SetPropertyText("bMovable",ME1.GetPropertyText("bMovable"));
				ex1.SetPropertyText("bGoodEnding",ME1.GetPropertyText("bGoodEnding"));
				ex1.SetPropertyText("DelayTime",ME1.GetPropertyText("DelayTime"));
				ex1.SetPropertyText("SuccessMsg",ME1.GetPropertyText("SuccessMsg"));
				ex1.SetPropertyText("FailedMsg",ME1.GetPropertyText("FailedMsg"));
				if (!ME1.bStatic && !ME1.bNoDelete)
				{
					ME1.SetCollisionSize(0,0);
					ME1.Tag = MonsterHunt2(Level.Game).TT;
					if (bMHLog)
					{
						log (ex1$" - new trigger for ending added successfully");
						log (ex1.Tag$" is our tag.");
						log (ex1.bGoodEnding$" is our good ending.");
						log (ex1.bDelayed$" is our Delayed mode.");
						log (ex1.DelayTime$" is our DelayTime.");
						log ("GoodMessage is "@ex1.SuccessMsg);
						log ("BadEndMessage is "@ex1.FailedMsg);
					}
					ME1.Destroy();
				}
			}
			else
				{
					if (bMHLog)
						log ("WARNING!!! Supposed End did not Spawn for "@ME1);
				}
		}
	}
	for (N = Level.NavigationPointList; N != NONE; N = N.NextNavigationPoint)
	{
		if ( N != None )
		{
			class'ExSkaarjBerserker'.default.TeamTag=Tz;
			class'ExSkaarjBerserker'.default.bGameRelevant = True;
			class'ExSkaarjBerserker'.default.bTeamLeader = True;
			class'ExSkaarjBerserker'.default.bHidden = True;
			EB = Spawn(class'MH_A_V2.ExSkaarjBerserker',,,N.Location);
		}
		if (EB != None)
		{
			class'ExSkaarjBerserker'.default.TeamTag='';
			class'ExSkaarjBerserker'.default.bGameRelevant = False;
			class'ExSkaarjBerserker'.default.bTeamLeader = False;
			class'ExSkaarjBerserker'.default.bHidden = False;
			break;
		}
	}
	if (EB != None)
	{
		EB.bGameRelevant = True;
		EB.OddsOfAppearing = 1.000000;
		EB.bTeamLeader = True;
		EB.TeamLeader = EB;
		EB.TeamTag = Tz;
		EB.Team = 1;
		EB.Style = STY_Translucent;
		EB.ScaleGlow = 0.000000;
		EB.Health = 0;
		EB.bHidden = True;
		EB.GotoState('GameEnded');
	}
	MH2.HuntHealth=MaxRegenHealth;

	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
	{
		S=ScriptedPawn(P);
		if ( S != None && S.Health > 0 /*&& S.InitialState != ''*/)
		{
//				log (S@"> Hit Monster Ignition.");
//				S.InitialState = '';
//				S.SetInitialState(); //Not here - not this
				foreach RadiusActors( class'Weapon',W,S.CollisionRadius, S.Location )
				{
					if ( W.MyMarker == None && W.Instigator == None )
						W.Destroy();
				}
				if ( EB != None )
					S.TeamLeader = EB;
		}
	}
	Class'ScriptedPawn'.default.TeamTag=Tz;
	Class'ScriptedPawn'.default.Team=1;
	Class'ScriptedPawn'.default.PlayerReplicationInfoClass=None;
	Class'ScriptedPawn'.default.PlayerReplicationInfo=None;
	if (bMHLog)
		log ("The Leader has been set.");
	bFoundLeader = True;
}

event Tick (float DT)
{
	local bool bAdjusted;

	NowTime = Level.TimeSeconds;
	if ( NowTime > OldTime )
	{
		SpTime = int((1000*Level.TimeDilation)/(( NowTime-OldTime )*(1000*Level.TimeDilation)));
		OldTime = Level.TimeSeconds;
		if (bChAttack)
			if ( Step < ( Tk-SpTime )/2 ) 
			{
				Step = ( Tk-SpTime )/2;
//				log ("Step >"@Step);
			}
	}
	if ( MH2 != None && ( !MH2.bStartedHunt || MH2.bGameEnded ) ) GoTo NoWork;

	if ( ( LastMonsterAttackTime + FRAttack ) < Level.TimeSeconds )
	{
		if (bChAttack)
		{
			if ( Step < 0 ) Step = 0;
			if ( SpTime < ( Tk*0.99 ) )  
			{
				Step+=1;
				if ( ( MH2.TotalMonsters / Step) < 50 ) //Won't mess under 50.
					Step -= 1;
//				log ("Tick Attack = "$SpTime$" > Growing Interval");
				if ( Level.NetMode == NM_DedicatedServer )
				{
					MonsterReplicationInfo2(MH2.GameReplicationInfo).Ticks = SpTime;
//					BroadCastMessage(SpTime$" ^");
				}
				if ( FRAttack <= 2.0 )
					FRAttack += 1.0;
				if ( FrAttack > 2.000000 )
					FRAttack = 2.000000;
//				log (FRAttack);
				bAdjusted = True;
			}
			if ( ( SpTime > ( Tk*0.99 ) ) && !bAdjusted )
			{
				if ( FRAttack >= 0.5 )
				{
//					log ("Tick Attack = "$SpTime$" > Shrinking Interval.");
					if ( Level.NetMode == NM_DedicatedServer )
					{
						MonsterReplicationInfo2(MH2.GameReplicationInfo).Ticks = SpTime;
//						BroadCastMessage(SpTime$" ^");
					}
					FRAttack -= 0.2;
//					log (FRAttack);
					bAdjusted=True;
				}
				if ( Step > 1 )
					Step -= 1;
				if ( FRAttack < 0.2 )
					FRAttack = 0.2;
			}
		}
		MonsterAttackCheck();
//		log (Level.AvgAITime);
	}

	if ( (LastMonsterCountTime + 5) < Level.TimeSeconds )
	{
		if (!bFoundLeader)
			AssesLeader();
		if ( bChAttack )
		{
			if ( Step <= 1 )
				MH2.CountMonsters();
		}
		else
			MH2.CountMonsters();
		LastMonsterCountTime=Level.TimeSeconds;
		NeedAttackers = MH2.TotalHunters * RandRange(3,6);
	}
NoWork:
}

function bool ValidSight( Pawn S, Actor SeenActor )
{
	local bool result;
	local actor HitActor;
	local vector HitLocation, HitNormal;

	result=False;
	if ( S == None || SeenActor == None || SeenActor.bHidden )
		result=False;
	HitActor = Trace(HitLocation, HitNormal, S.Location, SeenActor.Location, false);
	if ( HitActor == None )
		result = True;
	return result;
}

function CheckAttack(Pawn P)
{
	local ScriptedPawn Pl;

//	log ("Testing"@P.Name);
	foreach VisibleCollidingActors(class'ScriptedPawn',Pl,1800,P.Location,True) //2400 - Somehow this is almost LineOfSight
	{
		if ( ValidSight(P,Pl) && ( Pl.Enemy == None ||
		!Pl.LineOfSightTo(Pl.Enemy)
		|| ( Vsize(Pl.Enemy.Location - Pl.Location) > VSize(P.location - Pl.Location) && FRand() < 0.6 ) ))
		{
			Pl.LastSeenPos = P.Location;
			if ( MH2.bUseXC )
				Pl.SeePlayer(P);
			else
			{
				Pl.Enemy = P;
				Pl.Hated = P;
				Pl.GotoState('Attacking');
			}
			if ( P.Enemy == None || ( P.Enemy != None && !ValidSight(P,P.Enemy) ) )
				P.Enemy = Pl;
		}
	}
}

function MonsterAttackCheck()
{
	local Pawn P, Pl;
	local ScriptedPawn S;
	local Carcass C;
	local string CC;

	if ( !bPowerXC )
	{
		foreach AllActors(class'Pawn',P)
		{
			Switch(P)
			{
				Case ScriptedPawn(P):
				S = ScriptedPawn(P);
				if ( S.Health > 0 )
				{
					if ( bFoundLeader )
					{
						S.Team = 1; //Another team
						if (S.TeamTag == '' || S.TeamTag == S.Default.TeamTag )
							if ( Cow(S) == None && Nali(S) == None )
								S.TeamTag = Tz;
					}
					if ( !S.bBlockActors )
						S.SetCollision(True,True,True);
					if (S.Health > MaxMonsterHealth)
						S.Health = MaxMonsterHealth;
					if ( ScriptedPawn(S.Enemy) != None )
					if ( S.TeamTag == ScriptedPawn(S.Enemy).TeamTag )
					{
						S.Hated = None;
						S.Enemy = None;
						S.Target = None;
						S.bHunting = False;
						S.bReadyToAttack = False;
						if ( ScriptedPawn(S.OldEnemy) != None && S.TeamTag == ScriptedPawn(S.OldEnemy).TeamTag )
							S.OldEnemy = None;
						S.WhatToDoNext('','');
					}
				}
				if ( S.Health < 0 && !S.IsInstate('Dead') )
					S.GoToState('Dying');
				break;
			Case FlockPawn(P):
				if ( !P.bBlockActors && P.bCollideActors )
					P.SetCollision(True,True,True);
				break;
			}
		}
	}
	else
	{
		foreach PawnActors(class'Pawn',P)
		{
			Switch(P)
			{
				Case ScriptedPawn(P):
				S = ScriptedPawn(P);
				if ( S.Health > 0 )
				{
					if ( bFoundLeader )
					{
						S.Team = 1; //Another team
						if (S.TeamTag == '' || S.TeamTag == S.Default.TeamTag )
							if ( Cow(S) == None && Nali(S) == None )
								S.TeamTag = Tz;
					}
					if ( !S.bBlockActors )
						S.SetCollision(True,True,True);
					if (S.Health > MaxMonsterHealth)
						S.Health = MaxMonsterHealth;
					if ( ScriptedPawn(S.Enemy) != None )
					if ( S.TeamTag == ScriptedPawn(S.Enemy).TeamTag )
					{
						S.Hated = None;
						S.Enemy = None;
						S.Target = None;
						S.bHunting = False;
						S.bReadyToAttack = False;
						if ( ScriptedPawn(S.OldEnemy) != None && S.TeamTag == ScriptedPawn(S.OldEnemy).TeamTag )
							S.OldEnemy = None;
						S.WhatToDoNext('','');
					}
				}
				if ( S.Health < 0 && !S.IsInstate('Dead') )
					S.GoToState('Dying');
				break;
			Case FlockPawn(P):
				if ( !P.bBlockActors && P.bCollideActors )
					P.SetCollision(True,True,True);
				break;
			}
		}
	}
	LastMonsterAttackTime = Level.TimeSeconds;
}

final function Pawn GetRandomPlayer()
{
	local Pawn N, Dest, Candidate[32];
	local int num, Chosen;

//	Clock( F);
	num = 0;
	Chosen = 0;
	if ( !bPowerXC )
	{
		foreach AllActors(class'Pawn',N,'aMH')
		{
			if ( N.PlayerReplicationInfo != None
			&& N.Health > 0
			&& N.Weapon != None
			&& N.PlayerReplicationInfo.Team == 0 ) //Any kinda Spectator I'm guessing does not has weapons in end...
			{
				Dest = N; //Assign a Pawn
				if ( num < 32 )
					Candidate[num] = Dest;
			Dest = None;
				num++;
			}
		}
	}
	else
	{
		foreach PawnActors(class'Pawn',N,,,True)
		{
			if ( N.PlayerReplicationInfo != None
			&& N.Health > 0
			&& N.Weapon != None
			&& N.PlayerReplicationInfo.Team == 0 ) //Any kinda Spectator I'm guessing does not has weapons in end...
			{
				Dest = N; //Assign a Pawn
				if ( num < 32 )
					Candidate[num] = Dest;
				Dest = None;
				num++;
			}
		}
	}
	if(num == 0) return None;
	Chosen = Rand(num);
//	Time = UnClock( F);
//	log ("Random Candidate choice took "$Time$" seconds.");
	return Candidate[Chosen];
}

function GiveAmp(Pawn P)
{
	local Pickup dam;
	if (bUTReplace)
	{
		if( (P.FindInventoryType(class'MHUDamage') != None) || ( P.Health < 1 ) )
			GoTo NotWork;
		dam = spawn(class'MHUDamage',P,,P.Location);
		if( dam != None )
		{
			dam.RespawnTime = 0.0;
			dam.Touch(P);
		}
	}
	else
	{
		if( (P.FindInventoryType(class'UDamage') != None) || ( P.Health < 1 ) )
			GoTo NotWork;
		dam = spawn(class'UDamage',P,,P.Location);
		if( dam != None )
		{
			dam.RespawnTime = 0.0;
			dam.Touch(P);
		}
	}
NotWork:
}
// Section Gifts
function GiveRedeemer (Pawn P)
{
	local Weapon rede;
	local Inventory Inv;

	if (P.Health > 0)
	{
		if (bUTReplace)
			rede = Spawn(Class'NSWarheadLauncher',P,,P.Location);
		else
			rede = Spawn(Class'WarheadLauncher',P,,P.Location);
		if ( rede != None )
		{
			rede.RespawnTime = 0;
			rede.Touch(P);
		}
	}
}

function GiveHealth(Pawn PlayerPawn)
{
	if ( PlayerPawn.Health > 0 )
		PlayerPawn.Health += 500;
	else PlayerPawn.Health += 0;
}

//=========== Iterators and native functions specific for XC_GE 19+

native(1718) final function bool AddToPackageMap( optional string PkgName);

native(1719) final function bool IsInPackageMap( optional string PkgName, optional bool bServerPackagesOnly); //Second parameter doesn't exist in U 227!

//Iterators

native(3540) final iterator function PawnActors( class<Pawn> PawnClass, out pawn P, optional float Distance,
optional vector VOrigin, optional bool bHasPRI, optional Pawn StartAt);

native(3541) final iterator function NavigationActors( class<NavigationPoint> NavClass, out NavigationPoint P,
optional float Distance, optional vector VOrigin, optional bool bVisible);

native(3542) final iterator function InventoryActors( class<Inventory> InvClass, out Inventory Inv,
optional bool bSubclasses, optional Actor StartFrom);

native(3552) final iterator function CollidingActors( class<actor> BaseClass, out actor Actor,
float Radius, optional vector Loc);

native(3553) final iterator function DynamicActors( class<actor> BaseClass, out actor Actor,
optional name MatchTag );

//===========

/*
native (3556) static final function Clock( out float C[2]);
native (3557) static final function float UnClock( out float C[2]);
*/

Auto State TickTok
{
Begin:
	Sleep(tmr);
TokTik:
	DoTicking();
TakeABreak:
	Sleep(tmr);
	if ( MH2 != None && MH2.bGameEnded )
		GoTo('TakeABreak');
	GoTo('TokTik');
}

defaultproperties
{
   bAlwaysTick=False
   bHidden=True
   bGameRelevant=True
   RemoteRole=ROLE_SimulatedProxy
   NetUpdateFrequency=2.0
   HealthRegenPerSec=4
   AmmoRegenPerSec=8
   MaxMonsterHealth=20000
   bUseRegenAmmo=True
   bUseRegenHealth=True
   bScaleRegen=True
   bCorrodeFaster=True
   AmpTime=222
   kakuTime=233
   HealthTime=244
   MaxHealth=5000
   MaxRegenHealth=500
   Tz=X
   Tag=TiB
}