class UTES_HNotify expands SpawnNotify;

//var Class<Mutator> HUDMutatorClass;

simulated function PreBeginPlay()
{
	if(ROLE < ROLE_Authority)
		log("UTES: PreBeginPlay()");
	bAlwaysRelevant = True;
}

simulated function PostNetBeginPlay()
{
	local ChallengeHUD PlayerHUD;

	foreach AllActors(Class'ChallengeHUD',PlayerHUD)
		SpawnNotification(PlayerHUD);
}

simulated event Actor SpawnNotification(actor Actor)
{

	local UTES_HMut tmpHUD;

	log("UTES: SpawnNotification(1)");
	if ( Actor!=None )
	{	
		if (Actor.IsA('HUD') && (HUD(Actor).HUDMutator == None || !HUD(Actor).HUDMutator.IsA('UTES_HMut')))
		{
			log("UTES: SpawnNotification(2)");
			tmpHUD = spawn(class'UTES_HMut', Actor);
			if (tmpHUD != None)
			{

				log("UTES: SpawnNotification(3)");
				if (HUD(Actor).HUDMutator == None)
				{	
					log("UTES: SpawnNotification(4)");
					HUD(Actor).HUDMutator = tmpHUD;
				}	
				else
				{	
					log("UTES: SpawnNotification(5)");
					tmpHUD.NextHUDMutator = HUD(Actor).HUDMutator;
					HUD(Actor).HUDMutator = tmpHUD;
				}	
			}	
		}
	}
	return Actor;
}

defaultproperties
{
     ActorClass=Class'Engine.HUD'
     NetPriority=8.000000
}
