// Introducing GasBagBelch
// Made sure for 0 error
// Asses a decal and... an unexistent sound called (added a stock one)

class mhGasBagBelch expands Projectile;

var() texture SpriteAnim[6];
var int i;

simulated function Timer()
{
	Texture = SpriteAnim[i];
	i++;
	if (i>=6) i=0;
}

function SetUp()
{
	if ( ScriptedPawn(Instigator) != None )
		Speed = ScriptedPawn(Instigator).ProjectileSpeed;
	Velocity = Vector(Rotation) * speed;
	if ( ROLE == ROLE_Authority )
		MakeNoise ( 0.7 );
}

simulated function PostBeginPlay()
{
	SetUp();
	if ( Level.NetMode != NM_DedicatedServer )
	{
		PlaySound(SpawnSound,,7.00);
		Texture = SpriteAnim[0];
		i=1;
		SetTimer(0.15,True);
	}
	Super.PostBeginPlay();
}

auto state Flying
{

simulated function ProcessTouch (Actor Other, Vector HitLocation)
{
	if ( Other != instigator )
	{
		if ( Role == ROLE_Authority )
			Other.TakeDamage( Damage,instigator,HitLocation, 15000.0 * Normal(velocity), 'burned');
		Explode(HitLocation, Vect(0,0,0));
	}
}

simulated function Explode(vector HitLocation, vector HitNormal)
{
	local OSSpriteBallExplosion s;

	if ( !bDeleteMe )
	{
		if ( Role == ROLE_Authority )
			MakeNoise(0.7);	//FIXME - set appropriate loudness
							//No, this is unguilty
		if ( Level.NetMode != NM_DedicatedServer ) //Wrapped added, I don't hear any noise in dedicated servers after all
		{
			s = Spawn(class'OSSpriteBallExplosion',,,HitLocation+HitNormal*9);
			if (s != None)
				s.RemoteRole = ROLE_None;
		}
		Destroy();
	}
}

Begin:
	Sleep(3);
	Explode(Location, Vect(0,0,0));
}

defaultproperties
{
     ExplosionDecal=Class'BlastMark'
     SpawnSound=Sound'UnrealShare.Expla02'
     SpriteAnim(0)=Texture'UnrealI.Effects.gbProj0'
     SpriteAnim(1)=Texture'UnrealI.Effects.gbProj1'
     SpriteAnim(2)=Texture'UnrealI.Effects.gbProj2'
     SpriteAnim(3)=Texture'UnrealI.Effects.gbProj3'
     SpriteAnim(4)=Texture'UnrealI.Effects.gbProj4'
     SpriteAnim(5)=Texture'UnrealI.Effects.gbProj5'
     speed=600.000000
     Damage=40.000000
     ImpactSound=Sound'UnrealShare.flak.expl2'
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=3.500000
     DrawType=DT_Sprite
     Style=STY_Translucent
     Texture=Texture'UnrealI.Effects.gbProj0'
     DrawScale=1.800000
     Fatness=0
     bUnlit=True
     LightType=LT_Steady
     LightEffect=LE_NonIncidence
     LightBrightness=255
     LightHue=5
     LightSaturation=16
     LightRadius=9
}
