// ============================================================
// Some Tournament formula of dispersion without add-ons dummy classes
// Also reworking call to Amplifier - retarded craps anyway to bug fixing Net stuff
// ============================================================

class MHDispersionPistol expands TournamentWeapon;

#exec TEXTURE IMPORT NAME=UseDPistol FILE=Textures\UseDPistol.pcx GROUP="Icons" MIPS=OFF

var travel int PowerLevel;
var vector WeaponPos;
var float Count,ChargeSize;
var ChargeLight cl1,cl2;
var Pickup Amp;
var Sound PowerUpSound;
var bool bburst;    //client-side var ensureing proper timing.....
var Sound PowerUpSounds[4];

replication   //to ensure that the powerlevels work :D
{
	reliable if ( bNetOwner && (Role == ROLE_Authority) )     //server send to client var
		powerlevel;
	reliable if (Role==ROLE_Authority)  //functions send
		dopowerup;
}

function CheckVisibility()
{
	local Pawn PawnOwner;

	PawnOwner = Pawn(Owner);

	if ( PawnOwner != None )
		if ( Owner.bHidden && (PawnOwner.Health > 0) && (PawnOwner.Visibility < PawnOwner.Default.Visibility) )
		{
			Owner.bHidden = false;
			PawnOwner.Visibility = PawnOwner.Default.Visibility;
		}
}

function float RateSelf( out int bUseAltMode )
{
	local float rating;
	local Pawn P;
	local Inventory I;

	P = Pawn(Owner);
	for ( I = P.Inventory; I != None; I = I.Inventory )
	{
		if (I.IsA('MHUDamage'))
		{
			Amp = MHUDamage(I);
			break;
		}
	}
	if ( Amp != None )
		rating = 6 * AIRating;
	else
		rating = AIRating;

	if ( AmmoType.AmmoAmount <= 10 )
	{
		bUseAltMode = 0;
		return -1;
	}

	if ( Pawn(Owner).Enemy == None )
	{
		bUseAltMode = 0;
		return rating * (PowerLevel + 1);
	}
	bUseAltMode = int( FRand() < 0.3 );
	/*
	splash damage should be used if we are higher than the target, but definitely not if we're lower...
	Add-on:	No shit me, says who ? I'm firing anyway especially if I'm Trooper, LOL... Get lost !
	if (( Owner.Location.Z > Pawn(owner).Enemy.Location.Z + 120 ))
		bUseAltMode = 1;
	else if ( Pawn(owner).Enemy.Location.Z > Owner.Location.Z + 120 )
		bUseAltMode = 0;
	if ( powerlevel>2 ) //always use primary if the power is high...
		bUseAltMode = 0;
	*/
	return rating * (PowerLevel + 1);
}

// return delta to combat style
function float SuggestAttackStyle()
{
	local float EnemyDist;
	local Inventory Inv;

	if ( !Pawn(Owner).bIsPlayer || (PowerLevel > 0) )
		return 0;
	return -0.3;
}

function bool HandlePickupQuery( inventory Item )
{
	local int OldAmmo;
	local Pawn P;
/*
	if ( Item.class == class )
	{
		if ( Weapon(item).bWeaponStay && (!Weapon(item).bHeldItem || Weapon(item).bTossedOut) )
			return true;
		if ( AmmoType != None )
		{
			OldAmmo = AmmoType.AmmoAmount;
			if ( AmmoType.AddAmmo(PickupAmmoCount) && (OldAmmo == 0) 
			&& (P.Weapon.class != item.class) && !P.bNeverSwitchOnPickup )
			WeaponSet(P);
		}
		if (Level.Game.LocalLog != None)
			Level.Game.LocalLog.LogPickup(Item, Pawn(Owner));
		if (Level.Game.WorldLog != None)
			Level.Game.WorldLog.LogPickup(Item, Pawn(Owner));
		if ( PickupMessageClass == None )
			P.ClientMessage(PickupMessage, 'Pickup');
		else
			P.ReceiveLocalizedMessage( PickupMessageClass, 0, None, None, item.Class );
		item.PlaySound(PickupSound);
		item.SetRespawn();
		return true;
	}
*/
	if ( Item.IsA('MHDispersionPowerUp') )
	{
		if ( PowerLevel >= 4)
			return True;
		if ( PowerLevel < 4 )
		{
			if ( AmmoType != None )
				AmmoType.AddAmmo(AmmoType.MaxAmmo);
			if ( Item.PickupMessageClass == None )
				Pawn(Owner).ClientMessage(Item.PickupMessage, 'Pickup');
			else
				Pawn(Owner).ReceiveLocalizedMessage( Item.PickupMessageClass, 0, None, None, Item.Class );
			Item.PlaySound (PickupSound);
			ShakeVert = Default.ShakeVert + PowerLevel;
//			PowerUpSound = Item.ActivateSound;
			if ( Pawn(Owner).Weapon == self )
			{
				PowerLevel++;
				GotoState('PowerUp');
				if ( (Level.NetMode != NM_Standalone) && Owner.IsA('PlayerPawn')
				&& (ViewPort(PlayerPawn(Owner).Player) == None) )
				playerpawn(owner).ClientWeaponEvent('PowerUp');
				DoPowerUp(powerlevel);
			}
			else if ( (Pawn(Owner).Weapon != Self) && !Pawn(Owner).bNeverSwitchOnPickup )
			{
				Pawn(Owner).Weapon.PutDown();
				Pawn(Owner).PendingWeapon = self;
				GotoState('PowerUp', 'Waiting');  
			}
			else PowerLevel++;
		}
		Item.SetRespawn();
		return true;
	}
	else
		return Super.HandlePickupQuery(Item);
}

simulated function DoPowerUp (byte newlevel)
{ //called on pickup
	powerlevel = newlevel;
	GotoState('Clientpowerup');
}

function BecomePickup()
{
	Amp = None;
	Super.BecomePickup();
}
 
simulated function PlayFiring()
{
	if ( AmmoType != None )
		AmmoType.GoToState('Idle2');
	if ( Owner != None )
		PlayOwnedSound(AltFireSound, SLOT_None, Pawn(Owner).SoundDampening * 2.0 );
	if ( PlayerPawn(Owner) != None )
		PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
	if ( Mesh == PlayerViewMesh )
	{
		if ( PowerLevel==0 )
			PlayAnim('Shoot1',0.4,0.2);
		else if (PowerLevel==1) 
			PlayAnim('Shoot2',0.3,0.2);
		else if (PowerLevel==2) 
			PlayAnim('Shoot3',0.2, 0.2);
		else if (PowerLevel==3) 
			PlayAnim('Shoot4',0.1,0.2);
		else if (PowerLevel==4) 
			PlayAnim('Shoot5',0.1,0.2);
	}
}

function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
{
	local Vector Start, X,Y,Z;
	local DispersionAmmo da;
	local float Mult;

	Owner.MakeNoise(Pawn(Owner).SoundDampening);
	if (Amp != None)
		Mult = FClamp(Amp.Charge/30,2,3);
	else
		Mult = 1.0;
	GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
	Start = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z; 
	AdjustedAim = pawn(owner).AdjustAim(ProjSpeed, Start, AimError, True, (3.5*FRand()-1<PowerLevel));  
	if ( (PowerLevel == 0) || (AmmoType.AmmoAmount < 10) ) 
	{
		da = MHOSDispersionAmmo(Spawn(ProjClass,,, Start,AdjustedAim));
		if ( (AmmoType.AmmoAmount < 1) && Level.Game.bDeathMatch )
		AmmoType.AmmoAmount = 1;
	}
	else
	{
		if ( ( PowerLevel==1 ) && AmmoType.UseAmmo(2) ) 
			da = Spawn(class'MH_A_V2.MHOSDAmmo2',,, Start,AdjustedAim);
		if ( ( PowerLevel==2 ) && AmmoType.UseAmmo(4) ) 
			da = Spawn(class'MH_A_V2.MHOSDAmmo3',,, Start,AdjustedAim);
		if ( (PowerLevel==3) && AmmoType.UseAmmo(5) ) 
			da = Spawn(class'MH_A_V2.MHOSDAmmo4',,, Start ,AdjustedAim);
		if ( (PowerLevel>=4) && AmmoType.UseAmmo(6) ) 
			da = Spawn(class'MH_A_V2.MHOSDAmmo5',,, Start,AdjustedAim);    
	}
		if ( (da != None) && (Mult>1.0) )
		da.InitSplash(Mult);
}

function AltFire( float Value )
{
	bPointing=True;
	CheckVisibility();
	bCanClientFire = true;
	ClientAltFire(Value);
	GoToState('AltFiring');
}

////////////////////////////////////////////////////////
state AltFiring
{
ignores AltFire, animend;

	function Tick( float DeltaTime )
	{
		if ( Level.NetMode == NM_StandAlone || (Level.Netmode == NM_listenserver && playerpawn(owner) != none && playerpawn(owner).player.IsA('Viewport')))   //don't let this happen in netgames....  (that is called by clientaltfire)
		{
			PlayerViewOffset.X = WeaponPos.X + FRand()*ChargeSize*7;
			PlayerViewOffset.Y = WeaponPos.Y + FRand()*ChargeSize*7;
			PlayerViewOffset.Z = WeaponPos.Z + FRand()*ChargeSize*7;
		}
		ChargeSize += DeltaTime;
		if( (pawn(Owner).bAltFire==0))
			GoToState('ShootLoad');
		Count += DeltaTime;
		if (Count > 0.3) 
		{
			Count = 0.0;
			if ( AmmoType != None )
			{
				if ( !AmmoType.UseAmmo(1) ) GoToState('ShootLoad');
				AmmoType.GoToState('Idle2');
			}
		}
	}
	
	function EndState()
	{
		PlayerviewOffset = WeaponPos;
		if (cl1 != None) cl1.Destroy();
		if (cl2 != None) cl2.Destroy();    
	}

	function BeginState()
	{
		WeaponPos = PlayerviewOffset;
		ChargeSize=0.0;    
	}

Begin:
	if ( AmmoType != None && AmmoType.UseAmmo(1))
	{
//		Owner.PlaySound(Misc1Sound,SLOT_Misc, Pawn(Owner).SoundDampening*4.0);
		Count = 0.0;    
		Sleep(2.0 + 0.6 * PowerLevel);
		GoToState('ShootLoad');
	}
	else GotoState('Idle');
}

simulated function PlayAltFiring()
{ //play misc sound
	if (role < role_authority && !IsAnimating()) //replicate move problem.
		PlayIdleAnim();
	else
	{
		if ( Owner != None )
			PlayOwnedSound( Misc1Sound,SLOT_Misc, Pawn(Owner).SoundDampening*4.0 );
	}
}
///////////////////////////////////////////////////////////
state ClientAltFiring        //client-side animations.....
{
	simulated function Tick(float DeltaTime)
	{
		global.tick(deltatime);
		if ( bBurst )    //don't run!!!!
			GoTo JL330;

//	if (isinstate('clientaltfiring'))
//	{ verify we want to do this.......
		PlayerViewOffset.X = WeaponPos.X + FRand()*ChargeSize*7;            //allow offsets to change....
		PlayerViewOffset.Y = WeaponPos.Y + FRand()*ChargeSize*7;
		PlayerViewOffset.Z = WeaponPos.Z + FRand()*ChargeSize*7;
		ChargeSize += DeltaTime;
		if ( !bCanClientFire || (Pawn(Owner) == None) )
			GotoState('');
		else if ( Pawn(Owner).bAltFire == 0 || Ammotype.ammoamount<=0 || chargesize >=(2.0 + 0.6 * PowerLevel))
		{
			PlayShootLoad();
			bBurst=true;
			PlayerviewOffset=weaponpos;
		}
//  }
JL330:
	}
	simulated function AnimEnd()      //when shootload is done......
	{
		if ( bBurst )
		{
			bBurst = false;
			chargesize=0.0;
			if ( (Pawn(Owner) == None) || ((AmmoType != None) && (AmmoType.AmmoAmount <= 0)) )
			{
				PlayIdleAnim();
				GotoState('');
			}
			else if ( !bCanClientFire )
				GotoState('');
			else if ( Pawn(Owner).bFire != 0 )
				Global.ClientFire(0);
			else if ( Pawn(Owner).bAltFire != 0 )
				Global.ClientaltFire(0);
			else
			{
				PlayIdleAnim();
				GotoState('');
			}
		}
	}

	simulated function endstate()
	{
		super.endstate();
		//disable('tick');
		PlayerviewOffset=weaponpos;
	}

	simulated function beginstate()
	{
		super.beginstate();
		//enable('tick');
		chargesize=0.0;
		bBurst=false;
		weaponpos=PlayerviewOffset;
	}
JL371:
}

simulated function PlayShootLoad()
{
	if ( PlayerPawn(Owner) != None )
		PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag*ChargeSize, ShakeVert);
	if ( Mesh == PlayerViewMesh )
	{
		if (PowerLevel==0)
			PlayAnim('Shoot1',0.2, 0.05);
		else if (PowerLevel==1)
			PlayAnim('Shoot2',0.2, 0.05);
		else if (PowerLevel==2)
			PlayAnim('Shoot3',0.2, 0.05);
		else if (PowerLevel==3)
			PlayAnim('Shoot4',0.2, 0.05);  
		else if (PowerLevel==4)
			PlayAnim('Shoot5',0.2, 0.05);  
	}
	if ( Owner != None )
	{
		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		PlayOwnedSound(AltFireSound, SLOT_None, 4.0*Pawn(Owner).SoundDampening);
	}
}

state ShootLoad
{
	function Fire(float F)
	{
	}
	function AltFire(float F)
	{
	}

	function BeginState()
	{
		local MHOSDispersionAmmo d;
		local Vector Start, X,Y,Z;
		local float Mult;
    
		if ( Amp != None )
			Mult = FClamp(Amp.Charge/30,2,3);
		else
			Mult = 1.0;
		PlayShootload();
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		Start = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
		AdjustedAim = pawn(owner).AdjustAim(AltProjectileSpeed, Start, AimError, True, True);
		d = MHOSDispersionAmmo(Spawn(AltProjectileClass,,, Start,AdjustedAim));
		if ( d != None )
		{  
			d.bAltFire = True;
			d.DrawScale = 0.6 + ChargeSize*0.6;
			d.InitSplash(d.DrawScale * Mult * 1.3);
		}
	}
Begin:
	FinishAnim();
	Finish();
}
///////////////////////////////////////////////////////////
simulated function PlayIdleAnim()
{
	if (Mesh == PlayerViewMesh)
	{
		if (PowerLevel==0)
			LoopAnim('Idle1',0.04,0.2);
		else if (PowerLevel==1)
			LoopAnim('Idle2',0.04,0.2);
		else if (PowerLevel==2)
			LoopAnim('Idle3',0.04,0.2);
		else if (PowerLevel==3)
			LoopAnim('Idle4',0.04,0.2);
		else if (PowerLevel==4)
			LoopAnim('Idle5',0.04,0.2);
	}
}

simulated function PlayPowerup()
{
	if ( PowerLevel < 5 )
	{
		if ( PowerLevel==1 )
		{
			if ( Owner != None )
				PlayOwnedSound(PowerUpSounds[0], SLOT_None, 5.0*Pawn(Owner).SoundDampening);
			if ( Mesh == PlayerViewMesh )
				PlayAnim('PowerUp1',0.1, 0.05);
		}
		else if (PowerLevel==2)
		{
			if (Owner != None)
				PlayOwnedSound(PowerUpSounds[1], SLOT_None, 5.0*Pawn(Owner).SoundDampening);
			if ( Mesh == PlayerViewMesh )
				PlayAnim('PowerUp2',0.1, 0.05);
		}
		else if (PowerLevel==3)
		{
			if (Owner != None)
				PlayOwnedSound(PowerUpSounds[2], SLOT_None, 5.0*Pawn(Owner).SoundDampening);
			if ( Mesh == PlayerViewMesh )
				PlayAnim('PowerUp3',0.1, 0.05);
		}
		else if (PowerLevel==4)
		{
			if (Owner != None)
				PlayOwnedSound(PowerUpSounds[3], SLOT_None, 5.0*Pawn(Owner).SoundDampening);
			if ( Mesh == PlayerViewMesh )
				PlayAnim('PowerUp4',0.1, 0.05);
		}
	}
}
///////////////////////////////////////////////////////
simulated state ClientPowerUp //client-side anims.....
{
	simulated function bool ClientFire(float Value)
	{
		bForceFire = bForceFire || ( bCanClientFire && (Pawn(Owner) != None) && (AmmoType.AmmoAmount > 0) );
		return bForceFire;
	}
	simulated function bool ClientAltFire(float Value)
	{
		bForceAltFire = bForceAltFire || ( bCanClientFire && (Pawn(Owner) != None) && (AmmoType.AmmoAmount > 0) );
		return bForceAltFire;
	}
	simulated function AnimEnd()
	{
		if ( bCanClientFire && (PlayerPawn(Owner) != None) && (AmmoType.AmmoAmount > 0) )
		{
			if ( bForceFire || (Pawn(Owner).bFire != 0) )
			{
				Global.ClientFire(0);
				GoTo JL515;
			}
			else if ( bForceAltFire || (Pawn(Owner).bAltFire != 0) )
			{
			Global.ClientAltFire(0);
			GoTo JL515;
			}
		}
		GotoState('');
		Global.AnimEnd();
JL515:
	}

	simulated function EndState()
	{
		bForceFire = false;
		bForceAltFire = false;
    }

	simulated function Start()
	{
//		PlayOwnedSound(PowerUpSound, SLOT_None, 2.0*Pawn(Owner).SoundDampening);
		PlayPowerUp();
		Enable('tick');
		bForceFire = false;
		bForceAltFire = false;
	}
	Begin:
	Start();
}

state PowerUp
{
ignores fire, altfire/*, clientfire, clientaltfire*/;

	function BringUp()
	{
		bWeaponUp = false;
		PlaySelect();
		GotoState('PowerUp', 'Raising');
	}

	function bool PutDown()
	{
		bChangeWeapon = true;
		return True;
	}

	function BeginState()
	{
		bChangeWeapon = false;
	}

Raising:
	FinishAnim();
	PowerLevel++;
	if ( (Level.NetMode != NM_Standalone) && Owner.IsA('PlayerPawn')
     && (ViewPort(PlayerPawn(Owner).Player) == None) )
		DoPowerUp(powerlevel);

Begin:
	if (PowerLevel<5)
	{
		AmmoType.MaxAmmo += 10;  
		AmmoType.AddAmmo(10);
		PlayPowerUp();
		bcanclientfire=true;
		FinishAnim();
		if ( bChangeWeapon )
			GotoState('DownWeapon');
		else
			Finish();
	}
Waiting:
}

simulated function TweenDown()
{
	if ( GetAnimGroup(AnimSequence) == 'Select' )
		TweenAnim( AnimSequence, AnimFrame * 0.4 );
	else
	{
		if (PowerLevel==0)
			PlayAnim('Down1', 1.0, 0.05);
		else if (PowerLevel==1)
			PlayAnim('Down2', 1.0, 0.05);
		else if (PowerLevel==2)
			PlayAnim('Down3', 1.0, 0.05);
		else if (PowerLevel==3)
			PlayAnim('Down4', 1.0, 0.05);  
		else if (PowerLevel==4)
			PlayAnim('Down5', 1.0, 0.05);  
	}
}

simulated function TweenSelect()
{
	if ( Mesh == PlayerViewMesh )
		TweenAnim('Select1',0.001);
}

simulated function PlaySelect()
{
	if ( Level.Netmode != NM_StandAlone )
		Enable('tick');
	if ( Owner != None )
		PlayOwnedSound(SelectSound, SLOT_None, Pawn(Owner).SoundDampening);
	//tourney:
	bForceFire = false;
	bForceAltFire = false;
	bCanClientFire = false;
	if ( Mesh == PlayerViewMesh )
	{
		if ( !IsAnimating() || bool(string(AnimSequence) != "Select"$string(powerlevel+1)) )
		{
			if (PowerLevel==0)
				PlayAnim('Select1',0.5,0.0);
			else if (PowerLevel==1)
				PlayAnim('Select2',0.5,0.0);
			else if (PowerLevel==2)
				PlayAnim('Select3',0.5,0.0);
			else if (PowerLevel==3)
				PlayAnim('Select4',0.5,0.0);
			else if (PowerLevel==4)
				PlayAnim('Select5',0.5,0.0);
		}
	}
}

simulated function TweenToStill()     //handle powerlevels
{
	if ( Mesh == PlayerViewMesh )
	{
		if (PowerLevel==0)
			TweenAnim('Idle1',0.1);
		else if (PowerLevel==1)
			TweenAnim('Idle2',0.1);
		else if (PowerLevel==2)
			TweenAnim('Idle3',0.1);
		else if (PowerLevel==3)
			TweenAnim('Idle4',0.1);
		else if (PowerLevel==4)
			TweenAnim('Idle5',0.1);
	}
}

defaultproperties
{
     WeaponDescription="Classification: Energy Pistol"
     AmmoName=Class'UnrealShare.DefaultAmmo'
     PickupAmmoCount=50
     bAltWarnTarget=True
     bSpecialIcon=False
     FireOffset=(X=12.000000,Y=-8.000000,Z=-15.000000)
     ProjectileClass=Class'MH_A_V2.MHOSDispersionAmmo'
     AltProjectileClass=Class'MH_A_V2.MHOSDispersionAmmo'
     shakemag=200.000000
     shaketime=0.130000
     shakevert=2.000000
     RefireRate=0.850000
     AltRefireRate=0.300000
     AIRating=0.1
     FireSound=Sound'UnrealShare.Dispersion.DispShot'
     AltFireSound=Sound'UnrealShare.Dispersion.DispShot'
     SelectSound=Sound'UnrealShare.Dispersion.DispPickup'
     Misc1Sound=Sound'UnrealShare.Dispersion.PowerUp3'
     PowerUpSounds(0)=Sound'UnrealShare.Dispersion.number1'
     PowerUpSounds(1)=Sound'UnrealShare.Dispersion.number2'
     PowerUpSounds(2)=Sound'UnrealShare.Dispersion.number3'
     PowerUpSounds(3)=Sound'UnrealShare.Dispersion.number4'
     DeathMessage="%o was killed by %k's %w. What a loser!"
     PickupMessage="You got the Dispersion Pistol."
     ItemName="Dispersion Pistol"
     PlayerViewOffset=(X=3.800000,Y=-2.000000,Z=-2.000000)
     PlayerViewMesh=LodMesh'UnrealShare.DPistol'
     PickupViewMesh=LodMesh'UnrealShare.DPistolPick'
     ThirdPersonMesh=LodMesh'UnrealShare.DPistol3rd'
     StatusIcon=Texture'MH_A_V2.Icons.UseDPistol'
     PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
     Texture=None
     Mesh=LodMesh'UnrealShare.DPistolPick'
     bNoSmooth=False
     CollisionRadius=28.000000
     CollisionHeight=8.000000
     Mass=15.000000
}
