class MHRingExplosion2 expands RingExplosion2;

var bool bExtraEffectsSpawned;

simulated function PostBeginPlay()
{
	if ( Level.NetMode != NM_DedicatedServer )
	{
		PlayAnim( 'Explosion', 0.2 );
		SpawnEffects();
		PlaySound(ExploSound,,25.0,,1500,0.6);
//		log (Self$" Explosion 2...");
	}
	if ( Instigator != None )
		MakeNoise(0.5);
}

simulated function Tick( float DeltaTime )
{
	if ( Level.NetMode != NM_DedicatedServer )
	{
		ScaleGlow = (Lifespan/Default.Lifespan);
		AmbientGlow = ScaleGlow * 255;
	}
	if ( !bExtraEffectsSpawned )
	{
		if ( Level.NetMode != NM_DedicatedServer )
			SpawnExtraEffects();
		bExtraEffectsSpawned = True;
	}
}

simulated function SpawnEffects()
{
	local Actor a;

	a = Spawn(class'PurpleLight');
	if (a != None)
		a.RemoteRole = ROLE_None;
	a = Spawn(class'EnergyBurst');
	if (a != None)
	{
		a.DrawScale = 3.5;
		a.RemoteRole = ROLE_None;
	}
	a = Spawn(class'ParticleBurst');
	if (a != None)
		a.RemoteRole = ROLE_None;
//	Spawn(class'BigEnergyImpact',,,,rot(16384,0,0));
}

simulated function SpawnExtraEffects()
{
	Spawn(class'BigEnergyImpact',,,,rot(16384,0,0));
}

defaultproperties
{
}