class MHRingExplosion3 expands RingExplosion3;

var bool bExtraEffectsSpawned;

simulated function Tick( float DeltaTime )
{
	if ( Level.NetMode != NM_DedicatedServer )
	{
		ScaleGlow = (Lifespan/Default.Lifespan);
		AmbientGlow = ScaleGlow * 255;
//		if ( !bExtraEffectsSpawned )
//			SpawnExtraEffects();
	}
	if ( !bExtraEffectsSpawned )
	{
		if ( Level.NetMode != NM_DedicatedServer )
			SpawnExtraEffects();
		bExtraEffectsSpawned = True;
	}
}

simulated function PostBeginPlay()
{
	if ( Level.NetMode != NM_DedicatedServer )
	{
		PlayAnim( 'Explosion', 0.15 );
		SpawnEffects();
//		log (Self$" Explosion 3...");
	}
	if ( Instigator != None )
		MakeNoise(0.5);
}

simulated function SpawnEffects()
{
	local actor a;

	a = Spawn(class'EffectLight');
	if (a != None)
		a.RemoteRole = ROLE_None;
	a = Spawn(class'ParticleBurst2');
	if (a != None)
		a.RemoteRole = ROLE_None;
}

simulated function SpawnExtraEffects()
{
	Spawn(class'BotPack.EnergyImpact');
}

defaultproperties
{
}