//=============================================================================
//
//=============================================================================
class SongKeeper expands MusicEvent;
var Actor Tmuz;

// When triggered.
function Trigger( actor Other, pawn EventInstigator )
{
	local PlayerPawn P;
	local Pawn A;
	local TimedBoy Tb;
	local string MZ;

	foreach AllActors ( class 'TimedBoy',Tb )
	{
		if ( Tb != None )
		{
			Tmuz = Tb;
			log (self$" has assigned Parent "$Tmuz);
			break;
		}
	}
	if ( Tmuz == None )
	{
		log (Self$" doesn't include Parent TimedBoy. Won't trigger...");
		GoTo JL67;
	}
	if( bAffectAllPlayers )
	{
		A = Level.PawnList;
		While ( A != None )
		{
			if ( PlayerPawn(A) != None )
				PlayerPawn(A).ClientSetMusic( Song, SongSection, CdTrack, Transition );
			A = A.nextPawn;
		}
//		MZ = Self.GetPropertyText("Song");
		if ( Tmuz != None )
		{
			TimedBoy(Tmuz).NewSong = Song;
		}
		log (Self$" - TimedBoy is now with song "$TimedBoy(Tmuz).NewSong);
/*
		Tmuz.SetPropertyText("SongSection",Self.GetPropertyText("SongSection"));
		log (Self$" - TimedBoy is now with song section "$Li.SongSection);
		Tmuz.SetPropertyText("CdTrack",Self.GetPropertyText("CdTrack"));
		log (Self$" - TimedBoy is now with CdTrack "$Li.CdTrack);
*/
	}
	else
	{
		// Only affect the one player.
		P = PlayerPawn(EventInstigator);
		if( P==None )
			GoTo JL67;
		// Go to music.
		P.ClientSetMusic( Song, SongSection, CdTrack, Transition );
	}

	// Turn off if once-only.
	if( bOnceOnly )
	{
		SetCollision(false,false,false);
		disable( 'Trigger' );
	}
JL67:
}

defaultproperties
{
   CdTrack=255
   Transition=MTRAN_Fade
   bAffectAllPlayers=True
}
