class UTES_HMut expands Mutator;

var PlayerPawn PlayerOwner;
var UTES_CInfo RI;

//XC_GameEngine interface
//native(1718) final function bool AddToPackageMap( optional string PkgName);
/*
	Already package-d by Mod itself native added as package
*/
/*
event PostBeginPlay()
{
	if ( int(ConsoleCommand("get ini:Engine.Engine.GameEngine XC_Version")) >= 11 )
		AddToPackageMap();
}
*/
simulated function Tick(float DeltaTime)
{
//	Super.Tick(DeltaTime);

	if (!bHUDMutator && Level.NetMode != NM_DedicatedServer )
		RegisterHUDMutator();
}

simulated event PostNetBeginPlay()
{
	if(ROLE < ROLE_Authority)
		log("UTES: HUD PostNetBeginPlay()");
}

simulated function PostRender(Canvas C)
{
	local Info temp;

	PlayerOwner = C.Viewport.Actor;

	if(PlayerOwner!=None && PlayerOwner.PlayerReplicationInfo != None)
	{
		/* Check for valid player */
		if(PlayerOwner.PlayerReplicationInfo.bIsSpectator || PlayerOwner.PlayerReplicationInfo.bWaitingPlayer)
		{
			if(NextHUDMutator!=None)
				NextHUDMutator.PostRender(C);

			return;
		}
	}

	/* Bind PlayerReplicationInfo */
	if(RI == None && PlayerOwner!=None)
	{
		foreach AllActors(class'Info', temp)
		{
			if(temp.Owner == PlayerOwner)
			{
				if(temp.IsA('UTES_CInfo'))
				RI=UTES_CInfo(temp);
			}
		}
	}
}

simulated function Destroyed()
{
	local Mutator M;
	local HUD H;

	if ( Level.Game != None )
	{
		if ( Level.Game.BaseMutator == Self )
			Level.Game.BaseMutator = NextMutator;
	}

	foreach AllActors(Class'Engine.HUD', H)
		if ( H.HUDMutator == Self )
			H.HUDMutator = NextHUDMutator;

	foreach AllActors(Class'Engine.Mutator', M)
	{
		if ( M.NextMutator == Self )
			M.NextMutator = NextMutator;

		if ( M.NextHUDMutator == Self )
			M.NextHUDMutator = NextHUDMutator;
	}
}

defaultproperties
{
     bAlwaysRelevant=True
     bAlwaysTick=True
     RemoteRole=ROLE_SimulatedProxy
}
