//=============================================================================
// Bot_VerticalJumper.
// Modification brought to UT by Nelsona
// Reasons:
// I could see at Enforcer spot Bot skating... Because of Touch troubles ?
// Boosting Bot making it to fall was solving problem
// Okay I'm gonna make Bot to jump a bit in purpose to Re-Touch item
// This is small after all
//=============================================================================
class VJumper expands Triggers;

var() class<Pawn> LimitedToClass;
var Pawn Pending;
var Vector Direction;
var float Distance;
var() int JumpZ;

function Timer()
{
	if ( Bot(Pending) != None && Bot(Pending).Health >= 1 && Bot(Pending).MoveTarget != None )
	{
		Pending.SetPhysics(PHYS_Falling);
		Distance = VSize(Pending.MoveTarget.Location-Pending.Location);
		Direction = (Pending.MoveTarget.Location-Pending.Location)/Distance;
		Pending.Velocity = Pending.GroundSpeed * Direction;
		if ( JumpZ != 0 )
			Pending.Velocity.Z = JumpZ;
		else
			Pending.Velocity.Z = FMax(200, Pending.JumpZ);
		Pending.Acceleration = Direction * Pending.AccelRate;
		Pending.bJumpOffPawn = True;
		if ( Bot(Pending) != None )
			Bot(Pending).SetFall();
	}
}

function Touch( actor Other )
{
	if ( ((Bot(Other) != None) || ( Other.Class == LimitedToClass )) && !Other.bHidden )
	{
		Pending = Pawn(Other);
		if ( VSize(Pending.Velocity) < 5 )
			SetTimer(0.4, false);
	}
}

function Trigger( actor Other, pawn EventInstigator )
{
}

defaultproperties
{
   JumpZ=80
   CollisionHeight=10
   CollisionRadius=10
   RemoteRole=ROLE_None
}
