//=============================================================================
// mhsearchlight.
//=============================================================================
class mhsearchlight expands mhflashlight;

event float BotDesireability( pawn Bot )
{
	local inventory Inv;

	for ( Inv=Bot.inventory; Inv!=None; Inv=Inv.inventory )

		if ( Inv.IsA('mhsearchlight') || Inv.IsA('SearchLight') )
			return -2; //LOL

	return Super.BotDesireability(Bot);
}

function bool HandlePickupQuery( inventory Item )
{
	local Inventory S;

	if ( item.class == class ) 
	{
		S = Pawn(Owner).FindInventoryType(class'mhsearchlight');
		if (  S != None )
		{
			if ( Charge > S.Charge/3)
				return True;
			else
				Charge = S.Charge;
		}
/*		else
			Charge = Clamp(S.Default.Charge - S.Charge, Charge, Item.Charge );
*/
		if (Level.Game.LocalLog != None)
			Level.Game.LocalLog.LogPickup(Item, Pawn(Owner));
		if (Level.Game.WorldLog != None)
			Level.Game.WorldLog.LogPickup(Item, Pawn(Owner));
		if ( PickupMessageClass == None )
			Pawn(Owner).ClientMessage(PickupMessage, 'Pickup');
		else
			Pawn(Owner).ReceiveLocalizedMessage( PickupMessageClass, 0, None, None, Self.Class );
		Item.PlaySound (PickupSound,,2.0);
		Item.SetReSpawn();
		return true;
	}
	if ( Inventory == None )
		return false;

	return Inventory.HandlePickupQuery(Item);
}


defaultproperties
{
     ExpireMessage="SearchLight batteries have died."
     PickupMessage="You picked up the SearchLight."
     ItemName="SearchLight"
     PickupViewMesh=LodMesh'UnrealI.BigFlash'
     RespawnTime=10.000000
     MaxDesireability=2.000000
     Charge=20000
     Icon=Texture'UnrealI.Icons.I_BigFlash'
     RemoteRole=ROLE_DumbProxy
     Mesh=LodMesh'UnrealI.BigFlash'
     CollisionHeight=12.000000
     LightBrightness=180
     LightHue=167
     LightRadius=13
}
